/**
 * Created by eeee on 16/1/20.
 */
var BasketBallLayer=cc.Layer.extend({
    isTouch:true,
    isTouchLoserMan:false,
    isHitBall:false,
    isGetBall:false,
    isSetBottle:false,
    isSetWater:false,
    isShoot:false,
    isProvocation:false,
    isDiscardedBook:false,
    loserMan:null,
    man:null,
    basketball:null,
    hearts:null,
    laughAudio:null,
    ctor:function(){
        this._super();
        var _this=this;

        //背景
        var bg=createLevelSprite("k_kdlq_bg.png");
        bg.attr({
            x:winCenter().x+1,
            y:winCenter().y-17
        });
        this.addChild(bg);

        //凳子
        var chair=createLevelSprite("k_kdlq_chair.png");
        chair.attr({
            x:winCenter().x-211.5,
            y:winCenter().y+213.5
        });
        this.addChild(chair);

        //球篮
        var ballFrame=createLevelSprite("k_kdlq_basketball_frame.png");
        ballFrame.attr({
            x:winCenter().x+129.5,
            y:winCenter().y+29.5
        });
        this.addChild(ballFrame);


        //观众
        var womanConfig=[
            {x:-248,y:-282},
            {x:-154,y:-322.5},
            {x:-75.7,y:-362.5},
            {x:+13.5,y:-375}
        ];
        for(var i=0;i<womanConfig.length;i++){
            var woman=createLevelSprite("k_kdlq_woman_"+(i+1)+".png");
            woman.attr({
                x:winCenter().x+womanConfig[i].x,
                y:winCenter().y+womanConfig[i].y
            });
            this.addChild(woman);

            woman.runAction(cc.sequence(
                cc.rotateTo(0.3,i%2?-4:4),
                cc.rotateTo(0.3,i%2?4:-4)
            ).repeatForever());
        }

        //爱心
        var heartConfig=[
            {x:-203.5,y:-171,moveX:-162.5,moveY:-136.5},
            {x:-91.5,y:-221.5,moveX:-112,moveY:-197},
            {x:-31,y:-292.5,moveX:-20,moveY:-220.5}
        ];
        this.hearts=[];
        for(var i=0;i<heartConfig.length;i++){
            var heart=createLevelSprite("k_kdlq_heart_"+(i%2==0?1:2)+".png");
            heart.attr({
                scaleX:i==2?-1:1,
                x:winCenter().x+heartConfig[i].x,
                y:winCenter().y+heartConfig[i].y
            });
            this.addChild(heart,2);
            heart.runAction(cc.sequence(
                cc.delayTime(0.3),
                cc.place(winCenter().x+heartConfig[i].moveX,winCenter().y+heartConfig[i].moveY),
                cc.delayTime(0.3),
                cc.place(winCenter().x+heartConfig[i].x,winCenter().y+heartConfig[i].y)
            ).repeatForever());
            this.hearts.push(heart);
        }

        //篮球框
        var ballNet=createLevelSprite("k_kdlq_basketball_net_1.png");
        ballNet.attr({
            x:winCenter().x+202.5,
            y:winCenter().y+177.5
        });
        this.addChild(ballNet);

        //篮球框网
        var ballNet2=createLevelSprite("k_kdlq_basketball_net_2.png");
        ballNet2.attr({
            x:ballNet.x,
            y:ballNet.y
        });
        this.addChild(ballNet2,2);

        //包包
        var bag=createLevelSprite("k_kdlq_bag.png");
        bag.attr({
            x:winCenter().x-250.5,
            y:winCenter().y+89
        });
        this.addChild(bag);
        addTouchCallBack(bag,function(){
            removeListener(bag);

            //瓶子
            _this.bottle=createLevelSprite("k_kdlq_bottle.png");
            _this.bottle.attr({
                x:winCenter().x-245,
                y:winCenter().y+120.5
            });
            _this.addChild(_this.bottle);
            addTouchCallBack(_this.bottle,
                function(){
                    if(_this.isTouch && cc.rectIntersectsRect(_this.bottle.getBoundingBox(),_this.loserMan.getBoundingBox())){
                        removeListener(_this.bottle);
                        _this.bottle.attr({
                            x:winCenter().x+100,
                            y:winCenter().y-115
                        });
                        _this.isSetBottle=true;
                        _this.pourWater();
                    }else{
                        _this.bottle.attr({
                            x:winCenter().x-245,
                            y:winCenter().y+120.5
                        });
                    }
                },true,
                function(touch){
                    var delta=touch.getDelta();
                    _this.bottle.x+=delta.x;
                    _this.bottle.y+=delta.y;
                }
            )
        });

        //史小坑
        this.man=createLevelSprite("k_kdlq_man_standby_1.png");
        this.man.attr({
            x:winCenter().x-228.5,
            y:winCenter().y+256.5
        });
        this.addChild(this.man);
        setAnimation(this.man,0.2,["k_kdlq_man_standby_1.png","k_kdlq_man_standby_2.png"]);

        //被整人
        this.loserMan=createLevelSprite("k_kdlq_loser_shooting_1.png");
        this.loserMan.attr({
            x:winCenter().x+28,
            y:winCenter().y-72
        });
        this.addChild(this.loserMan,1);
        addTouchCallBack(this.loserMan,function(){
            if(!this.isTouch)return;
            removeListener(this.loserMan);
            this.isTouch=false;
            this.isProvocation=true;
        }.bind(this));

        //篮球
        this.basketball=createLevelSprite("k_kdlq_basketball.png");
        this.basketball.attr({
            x:winCenter().x+85.5,
            y:winCenter().y+2.5
        });
        this.addChild(this.basketball,1);

        addTouchCallBack(this.basketball);
        this.basketball.beganCallback=function(){
            if(this.isTouch && this.isShoot && !this.isSetBottle){
                removeListener(this.basketball);
                this.isGetBall=true;
            }
        }.bind(this);

        //投篮动作
        var shootAction=getAnimation(0.15,
            [
                "k_kdlq_loser_shooting_1.png",
                "k_kdlq_loser_shooting_2.png",
                "k_kdlq_loser_shooting_3.png",
                "k_kdlq_loser_shooting_3.png",
                "k_kdlq_loser_shooting_3.png",
                "k_kdlq_loser_shooting_3.png",
                "k_kdlq_loser_shooting_2.png",
                "k_kdlq_loser_shooting_1.png"
            ],false);
        this.loserMan.runAction(cc.sequence(
            cc.delayTime(0.4),
            cc.callFunc(function(){
                playEffect(res_sound.jump_mp3);
            },this),
            shootAction,
            cc.callFunc(function(){
                if(this.isSetWater){
                    this.gameWin();
                }else if( this.isDiscardedBook){
                    this.loserMan.stopAllActions();
                }
            },this),
            cc.delayTime(2.55),
            cc.callFunc(function(){
                if(this.isGetBall){
                    this.loserMan.stopAllActions();
                }
            },this)
        ).repeatForever());

        this.basketball.runAction(cc.sequence(
            cc.delayTime(0.55),
            cc.callFunc(function(){
                playEffect(res_sound.fly_mp3);
            },this),
            cc.spawn(
                cc.jumpBy(1.8,cc.p(99,210),200,1),
                cc.scaleTo(1.8,0.82)
            ),
            cc.spawn(
                cc.moveBy(0.6,cc.p(0,-375)),
                cc.rotateBy(0.6,-180)
            ),
            cc.callFunc(function(){
                this.isShoot=false;
                if(this.isSetWater){
                    removeListener(this.basketball);
                    this.basketball.stopAllActions();
                    this.basketball.runAction(cc.rotateBy(1,360).repeatForever());
                    this.basketball.runAction(cc.sequence(
                        cc.jumpTo(1,cc.p(winCenter().x*2+100,this.basketball.y-70),90,2),
                        cc.removeSelf()
                    ));
                }else if(this.isGetBall){
                    this.manGetBall();
                }
            },this),
            cc.spawn(
                cc.jumpBy(0.6,cc.p(-60,-20),200,1),
                cc.scaleTo(0.6,0.9),
                cc.rotateBy(0.6,-70)
            ),
            cc.spawn(
                cc.jumpTo(0.6,cc.p(winCenter().x+85.5,winCenter().y+2.5),105,1),
                cc.scaleTo(0.6,1),
                cc.rotateBy(0.6,-80)
            )
        ).repeatForever());

        //跳跃回调
        this.runAction(cc.sequence(
            cc.delayTime(0.05),
            cc.callFunc(function(){
                if(this.isProvocation)
                    this.discardedBook();
            },this),
            cc.delayTime(0.5),
            cc.callFunc(function(){
                if(this.isSetBottle){
                    this.isSetBottle=false;
                    this.isSetWater=true;
                    this.stopAllActions();
                }else{
                    this.isShoot=true;
                }
            },this),
            cc.delayTime(3.6)
        ).repeatForever());
    },
    pourWater:function(){
        this.isTouch=false;
        var bottleAction=getAnimation(0.2,["k_kdlq_water_1.png","k_kdlq_water_2.png","k_kdlq_water_3.png"]);
        this.bottle.runAction(cc.sequence(
            cc.rotateTo(0.2,-84),
            cc.callFunc(function(){
                this.bottle.attr({
                    rotation:0,
                    x:this.bottle.x-67.5,
                    y:this.bottle.y-64
                });
            },this),
            bottleAction
        ));
    },
    discardedBook:function(){
        this.isDiscardedBook=true;
        this.stopAllActions();
        this.runAction(cc.sequence(
            cc.delayTime(0.8),
            cc.callFunc(function(){
                removeListener(this.basketball);
                this.basketball.stopAllActions();
                this.basketball.runAction(cc.sequence(
                    cc.jumpBy(0.7,cc.p(180,-360),0,1),
                    cc.jumpBy(1.5,cc.p(180,-80),35,3)
                ));
            },this)
        ));

        this.man.stopAllActions();
        setAnimation(this.man,0.1,["k_kdlq_man_throw_1.png","k_kdlq_man_throw_2.png","k_kdlq_man_throw_3.png","k_kdlq_man_throw_4.png"],false,function(){
            //书
            var book=createLevelSprite("k_kdlq_book.png");
            book.attr({
                x:winCenter().x-131.5,
                y:winCenter().y+274
            });
            this.addChild(book,3);
            book.runAction(cc.sequence(
                cc.jumpTo(0.3,cc.p(winCenter().x+70.5,winCenter().y+173.5),30,1),
                cc.callFunc(function(){
                    playEffect(res_sound.fly_peng_mp3);
                    //击中
                    var hit=createLevelSprite("k_kdlq_hit.png");
                    hit.attr({
                        x:winCenter().x+91.5,
                        y:winCenter().y+220.5
                    });
                    this.addChild(hit,3);

                    hit.runAction(cc.sequence(
                        cc.delayTime(0.2),
                        cc.removeSelf()
                    ));

                    setAnimation(this.man,0.2,["k_kdlq_man_laugh_1.png","k_kdlq_man_laugh_2.png"]);
                    this.laughAudio=playEffect(res_sound.hahahahaha_mp3);
                },this),
                cc.spawn(
                    cc.jumpBy(0.5,cc.p(130,-395.5),0,1),
                    cc.rotateTo(0.5,90)
                ),
                cc.callFunc(function(){
                    this.loserMan.stopAllActions();
                    setAnimation(this.loserMan,0.2,["k_kdlq_loser_angry_1.png","k_kdlq_loser_angry_2.png","k_kdlq_loser_angry_1.png","k_kdlq_loser_angry_2.png"],false,function(){
                        setAnimation(this.loserMan,0.2,["k_kdlq_loser_walk_1.png","k_kdlq_loser_walk_2.png","k_kdlq_loser_walk_3.png"]);

                        this.loserMan.runAction(cc.sequence(
                            cc.moveTo(1.2,cc.p(winCenter().x-144.5,winCenter().y+225.5)),
                            cc.callFunc(function(){
                                this.loserMan.stopAllActions();
                                stopEffect(this.laughAudio);
                                shotDead(this.man,function(){
                                    this.getParent().gameOver("shotDie");
                                }.bind(this));
                            },this)
                        ));
                    }.bind(this));
                },this)
            ));
        }.bind(this));


    },
    manGetBall:function(){
        if(!this.isTouch)return;
        this.isTouch=false;
        this.stopAllActions();
        this.basketball.stopAllActions();
        this.basketball.setLocalZOrder(0);
        this.basketball.runAction(cc.sequence(
            cc.spawn(
                cc.jumpTo(1.7,cc.p(winCenter().x-220,winCenter().y-53),130,2),
                cc.rotateBy(1.7,-550),
                cc.scaleTo(1.7,1)
            ),
            cc.delayTime(1),
            cc.callFunc(function(){
                this.man.stopAllActions();
                this.man.attr({
                    scale:0.85,
                    x:winCenter().x-172.5,
                    y:winCenter().y+155.5
                });
                setSpriteTxture(this.man,"k_dxj_people_stand.png");

                this.man.runAction(cc.sequence(
                    cc.delayTime(1),
                    cc.spawn(
                        cc.callFunc(function(){
                            playEffect(res_sound.walk_mp3);
                        },this),
                        cc.sequence(
                            cc.rotateBy(0.2,5),
                            cc.rotateBy(0.4,-10),
                            cc.rotateBy(0.2,5)
                        ),
                        cc.moveTo(1,cc.p(winCenter().x-162.5,winCenter().y-17))
                    ),
                    cc.callFunc(function(){
                        this.man.stopAllActions();
                        this.man.scale=1;
                        this.basketball.visible=false;
                        setSpriteTxture(this.man,"k_kdlq_man_play_1.png");
                        this.man.y+=30;
                        setAnimation(this.man,0.2,["k_kdlq_man_play_1.png","k_kdlq_man_play_2.png"]);

                        setAnimation(this.loserMan,0.2,["k_kdlq_loser_daze_1.png","k_kdlq_loser_daze_2.png"]);

                        this.manShootBall();
                    },this)
                ));
            },this)
        ));
    },
    manShootBall:function(){
        this.man.runAction(cc.sequence(
            cc.delayTime(1),
            cc.callFunc(function(){
                this.man.stopAllActions();
                setSpriteTxture(this.man,"k_kdlq_man_play_3.png");
                this.basketball.attr({
                    visible:true,
                    x:winCenter().x-100,
                    y:winCenter().y+85
                });

                this.man.runAction(cc.sequence(
                    cc.delayTime(1),
                    cc.callFunc(function(){
                        setAnimation(this.man,0.2,
                            [
                                "k_kdlq_man_play_4.png",
                                "k_kdlq_man_play_5.png",
                                "k_kdlq_man_play_5.png",
                                "k_kdlq_man_play_5.png",
                                "k_kdlq_man_play_4.png",
                                "k_kdlq_man_play_3.png"
                            ],false,
                            function(){
                                setSpriteTxture(this.man,"k_kdlq_man_embarrassed.png");
                                this.man.scaleX=0.85;
                                this.man.scaleY=0.85;
                            }.bind(this)
                        );

                        playEffect(res_sound.fly_mp3);
                        var basketballBezier=[
                            cc.p(winCenter().x+108,winCenter().y+330.5),
                            cc.p(winCenter().x+150.5,winCenter().y+130),
                            cc.p(winCenter().x+286.5,winCenter().y-174)
                        ];
                        this.basketball.runAction(cc.sequence(
                            cc.spawn(
                                cc.bezierTo(1,basketballBezier),
                                cc.rotateBy(1,360),
                                cc.scaleTo(1,0.82)
                            ),
                            cc.callFunc(function(){
                                playEffect(res_GameSceneBasketBall_sound.boo_mp3);
                            },this),
                            cc.jumpBy(1.5,cc.p(300,-53),100,2),
                            cc.callFunc(function(){
                                this.shameDie();
                            },this)
                        ))
                    },this)
                ));
            },this)
        ));
    },
    shameDie:function(){
        //苹果
        var apple=createLevelSprite("k_kdlq_apple.png");
        apple.attr({
            x:winCenter().x-178.5,
            y:winCenter().y-178.5
        });
        this.addChild(apple,3);
        apple.runAction(cc.sequence(
            cc.spawn(
                cc.scaleTo(0.5,0.28),
                cc.moveTo(0.5,cc.p(winCenter().x-203,winCenter().y-75)),
                cc.rotateTo(0.5,-70)
            ),
            cc.callFunc(function(){
                playEffect(res_sound.theFace_mp3);

                this.man.scaleX=1;
                this.man.scaleY=1;
                setSpriteTxture(this.man,"k_dxj_people_die.png");
                this.man.y-=55;

                //灵魂
                var soul = soulFluttering(this,this.man.x+80,this.man.y+35,50,150,function(){
                    this.getParent().gameOver("shameDie");
                }.bind(this));
                soul.setLocalZOrder(2);
            },this)
        ));

        //香蕉
        var banana=createLevelSprite("k_kdlq_banana.png");
        banana.attr({
            x:winCenter().x-40,
            y:winCenter().y-221
        });
        this.addChild(banana,3);
        banana.runAction(cc.spawn(
            cc.scaleTo(0.6,0.25),
            cc.moveTo(0.6,cc.p(winCenter().x-108,winCenter().y-70)),
            cc.rotateTo(0.6,-50)
        ));
    },
    gameWin:function(){
        this.loserMan.stopAllActions();
        setSpriteTxture(this.loserMan,"k_kdlq_loser_slip_1.png");
        this.loserMan.attr({
            anchorY:0,
            x:this.loserMan.x-12,
            y:this.loserMan.y-40-this.loserMan.height/2
        });
        this.loserMan.runAction(cc.sequence(
            cc.delayTime(0.4),
            cc.spawn(
                cc.rotateTo(0.4,-80),
                cc.moveBy(0.4,cc.p(125,02))
            ),
            cc.callFunc(function(){
                this.loserMan.attr({
                    rotation:0,
                    x:this.loserMan.x-110,
                    y:this.loserMan.y-4.5
                });
                setSpriteTxture(this.loserMan,"k_kdlq_loser_slip_2.png");
                playEffect(res_sound.peng_mp3);

                //灵魂
                var soul = soulFluttering(this,winCenter().x-20.5,winCenter().y-156,50,150,function(){
                    this.getParent().gameWin();
                }.bind(this),2.5);
                soul.setLocalZOrder(2);

                //史小坑大笑
                this.man.stopAllActions();
                setAnimation(this.man,0.2,["k_kdlq_man_laugh_1.png","k_kdlq_man_laugh_2.png"]);
                playEffect(res_sound.hahahahaha_mp3);

                //清除爱心
                for(var i=0;i<this.hearts.length;i++){
                    this.hearts[i].removeFromParent();
                }

                //oh,no!!
                var oh=new cc.LabelTTF("啊!","",30);
                oh.attr({
                    x:winCenter().x-190,
                    y:winCenter().y-170,
                    rotation:18,
                    color:cc.color(50,75,100)
                });
                this.addChild(oh,2);
                oh.runAction(cc.sequence(
                    cc.moveBy(0.3,cc.p(20,-15)),
                    cc.moveBy(0.3,cc.p(-20,15))
                ).repeatForever());

            },this)
        ));
    }
});


var GameSceneBasketBall=GameSceneBase.extend({
    onEnter:function(){
        this._super();
        this._bgFile=getResImg("bg2.png");
        this.layer=new BasketBallLayer();
        this.addChild(this.layer);

        this.stopAllActions();

        this.setMyNameTag(this.layer.man);
        this.setLoserNameTag(this.layer.loserMan);

    }
});