/**
 * Created by eeee on 16/1/19.
 */
var BeatenBossLayer=cc.Layer.extend({
    state:1,
    isTouch:true,
    hitCount:0,
    maxHp:100000,
    blood:null,
    hp:0,
    hpLabel:null,
    boss:null,
    man:null,
    skillBtn1:null,
    skillBtn2:null,
    skillBtn3:null,
    curBtnName:"skillBtn1",
    curSelectSkill:1,
    skillLevel:0,
    box:null,
    isSkillEnd:true,
    table:null,
    ctor:function(){
        this._super();
        var _this=this;

        //线
        var link=createLevelSprite("k_com_line.png");
        link.attr({
            x:winCenter().x,
            y:540
        });
        this.addChild(link);

        //凳子
        var stool=createLevelSprite("k_bdlb_dengzi.png");
        stool.attr({
            x:winCenter().x+10,
            y:winCenter().y+110
        });
        this.addChild(stool);

        //boss
        this.boss=createLevelSprite("k_bdlb_boss1.png");
        this.boss.attr({
            x:winCenter().x+5,
            y:winCenter().y+197.5
        });
        this.addChild(this.boss,1);

        //桌子
        var table=createLevelSprite("k_bdlb_zhuozi.png");
        table.attr({
            x:winCenter().x,
            y:winCenter().y
        });
        this.addChild(table,2);
        this.table=table;

        //boss头像
        var bossIcon=createLevelSprite("k_bdlb_touxiang.png");
        bossIcon.attr({
            x:winCenter().x-228.5,
            y:winCenter().y+393.5
        });
        this.addChild(bossIcon);

        //boss名字
        var bossName=new cc.LabelTTF(_curLoserName,"",22);
        bossName.attr({
            x:winCenter().x-162,
            y:winCenter().y+412,
            color:cc.color(0,0,0),
            anchorX:0
        });
        this.addChild(bossName);

        //血条背景
        var bloodBg=createLevelSprite("k_bdlb_xueliangtiao.png");
        bloodBg.attr({
            anchorX:0,
            x:winCenter().x-43.5-bloodBg.width/2,
            y:winCenter().y+375
        });
        this.addChild(bloodBg);

        //血条遮罩层
        this.blood=createLevelSprite("k_bdlb_xueliang.png");
        this.blood.attr({
            anchorX:0,
            x:winCenter().x-43.5-this.blood.width/2,
            y:winCenter().y+375
        });

        var bloodClippingNode=new cc.ClippingNode(this.blood);
        this.addChild(bloodClippingNode);

        //血条
        var blood=createLevelSprite("k_bdlb_xueliang.png");
        blood.attr({
            anchorX:0,
            x:this.blood.x,
            y:this.blood.y
        });
        bloodClippingNode.addChild(blood);

        //血量
        this.hpLabel=new cc.LabelTTF("HP:"+this.maxHp+"/"+this.maxHp,"",20);
        this.hpLabel.attr({
            anchorX:0,
            x:winCenter().x+100,
            y:winCenter().y+375,
            color:cc.color(144.53,61)
        });
        this.addChild(this.hpLabel);
        this.hp=this.maxHp;

        //史小坑
        this.man=createLevelSprite("k_bdlb_daiji01.png");
        this.man.attr({
            x:winCenter().x,
            y:winCenter().y-214.5,
            anchorY:0
        });
        this.addChild(this.man,3);
        setAnimation(this.man,0.2,["k_bdlb_daiji01.png","k_bdlb_daiji02.png"]);

        //技能背景
        var skillBg=createLevelSprite("k_bdlb_btnbg.png");
        skillBg.attr({
            x:winCenter().x,
            y:winCenter().y-288
        });
        this.addChild(skillBg);

        //技能
        for(var i=0;i<3;i++){
            var skillBtn=createLevelSprite(i==1?"k_bdlb_zhongjian1.png":"k_bdlb_youquantou.png");
            skillBtn.attr({
                x:skillBg.x-175+i*175,
                y:skillBg.y,
                scaleX:i==0?-1:1
            });
            skillBtn.initX=skillBtn.x;
            this.addChild(skillBtn);
            skillBtn.skillTag=(i+1);
            this["skillBtn"+(i+1)]=skillBtn;
        }

        this.selectSkill(1);

        cc.eventManager.addListener({
            event:cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches:true,
            onTouchBegan:function(touch,event){
                var pos=touch.getLocation();
                if(_this.state==1 && _this.isTouch){
                    if(_this.skillLevel<2) {
                        for (var i = 1; i <= 3; i++) {
                            var btn = _this["skillBtn" + i];
                            if (btn && cc.rectContainsPoint(btn.getBoundingBox(), pos)) {
                                if (_this.curSelectSkill != i) {
                                    _this.selectSkill(btn.skillTag);
                                    btn.setLocalZOrder(1);
                                    return true;
                                } else {
                                    _this.useSkill();
                                    return true;
                                }
                            }
                        }
                    }
                    _this.useSkill();
                }
                return false;
            },
            onTouchMoved:function(touch,event){
                var delta=touch.getDelta();
                if(_this.curBtnName=="skillBtn1" || _this.curBtnName=="skillBtn3"){
                    var btn=_this[_this.curBtnName];
                    if(btn){
                        btn.x+=delta.x;
                        if(btn.x<winCenter().x-175){
                            btn.x=winCenter().x-175;
                        }else if(btn.x>winCenter().x+175){
                            btn.x=winCenter().x+175;
                        }
                    }
                }
            },
            onTouchEnded:function(touch,event){
                var btn=_this[_this.curBtnName];
                if(btn && _this.curBtnName!="skillBtn2"){
                    if(cc.rectIntersectsRect(_this.skillBtn2.getBoundingBox(),btn.getBoundingBox())){
                        btn.runAction(cc.sequence(
                            cc.moveTo(0.05,_this.skillBtn2.getPosition()),
                            cc.callFunc(function(){
                                this.skillUpLevel();
                            },_this),
                            cc.removeSelf()
                        ));
                        _this[_this.curBtnName]=null;
                    }else{
                        btn.x=btn.initX;
                        btn.setLocalZOrder(0);
                    }
                }
            }
        },this);

        this.bloodUpdate();

    },
    bloodUpdate:function(){
        var curHp=this.maxHp-this.hitCount*10;
        if(this.hitCount>=this.maxHp/10){
            this.state=0;
            this.isTouch=false;
            this.hitCount=this.maxHp/10;
        }
        this.hpLabel.string="HP:"+curHp+"/"+this.maxHp;
        this.blood.stopAllActions();
        this.blood.runAction(cc.sequence(
            cc.scaleTo(this.hitCount>=this.maxHp/10?2.5:0.2,curHp/this.maxHp,1),
            cc.callFunc(function(){
                if(curHp==0){
                    this.boss.stopAllActions();
                    this.stopAllActions();
                    switch(this.curSelectSkill){
                        case 1:
                            setSpriteTxture(this.boss,"k_bdlb_zuoboss.png");
                            break;
                        case 2:
                            setSpriteTxture(this.boss,"k_bdlb_zhongjianboss.png");
                            break;
                        case 3:
                            setSpriteTxture(this.boss,"k_bdlb_youboss.png");
                            break;
                    }
                    this.runAction(cc.sequence(
                        cc.delayTime(this.curSelectSkill==4?1.5:0.2),
                        cc.callFunc(function(){
                            this.getParent().gameWin();
                        },this)
                    ));
                }else if(this.hitCount>=3 && this.state==1){
                    this.runAction(cc.sequence(
                        cc.delayTime(2),
                        cc.callFunc(function(){
                            if(this.state==1)this.gameOver();
                        },this)
                    ));
                }
            },this)
        ));
    },
    selectSkill:function(skillTag){
        if(this.skillLevel==2){
            this.curSelectSkill=4;
        }else{
            this.curSelectSkill=skillTag;
        }
        this.curBtnName="skillBtn"+skillTag;
        
        var btn=this[this.curBtnName];

        //选框
        if(!this.box){
            this.box=createLevelSprite("k_bdlb_xuanzhong.png");
            this.addChild(this.box);
        }
        this.box.attr({
            x:this.curBtnName=="skillBtn2"?btn.x+6:btn.x+1,
            y:btn.y-1,
            opacity:255
        });
    },
    useSkill:function(){
        this.stopAllActions();
        this.skillAction();
        switch(this.curSelectSkill){
            case 1:
            case 3:
                this.hitCount++;
                break;
            case 2:
                this.hitCount+=1+this.skillLevel;
                break;
            case 4:
                this.hitCount=this.maxHp/10;
                this.runAction(cc.sequence(
                    cc.delayTime(0.5),
                    cc.callFunc(function(){
                        this.bloodUpdate();
                    },this)
                ));
                break;
            default:
                break;
        }
        if(this.curSelectSkill!=4){
            this.bloodUpdate();
        }


    },
    skillAction:function(){
        if(!this.isTouch || !this.isSkillEnd)return;
        this.isSkillEnd=false;
        this.man.stopAllActions();
        switch(this.curSelectSkill){
            case 1:
            case 2:
            case 3:
                var manTexture,
                    manActionFile,
                    bossTexture,
                    manOffsetX=-31,
                    bossOffsetX=20;
                switch(this.curSelectSkill){
                    case 1:
                        manTexture="k_bdlb_zuoquantou01.png";
                        manActionFile=["k_bdlb_zuoquantou01.png","k_bdlb_zuoquantou02.png","k_bdlb_zuoquantou03.png"];
                        bossTexture="k_bdlb_zuoboss2.png";
                        break;
                    case 2:
                        manTexture= "k_bdlb_zhong1.png";
                        manActionFile=["k_bdlb_zhong1.png","k_bdlb_zhong2.png","k_bdlb_zhong2.png"];
                        bossTexture="k_bdlb_zhongboss.png";
                        manOffsetX=5;
                        bossOffsetX=0;
                        break;
                    case 3:
                        manTexture= "k_bdlb_youquantou01.png";
                        manActionFile=["k_bdlb_youquantou01.png","k_bdlb_youquantou02.png","k_bdlb_youquantou03.png"];
                        bossTexture="k_bdlb_youboss2.png";
                        manOffsetX=37.5;
                        bossOffsetX=-10;
                        break;
                    default :
                        break;
                }
                playEffect(res_sound.theFace_mp3);
                setSpriteTxture(this.man,manTexture);
                this.man.x=winCenter().x+manOffsetX;
                this.man.anchorY=0;
                setAnimation(this.man,0.07,manActionFile,false,function(){
                    this.manStandby();
                }.bind(this));

                this.boss.runAction(cc.sequence(
                    cc.delayTime(0.1),
                    cc.callFunc(function(){
                        this.boss.x+=bossOffsetX;
                        setSpriteTxture(this.boss,bossTexture);
                    },this),
                    cc.delayTime(0.14),
                    cc.callFunc(function(){
                        if(this.hitCount<this.maxHp/10){
                            setSpriteTxture(this.boss,"k_bdlb_boss1.png");
                            this.boss.x-=bossOffsetX;
                        }
                    },this)
                ));
                break;
            case 4:
                removeListener(this);

                var manAction=getAnimation(0.1,[
                    "k_bdlb_dazhao_mantiao01.png",
                    "k_bdlb_dazhao_mantiao02.png",
                    "k_bdlb_dazhao_mantiao03.png",
                    "k_bdlb_dazhao_mantiao04.png",
                    "k_bdlb_dazhao_mantiao05.png"
                ]);

                this.man.runAction(cc.sequence(
                    cc.moveTo(0.3,cc.p(winCenter().x+-188.0,winCenter().y+-162.2)),
                    cc.callFunc(function(){
                        var wind=createLevelSprite("k_bdlb_dazhao_xian.png");
                        wind.attr({x:winCenter().x-209.2,y:winCenter().y+3.7});
                        this.addChild(wind,4);
                        wind.runAction(cc.sequence(
                            cc.delayTime(0.1),
                            cc.removeSelf()
                        ));
                    },this),
                    cc.delayTime(0.1),
                    cc.callFunc(function(){
                        setSpriteTxture(this.man,"k_bdlb_dazhao_manda01.png");
                        this.man.setLocalZOrder(1);
                        this.man.attr({x:winCenter().x-112.0,y:winCenter().y-47.6});
                    },this),
                    cc.delayTime(0.1),
                    cc.callFunc(function(){
                        playEffect(res_sound.theFace_mp3);
                        setSpriteTxture(this.man,"k_bdlb_dazhao_manda02.png");
                        setSpriteTxture(this.boss,"k_bdlb_zuoboss2.png");
                        this.boss.x+=16;
                    },this),
                    cc.delayTime(0.1),
                    cc.callFunc(function(){
                        setSpriteTxture(this.man,"k_bdlb_dazhao_manda01.png");
                        this.man.attr({x:winCenter().x+114.6,y:winCenter().y+-47.6,scaleX:-1});
                    },this),
                    cc.delayTime(0.2),
                    cc.callFunc(function(){
                        playEffect(res_sound.theFace_mp3);
                        setSpriteTxture(this.man,"k_bdlb_dazhao_manda02.png");
                        setSpriteTxture(this.boss,"k_bdlb_youboss2.png");
                        this.boss.x-=26;
                    },this),
                    cc.delayTime(0.1),
                    cc.callFunc(function(){
                        setSpriteTxture(this.man,"k_bdlb_daiji01.png");
                        this.man.attr({x:winCenter().x+188.0,y:winCenter().y-162.2});
                        this.man.setLocalZOrder(3);

                        var wind=createLevelSprite("k_bdlb_dazhao_xian.png");
                        wind.attr({x:winCenter().x+209.2,y:winCenter().y+3.7,scaleX:-1});
                        this.addChild(wind,4);
                        wind.runAction(cc.sequence(
                            cc.delayTime(0.1),
                            cc.removeSelf()
                        ));

                    },this),
                    cc.moveTo(0.3,cc.p(winCenter().x,winCenter().y-214.5)),
                    manAction,
                    cc.callFunc(function(){
                        setSpriteTxture(this.boss,"k_bdlb_dazhao_bosskill.png");
                        playEffect(res_sound.theFace_mp3);
                        playEffect(res_sound.boom_mp3);
                        this.boss.y-=200;
                        this.boss.anchorY=0.1;
                        this.boss.runAction(cc.sequence(
                            cc.spawn(
                                cc.rotateTo(0.7,-80),
                                cc.moveBy(0.7,cc.p(0,-25))
                            ),
                            cc.callFunc(function(){
                                //血
                                //var bleeding=createLevelSprite("k_bdlb_xue01.png");
                                //bleeding.attr({
                                //    x:winCenter().x-90,
                                //    y:winCenter().y-111.5
                                //});
                                //this.addChild(bleeding);
                                //setAnimation(bleeding,0.25,["k_bdlb_xue01.png","k_bdlb_xue02.png","k_bdlb_xue03.png"],false)
                            },this)
                        ));

                        setSpriteTxture(this.table,"k_bdlb_dazhao_lanzhuozi.png");

                        //爆炸光
                        var boomLight=createLevelSprite("k_bdlb_dazhao_guang01.png");
                        boomLight.attr({x:winCenter().x+-5.0,y:winCenter().y+42.3});
                        this.addChild(boomLight,1);
                        boomLight.runAction(cc.sequence(
                            cc.spawn(
                                cc.fadeOut(1.5),
                                cc.scaleTo(1,1.5)
                            ),
                            cc.removeSelf()
                        ));

                    },this),
                    cc.delayTime(0.1),
                    cc.callFunc(function(){
                        setSpriteTxture(this.man,"k_bdlb_dazhao_mantiao01.png");
                        setAnimation(this.man,0.2,["k_bdlb_daiji01.png","k_bdlb_daiji02.png"]);
                    },this)
                ));
                break;
            default:
                break;
        }
    },
    manStandby:function(){
        this.man.stopAllActions();
        this.isSkillEnd=true;
        setSpriteTxture(this.man,"k_bdlb_daiji01.png");
        this.man.x=winCenter().x;
        this.man.anchorY=0;
        setAnimation(this.man,0.2,["k_bdlb_daiji01.png","k_bdlb_daiji02.png"]);
    },
    skillUpLevel:function(){
        this.skillLevel++;
        if(this.skillLevel==2){
            setSpriteTxture(this.skillBtn2,"k_bdlb_zhongjian3.png");

            //红光
            var redLight=createLevelSprite("k_bdlb_zhongjianguang.png");
            redLight.attr({
                x:this.skillBtn2.width/2,
                y:this.skillBtn2.height/2
            });
            this.skillBtn2.addChild(redLight,-1);
            redLight.runAction(cc.sequence(
                cc.fadeTo(0.4,120),
                cc.fadeTo(0.4,255)
            ).repeatForever());
        }else if(this.skillLevel==1){
            setSpriteTxture(this.skillBtn2,"k_bdlb_zhongjian2.png");
        }
        this.skillBtn2.runAction(cc.sequence(
            cc.delayTime(0.01),
            cc.callFunc(function(){
                this.selectSkill(2);
            },this)
        ));
    },
    gameOver:function(){
        this.isTouch=false;

        var hand=createLevelSprite("k_com_bighand1.png");
        hand.attr({
            x:winCenter().x+110,
            y:winCenter().y+102.5
        });
        this.addChild(hand,3);

        this.man.anchorY=0.5;
        shotDead(this.man,function(){
            this.getParent().gameOver();
        }.bind(this));
    }

});

var GameSceneBeatenBoss=GameSceneBase.extend({
    ctor:function(){
        this._super();
        this.layer=new BeatenBossLayer();
        this.addChild(this.layer);
        //this.setMyNameTag(this.layer.man);
        this.setLoserNameTag(this.layer.boss);
    },
    pauseTheGame:function(){
        if(this.layer.blood)this.layer.blood.pause();
    },
    resumeTheGame:function(){
        if(this.layer.blood)this.layer.blood.resume();
    }
});