/**
 * Created by eeee on 16/1/31.
 */
var BlowGoldLayer=cc.Layer.extend({
    isTouch:true,
    referee:null,
    dialog:null,
    nail:null,
    man:null,
    loserMan:null,
    downTimeLabel:null,
    downTime:10,
    blueBallList:null,
    redBallList:null,
    ctor:function(){
        this._super();
        this.blueBallList=[];
        this.redBallList=[];

        var that=this;

        //观众
        var people=createLevelSprite("k_csds_people.png");
        people.attr({
            anchorY:0,
            x:winCenter().x,
            y:0
        });
        this.addChild(people);

        //线
        var line=createLevelSprite("k_csds_line.png");
        line.attr({x:winCenter().x,y:winCenter().y+135.6});
        this.addChild(line);

        //横幅
        var banner=createLevelSprite("k_csds_banner.png");
        banner.attr({x:winCenter().x+8.7,y:winCenter().y+243.9});
        this.addChild(banner);

        //钉子
        for(var i=0;i<4;i++) {
            var row=Math.floor(i/2);

            var nail = createLevelSprite("k_csds_nail_1.png");
            nail.attr({
                x: winCenter().x + -227.7+(i%2)*465,
                y: winCenter().y + 335.9+row*92+(i==3?6:0)
            });
            nail.initPos=nail.getPosition();
            this.addChild(nail, 2);

            nail.callback = function () {
                if (!that.isTouch)return;
                setSpriteTxture(this, "k_csds_nail_2.png");
                this.beganCallback = function () {
                    if (!that.isTouch)return false;
                    setSpriteTxture(this, "k_csds_nail_3.png");
                    return true;
                }.bind(this);

                this.moveCallback = function (touch) {
                    var delta = touch.getDelta();
                    this.x += delta.x;
                    this.y += delta.y;
                }.bind(this);

                this.callback = function () {
                    var rect = cc.rect(winCenter().x - 187, winCenter().y - 43, 62, 86);
                    if (that.isTouch && cc.rectIntersectsRect(rect, this.getBoundingBox())) {
                        that.bombLoserManBall(this);
                    } else {
                        setSpriteTxture(this, "k_csds_nail_2.png");
                        this.setPosition(this.initPos);
                    }
                }.bind(this);
            }.bind(nail);
            this.addTouchRectDouble(nail);
        }


        //裁判
        this.referee=createLevelSprite("k_csds_referee_1.png");
        this.referee.attr({x:winCenter().x+191.6,y:winCenter().y+-26.1});
        this.addChild(this.referee);

        //对话框
        this.dialog=createLevelSprite("huakuang.png");
        this.dialog.attr({scale:0.45,x:winCenter().x+210.3,y:winCenter().y+204.1});
        this.addChild(this.dialog);

        //倒计时文本
        this.downTimeLabel=new cc.LabelTTF(this.downTime+"s","",100);
        this.downTimeLabel.attr({
            x:this.dialog.width/2,
            y:this.dialog.height/2+15,
            color:cc.color(68,32,11)
        });
        this.dialog.addChild(this.downTimeLabel);

        //史小坑
        this.man=createLevelSprite("k_csds_man_1.png",0.2,["k_csds_man_2.png","k_csds_man_1.png"]);
        this.man.attr({x:winCenter().x+19.9,y:winCenter().y+14.9});
        this.addChild(this.man);
        this.man.blowBallAction=cc.sequence(
            cc.delayTime(2.5),
            cc.callFunc(this.addRedBall,this)
        ).repeat(4);
        this.man.runAction(this.man.blowBallAction);

        //被整人
        this.loserMan=createLevelSprite("k_csds_loser_1.png",0.2,["k_csds_loser_2.png","k_csds_loser_1.png"]);
        this.loserMan.attr({x:winCenter().x+-158.0,y:winCenter().y+2.5});
        this.addChild(this.loserMan);
        addTouchCallBack(this.loserMan,function(){
            if(!this.isTouch)return;
            this.ballHit();
        }.bind(this));
        this.loserMan.beganCallback=function(touch){
            var rect=cc.rect(winCenter().x-187,winCenter().y-43,62,86);
            if(cc.rectContainsPoint(rect,touch.getLocation())){
                return true;
            }
            return false;
        }.bind(this);
        this.loserMan.runAction(cc.sequence(
            cc.delayTime(2),
            cc.callFunc(this.addBlueBall,this)
        ).repeat(5));

        //倒计时
        this.runAction(cc.sequence(
            cc.sequence(
                cc.delayTime(0.2),
                cc.callFunc(function(){
                    playEffect(res_GameSceneBlowGod_sound.blowing_mp3);
                },this),
                cc.delayTime(0.8),
                cc.callFunc(function(){
                    this.downTime--;
                    if(this.downTime>0){
                        this.downTimeLabel.string=this.downTime+"s";
                    }else if(this.downTime==0){
                        this.downTimeLabel.fontSize=75;
                        this.downTimeLabel.string="时间到!";
                        this.timeTo();
                    }
                },this)
            ).repeat(10),
            cc.delayTime(0.2),
            cc.callFunc(this.timeTo,this)
        ));

    },
    //添加点击
    addTouchRectDouble:function(target,scale){
        scale=scale || 2.5;
        cc.eventManager.addListener({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: true,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                var touchPos = touch.getLocation();
                var s = target.getContentSize();
                var rect=cc.rect(target.x-s.width/2*scale,target.y-s.height/2*scale,s.width*scale,s.height*scale);
                if(cc.rectContainsPoint(rect, touchPos)) {
                    if(target.beganCallback)target.beganCallback();
                    return true;
                }
                return false;
            },
            onTouchMoved:function(touch,event){
                var target = event.getCurrentTarget();
                if(target.moveCallback)target.moveCallback(touch);
            },
            onTouchEnded: function (touch, event) {
                var target = event.getCurrentTarget();
                var touchPos = touch.getLocation();
                var s = target.getContentSize();
                var rect=cc.rect(target.x-s.width/2*scale,target.y-s.height/2*scale,s.width*scale,s.height*scale);
                if(cc.rectContainsPoint(rect, touchPos)) {
                    if(target.callback)target.callback(touch, event);
                }
            }
        }, target);
    },
    addBlueBall:function(){
        var row=Math.ceil((this.blueBallList.length+1)/3)-1;
        var blueBall=createLevelSprite("k_csds_balloon_blue.png");
        blueBall.attr({
            x:winCenter().x-225+51*(this.blueBallList.length%3)+(row==1?23:0),
            y:winCenter().y-181-51*row
        });
        this.addChild(blueBall);
        addTouchCallBack(blueBall,function(){
            if(!this.isTouch)return;
            this.ballBomb();
        }.bind(this));
        this.blueBallList.push(blueBall);

        this.addScore(this.loserMan);
    },
    addRedBall:function(){
        var row=Math.ceil((this.redBallList.length+1)/3)-1;
        var redBall=createLevelSprite("k_csds_balloon_pink.png");
        redBall.attr({
            x:winCenter().x+-16+51*(this.redBallList.length%3)+(row==1?23:0),
            y:winCenter().y+-181-51*row
        });
        this.addChild(redBall);
        this.redBallList.push(redBall);

        this.addScore(this.man);
    },
    addScore:function(target){
        var label=new cc.LabelTTF("+1","",60);
        label.attr({
            x:target.width/2,
            y:target.height,
            color:cc.color(197,94,95)
        });
        target.addChild(label);
        label.runAction(cc.sequence(
            cc.spawn(
                cc.moveBy(0.8,cc.p(0,110)),
                cc.fadeOut(1)
            ),
            cc.removeSelf()
        ));
    },
    ballHit:function(){
        this.isTouch=false;
        this.stopAllActions();
        this.loserMan.stopAllActions();
        this.man.stopAction(this.man.blowBallAction);

        setSpriteTxture(this.loserMan,"k_csds_loser_3.png");

        //飞出去的气球
        var ball=createLevelSprite("k_csds_balloon_fly.png");
        ball.attr({x:winCenter().x+-149.3,y:winCenter().y+-16.2});
        this.addChild(ball);
        ball.runAction(cc.sequence(
            cc.delayTime(0.3),
            cc.callFunc(function(){
                playEffect(res_GameSceneBlowGod_sound.bleed_mp3);
            },this),
            cc.spawn(
                cc.rotateTo(0.7,90),
                cc.moveBy(0.7,cc.p(-winCenter().x+90,-250))
            ),
            cc.place(-120,winCenter().y+150),
            cc.spawn(
                cc.rotateTo(0.01,255),
                cc.moveTo(1.4,cc.p(cc.winSize.width+100,cc.winSize.height-200))
            ),
            cc.delayTime(0.2),
            cc.place(cc.winSize.width+100,winCenter().y-105),
            cc.spawn(
                cc.rotateTo(0.01,135),
                cc.moveTo(0.4,cc.p(winCenter().x+49.6,winCenter().y+15.6))
            ),
            cc.callFunc(function(){
                playEffect(res_sound.theFace_mp3);
                this.man.stopAllActions();
                setSpriteTxture(this.man,"k_csds_man_3.png");
                this.man.runAction(cc.sequence(
                    cc.sequence(
                        cc.rotateTo(0.15,6),
                        cc.rotateTo(0.15,0)
                    ).repeat(3),
                    cc.callFunc(function(){
                        setSpriteTxture(this.man,"k_csds_man_4.png");
                        this.man.anchorY=0.35;
                        this.man.y-=this.man.height*0.15;
                    },this),
                    cc.callFunc(function(){
                        playEffect(res_sound.sinisterSmile_mp3);
                        setSpriteTxture(this.loserMan,"k_csds_loser_6.png");
                        setAnimation(this.loserMan,0.2,["k_csds_loser_7.png","k_csds_loser_6.png"]);

                        var cheer=createLevelSprite("k_csds_cheer.png");
                        cheer.attr({x:winCenter().x,y:winCenter().y-321});
                        this.addChild(cheer);
                        cheer.runAction(cc.blink(2,5));

                        var label=new cc.LabelTTF("哈哈哈哈！！","",70);
                        label.attr({
                            x:winCenter().x,
                            y:260,
                            color:cc.color(197,94,95)
                        });
                        this.addChild(label);
                        label.runAction(cc.sequence(
                            cc.moveBy(0.2,cc.p(15,8)),
                            cc.moveBy(0.2,cc.p(-15,-8))
                        ).repeatForever());
                    },this),
                    cc.rotateTo(0.3,90),
                    cc.callFunc(function(){
                        setSpriteTxture(this.man,"k_dxj_people_die.png");
                        this.man.attr({x:winCenter().x+29.9,y:winCenter().y+-87.8,rotation:0});
                        soulFluttering(this,this.man.x+70,this.man.y+40,100,260,function(){
                            showGameOver("ballHit");
                        });
                    },this)
                ));
            },this),
            cc.removeSelf()
        ));

    },
    ballBomb:function(){
        this.isTouch=false;
        this.stopAllActions();
        this.loserMan.stopAllActions();
        this.man.stopAllActions();

        playEffect(res_GameSceneBlowGod_sound.ballBomb_mp3);
        var boom=createLevelSprite("k_zxx_boom_1.png");
        var boomAction=getAnimation(0.1,["k_zxx_boom_2.png","k_zxx_boom_1.png"]);
        boom.attr({x:winCenter().x+-172.0,y:winCenter().y+-192,scale:0.5});
        this.addChild(boom);
        boom.runAction(cc.sequence(
            boomAction.repeat(2),
            cc.callFunc(function(){
                for(var i=0;i<this.blueBallList.length;i++){
                    this.blueBallList[i].removeFromParent();
                }
                setSpriteTxture(boom,"k_csds_chip.png");
                boom.attr({x:winCenter().x+-160.8,y:winCenter().y+-203.4});

                setSpriteTxture(this.loserMan,"k_csds_loser_3.png");

                //飞出去的气球
                var ball=createLevelSprite("k_csds_balloon_fly.png");
                ball.attr({x:winCenter().x+-149.3,y:winCenter().y+-16.2});
                this.addChild(ball);
                ball.runAction(cc.sequence(
                    cc.delayTime(0.3),
                    cc.callFunc(function(){
                        playEffect(res_GameSceneBlowGod_sound.bleed_mp3);
                    },this),
                    cc.spawn(
                        cc.rotateTo(0.7,90),
                        cc.moveBy(0.7,cc.p(-winCenter().x+90,-250))
                    ),
                    cc.place(-120,winCenter().y+150),
                    cc.spawn(
                        cc.rotateTo(0.01,225),
                        cc.moveTo(1.4,cc.p(cc.winSize.width,cc.winSize.height+60))
                    ),
                    cc.delayTime(1),
                    cc.callFunc(function(){
                        showGameOver("ballBomb");
                    },this)
                ));

            },this),
            cc.delayTime(0.15),
            cc.callFunc(function(){
                playEffect(res_GameSceneBlowGod_sound.timeTo_mp3);

                //作弊
                this.downTimeLabel.string="作弊，out!";
                this.downTimeLabel.fontSize=50;
                setSpriteTxture(this.referee,"k_csds_referee_2.png");

                setSpriteTxture(this.man,"k_dxj_people_cry1.png");
                setAnimation(this.man,0.2,["k_dxj_people_cry2.png","k_dxj_people_cry1.png"]);

                playEffect(res_sound.cry_mp3);
            },this)
        ));

    },
    timeTo:function(){
        playEffect(res_GameSceneBlowGod_sound.timeTo_mp3);
        this.isTouch=false;
        var scoreLabel=new cc.LabelTTF("5 : 4","",80);
        scoreLabel.attr({
            x:winCenter().x,
            y:250,
            color:cc.color(197,94,95)
        });
        this.addChild(scoreLabel);

        playEffect(res_sound.sinisterSmile_mp3);
        setSpriteTxture(this.loserMan,"k_csds_loser_4.png");
        setAnimation(this.loserMan,0.2,["k_csds_loser_5.png","k_csds_loser_4.png"]);

        playEffect(res_sound.cry_mp3);
        setSpriteTxture(this.man,"k_dxj_people_cry1.png");
        setAnimation(this.man,0.2,["k_dxj_people_cry2.png","k_dxj_people_cry1.png"]);

        this.runAction(cc.sequence(
            cc.delayTime(3),
            cc.callFunc(function(){
                showGameOver("timeTo");
            },this)
        ));
    },
    bombLoserManBall:function(nail){
        nail.removeFromParent();
        this.isTouch=false;
        this.stopAllActions();
        this.loserMan.stopAllActions();
        this.man.stopAction(this.man.blowBallAction);

        playEffect(res_GameSceneBlowGod_sound.ballBomb_mp3);
        var boom=createLevelSprite("k_zxx_boom_1.png");
        var boomAction=getAnimation(0.1,["k_zxx_boom_2.png","k_zxx_boom_1.png"]);
        boom.attr({x:winCenter().x-155,y:winCenter().y-10,scale:0.5});
        this.addChild(boom);
        boom.runAction(cc.sequence(
            boomAction.repeat(3),
            cc.callFunc(function(){
                setAnimation(this.loserMan,0.2,["k_csds_loser_8.png","k_csds_loser_9.png","k_csds_loser_10.png"],false,function(){
                    setSpriteTxture(this.man,"k_dxj_people_laugh1.png");
                    setAnimation(this.man,0.2,["k_dxj_people_laugh2.png","k_dxj_people_laugh1.png"]);

                    playEffect(res_sound.laugh_boy_mp3);

                    soulFluttering(this,winCenter().x-145,winCenter().y+6,null,null,function(){
                        showGameWin();
                    });
                }.bind(this));
            },this),
            cc.removeSelf()
        ));

    }
});

var GameSceneBlowGod=GameSceneBase.extend({
    onEnter:function(){
        this._super();
        this.layer=new BlowGoldLayer();
        this.addChild(this.layer);
        this.setMyNameTag(this.layer.man);
        this.setLoserNameTag(this.layer.loserMan);

        this.stopAllActions();
    }
});