/**
 * Created by eeee on 16/1/23.
 */
var DwarfLayer=cc.Layer.extend({
    isTouch:true,
    man:null,
    shengqi:null,
    loserMan:null,
    loserManHead:null,
    loserManHand:null,
    dialog:null,
    laughtAudio:null,
    onEnter:function(){
        this._super();
        //绿色地面
        var ground=new cc.LayerColor(cc.color(186,186,159),cc.winSize.width,352);
        this.parent.addChild(ground,-1);

        this.runAction(cc.sequence(
            cc.delayTime(0.1),
            cc.callFunc(function(){
                ground.height=352*(1+(1-this.scale));
            },this)
        ));
    },
    ctor:function(){
        this._super();
        var _this=this;

        //地面
        // var ground=new cc.LayerColor(cc.color(209,205,178),cc.winSize.width,352);
        // this.addChild(ground);

        //背景
        var bg=createLevelSprite("k_xar_bg.png");
        bg.attr({
            x:winCenter().x,
            y:352,
            anchorY:0
        });
        this.addChild(bg);

        //云
        for(var i=0;i<2;i++){
            var could=createLevelSprite(i==0?"k_dxz_cloud3.png":"k_dxz_cloud1.png");
            could.attr({
                x:winCenter().x+(i==0?-134:174.5),
                y:winCenter().y+(i==0?373:349)
            });
            this.addChild(could);
        }

        //史小坑
        this.man=createLevelSprite("k_xar_man_1.png");
        this.man.attr({
            anchorY:0,
            x:winCenter().x-177,
            y:winCenter().y-368
        });
        this.addChild(this.man);
        setAnimation(this.man,0.2,["k_xar_man_1.png","k_xar_man_2.png"]);

        //生气##
        this.shengqi=createLevelSprite("k_xcw_fuhao.png");
        this.shengqi.attr({
            x:88.5,
            y:307.5
        });
        this.man.addChild(this.shengqi);
        this.shengqi.runAction(cc.sequence(
            cc.delayTime(0.2),
            cc.place(95,317),
            cc.delayTime(0.2),
            cc.place(88.5,307.5)
        ).repeatForever());

        //被整人
        this.loserMan=createLevelSprite("k_xar_tall_1_body.png");
        this.loserMan.attr({
            anchorY:0,
            x:winCenter().x+163,
            y:winCenter().y-374.5
        });
        this.addChild(this.loserMan);
        addTouchCallBack(this.loserMan,function(){
            if(!this.isTouch)return;
            removeListener(this.loserMan);
            this.manChaosFist("touchLoserMan");
        }.bind(this));

        //笑声
        this.runAction(cc.sequence(
            cc.callFunc(function(){
                this.laughtAudio=playEffect(res_sound.hahahahaha_mp3);
            },this),
            cc.delayTime(5)
        ).repeatForever());

        //被整人头
        this.loserManHead=createLevelSprite("k_xar_tall_1_head1.png");
        this.loserManHead.attr({
            x:75,
            y:415
        });
        this.loserMan.addChild(this.loserManHead);
        setAnimation(this.loserManHead,0.2,["k_xar_tall_1_head1.png","k_xar_tall_1_head2.png"]);

        //被整人手
        this.loserManHand=createLevelSprite("k_xar_tall_1_hand1.png");
        this.loserManHand.attr({
            x:-25,
            y:298
        });
        this.loserMan.addChild(this.loserManHand,-1);
        setAnimation(this.loserManHand,0.2,["k_xar_tall_1_hand1.png","k_xar_tall_1_hand2.png"]);

        //对话框
        this.dialog=createLevelSprite("k_jbthy_box_man.png");
        this.dialog.attr({
            anchorY:0,
            anchorX:1,
            x:winCenter().x+80,
            y:winCenter().y+37
        });
        this.addChild(this.dialog);
        this.dialog.runAction(cc.sequence(
            cc.delayTime(0.2),
            cc.place(winCenter().x+80,winCenter().y+27),
            cc.delayTime(0.2),
            cc.place(winCenter().x+80,winCenter().y+37)
        ).repeatForever());

        var dialogLabel=new cc.LabelTTF("你个小矮人！","",33);
        dialogLabel.attr({
            x:this.dialog.width/2+6,
            y:this.dialog.height/2,
            color:cc.color(98,73,69)
        });
        this.dialog.addChild(dialogLabel);

        var beginDistance = 0,
            movedDistance = 0;
        var isTouchMan=false;
        cc.eventManager.addListener({
            event:cc.EventListener.TOUCH_ALL_AT_ONCE,
            onTouchesBegan:function(touches,event){
                var touchPos=touches[0].getLocation();
                var touchPos2=touches[1] ? touches[1].getLocation() : touchPos;
                if(cc.rectContainsPoint(_this.man.getBoundingBox(),touchPos)){
                    beginDistance=endDistance=Math.abs(touchPos.y-touchPos2.y);
                    isTouchMan=true;
                    return true;
                }else{
                    isTouchMan=false;
                }
                return false;
            },
            onTouchesMoved:function(touches,event){
                if(touches.length>1){
                    var touchPos=touches[0].getLocation();
                    var touchPos2=touches[1].getLocation();
                    if(beginDistance==0)
                        beginDistance=Math.abs(touchPos.y-touchPos2.y);

                    movedDistance=Math.abs(touchPos.y-touchPos2.y);
                }
            },
            onTouchesEnded:function(touches,event){
                if(isTouchMan){
                    cc.log(beginDistance+","+movedDistance);

                    if(movedDistance-beginDistance>30){
                        _this.manEnlarge();
                    }else{
                        _this.manChaosFist("touchMan");
                    }
                    removeListener(_this);
                }
            }
        },this);

    },
    manChaosFist:function(faileKey){
        if(!this.isTouch)return;
        this.isTouch=false;

        this.man.runAction(cc.sequence(
            cc.moveBy(1,cc.p(158,0)),
            cc.callFunc(function(){

                this.loserManHand.stopAllActions();
                setSpriteTxture(this.loserManHand,"k_xar_tall_1_hand3.png");
                this.loserManHand.x-=10;
                this.loserManHand.y-=5;

                this.man.stopAllActions();
                playEffect(res_GameSceneDwarf_sound.kyoodle_mp3);
                setAnimation(this.man,0.15,["k_xar_man_3.png","k_xar_man_4.png"]);
                this.man.y+=46.5;

                this.loserMan.runAction(cc.sequence(
                    cc.delayTime(1.35),
                    cc.callFunc(function(){
                        this.loserManFlyKick(faileKey);
                    },this)
                ));
            },this)
        ));
    },
    loserManFlyKick:function(faileKey){
        this.dialog.removeFromParent();
        this.shengqi.removeFromParent();

        this.man.stopAllActions();
        setSpriteTxture(this.man,"k_xar_man_5.png");
        this.man.anchorY=0;
        this.man.x-=30;
        this.man.runAction(cc.sequence(
            cc.callFunc(function(){
                playEffect(res_sound.theFace_mp3);
            },this),
            cc.delayTime(0.15),
            cc.place(winCenter().x-79,this.man.y),
            cc.callFunc(function(){
                playEffect(res_sound.theFace_mp3);
            },this),
            cc.delayTime(0.15),
            cc.place(winCenter().x-49,this.man.y)
        ).repeat(6));

        this.loserManHand.visible=false;
        this.loserManHead.visible=false;
        setSpriteTxture(this.loserMan,"k_xar_tall_2.png");
        this.loserMan.anchorY=0;
        this.loserMan.y+=120;
        var loserManAction=getAnimation(0.15,["k_xar_tall_2.png","k_xar_tall_3.png"]);
        this.loserMan.runAction(cc.sequence(
            loserManAction.repeat(6),
            cc.callFunc(function(){
                setSpriteTxture(this.loserMan,"k_xar_tall_1_body.png");
                this.loserMan.anchorY=0;
                this.loserMan.y-=120;
                this.loserManHand.visible=true;
                setSpriteTxture(this.loserManHand,"k_xar_tall_1_hand1.png");
                this.loserManHand.x+=10;
                this.loserManHand.y+=5;
                this.loserManHead.visible=true;

                playEffect(res_sound.scream_mp3);

                this.man.runAction(cc.sequence(
                    cc.spawn(
                        cc.jumpBy(0.5,cc.p(-35,20),100,1),
                        cc.rotateTo(0.5,-90)
                    ),
                    cc.callFunc(function(){
                        setSpriteTxture(this.man,"k_xar_man_6.png");
                        this.man.x-=100;
                        this.man.rotation=0;

                        //灵魂
                        soulFluttering(this,this.man.x-60,this.man.y+30,100,150,function(){
                            this.getParent().gameOver(faileKey);
                        }.bind(this));
                    },this)
                ))
            },this)
        ));
    },
    manEnlarge:function(){
        if(!this.isTouch)return;
        this.isTouch=false;

        this.dialog.removeFromParent();
        this.shengqi.removeFromParent();

        playEffect(res_sound.angry_mp3);


        this.getParent().setMyNameTag(this.man,null,null,130);
        playEffect(res_sound.change_mp3);
        this.man.stopAllActions();
        this.man.runAction(cc.sequence(
            cc.scaleTo(1,1.6),
            cc.callFunc(function(){
                this.loserManHand.stopAllActions();
                this.loserManHead.stopAllActions();

                this.stopAllActions();
                stopEffect(this.laughtAudio);

                this.man.scale=1;
                setSpriteTxture(this.man,"k_xar_man_7.png");
                this.man.setLocalZOrder(2);
                this.man.x=winCenter().x-79.5;
                this.man.y=winCenter().y+26;
                var manAction=getAnimation(0.15,["k_xar_man_7.png","k_xar_man_8.png"]);
                this.man.runAction(cc.sequence(
                    manAction.repeat(5),
                    cc.callFunc(function(){
                        setSpriteTxture(this.man,"k_xar_man_1.png");
                        this.man.attr({
                            anchorY:0,
                            scale:1.6,
                            x:winCenter().x-177,
                            y:winCenter().y-368
                        });

                        this.loserManHand.removeFromParent();
                        this.loserManHead.removeFromParent();
                        setSpriteTxture(this.loserMan,"k_xar_tall_4.png");
                        this.loserMan.y+=70;

                        //灵魂
                        soulFluttering(this,this.loserMan.x+100,this.loserMan.y+100,30,150,function(){
                            this.getParent().gameWin();
                        }.bind(this));

                    },this)
                ));

                this.loserMan.runAction(cc.sequence(
                    cc.moveBy(0.15,cc.p(40,0)),
                    cc.moveBy(0.15,cc.p(-40,0))
                ).repeat(5));

                //爆炸
                var boom=createLevelSprite("k_zxx_boom_1.png");
                boom.attr({
                    scale:0.5,
                    x:winCenter().x+167.5,
                    y:winCenter().y-33
                });
                this.addChild(boom);
                var boomAction=getAnimation(0.15,["k_zxx_boom_1.png","k_zxx_boom_2.png"]);
                boom.runAction(cc.sequence(
                    boomAction.repeat(5),
                    cc.removeSelf()
                ));

                this.runAction(cc.sequence(
                    cc.callFunc(function(){
                        playEffect(res_sound.theFace_mp3);
                    },this),
                    cc.delayTime(0.15),
                    cc.callFunc(function(){
                        playEffect(res_sound.theFace_mp3);
                    },this),
                    cc.delayTime(0.15)
                ).repeat(6));
            },this)
        ));
    }
});

var GameSceneDwarf=GameSceneBase.extend({
    ctor:function(){
        this._super();
        this._bgFile=getResImg("bg2.png");
        this.layer=new DwarfLayer();
        this.addChild(this.layer);

        this.setMyNameTag(this.layer.man);
        this.setLoserNameTag(this.layer.loserMan,null,0,145);
    },
    resumeTheGame:function(){
        //测试放大
        //this.layer.manEnlarge();
    }
});