/**
 * Created by MingliC on 16/1/19.
 */
var FightChickLayer = cc.Layer.extend({
    sprite: null,
    sprite2: null,
    ctor: function () {
        this._super();
        this.size = cc.director.getWinSize();
        var _this = this;
        var _size = this.size;

        var isNoTouch = false;//禁止操作
        var isClickedShovel = false;//已经点击了铲子
        var isDoorOpen = false;//门是否已打开

        //小石头
        for (var i = 0; i < 5; i++) {
            var rx = Math.random() * 1000 % 150 - 75;
            var ry = Math.random() * 1000 % 150 - 75;
            var stone1 = createLevelSprite("k_dxj_tone1.png");
            stone1.attr({x: winCenter().x - 50 + rx, y: 250 + ry});
            _this.addChild(stone1);
        }

        //铲子
        var shovel = createLevelSprite("k_dxj_chanzi.png");
        shovel.attr({x: winCenter().x + 250, y: winCenter().y + 40, anchorX: 0.95});
        _this.addChild(shovel);
        addTouchCallBack(shovel, function () {//点击受虐者
            action();
        }, true);

        //房子
        var house = createLevelSprite("k_dxj_house.png");
        house.attr({x: winCenter().x, y: winCenter().y + 200});
        _this.addChild(house);

        //烟
        var smoke = createLevelSprite("k_dxj_yan1.png");
        smoke.attr({x: winCenter().x - 125, y: winCenter().y + 445});
        setAnimation(smoke, 0.2, ["k_dxj_yan2.png", "k_dxj_yan1.png"], true);
        _this.addChild(smoke);

        //门
        var door = createLevelSprite("k_dxj_door.png");
        door.attr({x: winCenter().x, y: winCenter().y + 80});
        _this.addChild(door);
        addTouchCallBack(door, function () {//点击受虐者
            openTheDoor();
        }, true);

        //史小坑
        var kengMan = createLevelSprite("k_dxj_people_stand.png");
        kengMan.attr({x: winCenter().x + 208, y: winCenter().y - 240});
        setAnimation(kengMan, 0.4, ["k_dxj_people_stand1.png","k_dxj_people_stand.png"], true);
        _this.addChild(kengMan);
        addTouchCallBack(kengMan, function () {//点击受虐者
            jumpStoneBigAction();
        }, true);
        createNameTagAndUpdate(_this, kengMan, 0, 0, getMyName());

        //受虐者
        var loser = createLevelSprite("k_dxj_ta_stand.png");
        loser.attr({x: winCenter().x - 190, y: winCenter().y - 210});
        _this.addChild(loser);
        addTouchCallBack(loser, function () {//点击受虐者
            jumpStoneBigAction();
        }, true);
        createNameTagAndUpdate(_this, loser, 0, 0);

        //大石头
        var stoneBig = createLevelSprite("k_dxj_tone2.png");
        stoneBig.attr({x: winCenter().x + 15, y: winCenter().y - 245});
        stoneBig.setLocalZOrder(200);
        _this.addChild(stoneBig);
        addTouchCallBack(stoneBig, function () {//点击大石头
            kengManDieAction();
        }, true);

        //大石头
        var stoneBigAction = createLevelSprite("k_dxj_tone2.png");
        stoneBigAction.attr({x: winCenter().x - 211, y: winCenter().y - 240});
        _this.addChild(stoneBigAction);

        //桶
        var barrel = createLevelSprite("k_dxj_ktong.png");
        barrel.attr({x: winCenter().x + 96, y: winCenter().y - 257});
        _this.addChild(barrel);

        //线
        var line = createLevelSprite("k_dxj_jiantou.png");
        line.attr({x: winCenter().x, y: winCenter().y - 146});
        _this.addChild(line);

        //暂停5秒,然后开始播放动作
        var seq = cc.sequence(
            cc.delayTime(5), cc.callFunc(function () {
                jumpStoneBigAction();
            })
        );
        _this.runAction(seq);

        //石头抛出
        var jumpStoneBigAction = function () {

            if (isNoTouch) return;
            isNoTouch = true;

            if (isClickedShovel) {//如果铲子移动过, 则播放打小鸡动画
                fightChick();//打小鸡
            } else {//如果铲子移动过，则直接进入死亡流程
                fightKengMan();//打史小坑
            }
        };

        //抛石头的动作
        function reng() {
            //抛石头的动作
            setAnimation(loser, 0.1, ["k_dxj_ta_reng.png", "k_dxj_ta_reng2.png", "k_dxj_ta_stand.png"], false);
            stoneBigAction.setLocalZOrder(200);
        }

        //石头打到史小坑
        var fightKengMan = function () {

            line.setVisible(false);

            playEffect(res_sound.fly_mp3);

            reng();

            //死亡过程
            stoneBigAction.runAction(
                cc.sequence(
                    //石头运动
                    cc.jumpTo(1.0, cc.p(winCenter().x + 200, winCenter().y - 159), 150, 1),
                    //史小坑死掉，石头消失
                    cc.callFunc(function () {
                        kengMan.stopAllActions();
                        setAnimation(kengMan, 0.01, ["k_dxj_people_die.png"], false, function () {
                            stoneBigAction.setVisible(false);
                            shock(_this, 0.03, 3);
                        });

                        //添加不小心失手的框框
                        loserLaugh();
                        var chart = createLevelSprite("k_dxj_huakuang.png");
                        chart.attr({x: winCenter().x - 26, y: winCenter().y - 133});
                        _this.addChild(chart);

                    }),
                    cc.delayTime(3.0),
                    cc.callFunc(function () {
                        _this.gameOver("lossWord2");//被Loser石头砸死
                    })
                )
            );
        }

        //铲子打小鸡
        var fightChick = function () {

            isNoTouch = true;

            line.setVisible(false);

            reng();

            //打小鸡
            stoneBigAction.runAction(
                cc.sequence(
                    //播放石头运动的声音，咻。。。。
                    cc.callFunc(function () {
                        //需要播放打击的声音
                        _this.runAction(cc.sequence(cc.delayTime(0.3), cc.callFunc(function () {
                            playEffect(res_sound.fly_mp3);
                        })));
                    }),
                    //石头运动

                    cc.jumpTo(1.0, cc.p(winCenter().x + 60, winCenter().y - 300), 250, 1),

                    //砸到铲子，铲子翘起，
                    cc.callFunc(function () {
                        playEffect(res_sound.peng_mp3);
                        shovel.runAction(
                            cc.sequence(
                                cc.rotateBy(0.05, 20),//铲子翘起
                                cc.callFunc(function () {

                                    //播放痛的动画
                                    shock(_this, 0.03, 3);
                                    loser.runAction(cc.moveBy(0.07, cc.p(0, 20)));
                                    setAnimation(loser, 0.5, ["k_dxj_ta_tong.png"], false, function () {
                                        if (isDoorOpen) {//如果门打开，追逐史小坑
                                            loserKeyAndRun();
                                        } else {//打到小鸡鸡，生气杀死史小坑
                                            loserKry();
                                        }
                                    });

                                    //史小坑笑
                                    kengMan.stopAllActions();
                                    setAnimation(kengMan, 0.2, ["k_dxj_people_laugh1.png","k_dxj_people_laugh2.png"]);

                                    //播放奸笑的声音
                                    playEffect(res_sound.laugh_boy_mp3);

                                }),
                                cc.delayTime(0.7),
                                cc.callFunc(function () {
                                    //播放好痛的声音
                                    playEffect(res_sound.kry_mp3);
                                })
                            )
                        )
                    })
                )
            );

        }

        //追逐史小坑
        var loserKeyAndRun = function () {

            line.setVisible(false);

            setAnimation(loser, 0.2, ["k_dxj_ta_angry.png", "k_dxj_ta_angry2.png"], true);
            loser.runAction(cc.scaleTo(1.5, 0.5));//Loser缩小
            loser.runAction(cc.sequence(//Loser跑
                cc.moveTo(1.5, cc.p(winCenter().x - 27, winCenter().y - 39)),
                cc.callFunc(function () {
                    _this.gameWin();//游戏过关
                })
            ));

            //史小坑边跑边缩小
            kengMan.runAction(cc.spawn(
                cc.moveTo(1.0, cc.p(winCenter().x, winCenter().y + 70)),
                cc.scaleTo(1.0, 0.5)
            ));

            kengMan.runAction(cc.sequence(
                cc.rotateBy(0.1, 15), cc.rotateBy(0.3, -15)
            ).repeatForever());

            //关门，史小坑进门
            kengMan.runAction(cc.sequence(cc.delayTime(1.0), cc.callFunc(function () {
                setAnimation(door, 0.01, ["k_dxj_door.png"], false, function () {
                    kengMan.setVisible(false);
                    playEffect(res_sound.peng_mp3);
                });
            })));
        }

        //受虐者生气了
        var loserKry = function () {

            line.setVisible(false);
            setAnimation(loser, 0.3, ["k_dxj_ta_angry.png", "k_dxj_ta_angry2.png"], true);
            loser.setLocalZOrder(210);
            loser.runAction(cc.sequence(
                cc.moveTo(1.0, kengMan.getPosition()),
                cc.callFunc(function () {
                    kengMan.setVisible(false);
                    fightFightFight(loser, null, function () {
                        _this.gameOver("lossWord4");//史小坑被打死
                    });
                })
            ));
        }

        //铲子被点击后，移动
        var action = function () {
            if (isNoTouch) return;

            line.setVisible(false);

            isClickedShovel = true;

            playEffect(res_sound.click_mp3);

            shovel.runAction(
                cc.sequence(
                    cc.moveTo(0.3, cc.p(winCenter().x + 70, winCenter().y - 330)),
                    cc.callFunc(function () {
                        //移动桶
                        barrel.runAction(cc.moveBy(0.3, cc.p(10, -200)))
                    })
                )
            );
        }

        //打开门
        var openTheDoor = function () {
            isDoorOpen = true;
            setAnimation(door, 0.05, ["k_dxj_door2.png"], false);
            playEffect(res_sound.openDoor_mp3);
        }

        //Loser笑
        var loserLaugh = function () {
            stoneBigAction.setVisible(false);
            setAnimation(loser, 0.3, ["k_dxj_ta_laugh1.png", "k_dxj_ta_laugh2.png"], true);
            playEffect(res_sound.peng_mp3);
            delayTimeDoSomething(0.3, function () {
                playEffect(res_sound.laugh_boy_mp3);
            });
        }

        //史小坑去捡石头的作死动画
        var kengManDieAction = function () {

            if(isClickedShovel&&isDoorOpen) return;

            if (isNoTouch) return;

            isNoTouch = true;

            line.setVisible(false);

            kengMan.stopAllActions();
            kengMan.runAction(cc.sequence(
                cc.moveTo(0.5, cc.p(winCenter().x + 15, winCenter().y - 200)),
                cc.callFunc(function () {
                    stoneBig.setVisible(false);

                    delayTimeDoSomething(0.1, function () {
                        playEffect(res_sound.enheng_mp3);
                    });

                    setAnimation(kengMan, 0.3, ["k_dxj_people_jianqi.png","k_dxj_people_songshou.png"], false, function () {

                        //添加对话框，显示：吓死宝宝了
                        loserLaugh();
                        var chart = createLevelSprite("k_dxj_huakuang2.png");
                        chart.attr({x: winCenter().x - 63, y: winCenter().y - 13});
                        chart.setLocalZOrder(300);
                        _this.addChild(chart);

                        stoneBig.setVisible(true);
                        stoneBig.setPosition(limitToPosition(-28, -309));
                        stoneBig.setLocalZOrder(100);

                        playLevelEffect("wuhahaho.mp3");

                        setAnimation(kengMan, 0.3, ["k_dxj_people_cry1.png","k_dxj_people_cry2.png"]);
                    });
                    stoneBig.runAction(cc.sequence(cc.delayTime(4.0), cc.callFunc(function () {
                        _this.gameOver("lossWord1");//搬石头砸自己的脚而死
                    })));
                })
            ));
        }

        return true;
    },
    onEnter: function () {
        this._super();
    },
    gameOver: function (faileType) {

        //失败的时候调用父节点（当前场景）的gameOver方法，传入失败类型（对应配置表不同的文案）
        this.getParent().gameOver(faileType);
    },
    gameWin: function () {

        //游戏胜利的时候调用当前场景的gameWin方法
        this.getParent().gameWin();
    },
    //必需要实现这个函数
    propCallBack: function (tag, pos) {


    }
});

var GameSceneFightChick = GameSceneBase.extend({
    layer: null,
    onEnter: function () {
        this._super();
        this.layer = new FightChickLayer();
        this.addChild(this.layer);

        this.hidePropBox();

        this.stopAllActions();

    },
    pauseTheGame: function () {
        //暂停游戏处理
    },
    resumeTheGame: function () {
        //恢复游戏处理
    }
});

