/**
 * Created by eeee on 16/1/26.
 */
var KengLockLayer=cc.Layer.extend({
    isTouch:false,
    door:null,
    man:null,
    loserMan:null,
    locks:null,
    blueLocks:null,
    stone:null,
    windows:null,
    doorFragment1:null,
    doorFragment2:null,
    onEnter:function(){
        this._super();
        //绿色地面
        var ground=new cc.LayerColor(cc.color(186,186,159),cc.winSize.width,460);
        this.parent.addChild(ground,-1);

        this.runAction(cc.sequence(
            cc.delayTime(0.1),
            cc.callFunc(function(){
                ground.height=460*(1+(1-this.scale)/4);
            },this)
        ));
    },
    ctor:function(){
        this._super();

        //线
        var line=createLevelSprite("k_com_line.png");
        line.attr({
            x:winCenter().x,
            y:460
        });
        this.addChild(line);

        //门牌
        var doorPlate=createLevelSprite("k_ms_housename.png");
        doorPlate.attr({
            x:winCenter().x-139.3,
            y:winCenter().y+249.5
        });
        this.addChild(doorPlate);

        //门牌名字
        var homeMaterName=new cc.LabelTTF(_curLoserName+"的家","",26);
        homeMaterName.attr({
            x:doorPlate.width/2,
            y:doorPlate.height/2,
            color:cc.color(93,71,67)
        });
        doorPlate.addChild(homeMaterName);
        var labelSize=doorPlate.width/homeMaterName.width*22;
        labelSize=labelSize>40?40:labelSize;
        homeMaterName.fontSize=labelSize;

        //门
        this.door=createLevelSprite("k_ms_door_close.png");
        this.door.attr({
            x:winCenter().x-130.5,
            y:winCenter().y+43
        });
        this.addChild(this.door);

        //门锁
        this.locks=[];
        for(var i=0;i<3;i++){
            var lock=createLevelSprite("k_ms_suo.png");
            lock.attr({
                x:winCenter().x-246,
                y:winCenter().y+92.7-i*69.5
            });
            this.addChild(lock);
            addTouchCallBack(lock,function(){
                if(!this.isTouch)return;
                this.manUnLock();
            }.bind(this));
            this.locks[i]=lock;
        }

        //门前地板
        var floor=createLevelSprite("k_ms_door_di.png");
        floor.attr({
            x:winCenter().x-130.5,
            y:winCenter().y-125.5
        });
        this.addChild(floor);

        //窗
        var windows=createLevelSprite("k_ms_window.png");
        windows.attr({
            x:winCenter().x+180,
            y:winCenter().y+140.5
        });
        this.addChild(windows);
        this.windows=windows;
        addTouchCallBack(windows,function(){
            if(!this.isTouch)return;
            removeListener(windows);
            this.manThrowStone();
        }.bind(this));
        windows.beganCallback=function(touch,event){
            var target = event.getCurrentTarget();
            var locationInNode = target.convertToNodeSpace(touch.getLocation());
            var s = target.getContentSize();
            var rect = cc.rect(s.width/2, 0, s.width/2, s.height);
            if(cc.rectContainsPoint(rect, locationInNode)) {
                return true;
            }
            return false;
        };

        //花瓶
        var flowerVase=createLevelSprite("k_03_flower.png");
        flowerVase.attr({
            x:winCenter().x+118,
            y:winCenter().y+119
        });
        this.addChild(flowerVase);
        addTouchCallBack(flowerVase,function(){
            if(!this.isTouch)return;
            removeListener(flowerVase);
            flowerVase.runAction(cc.sequence(
                cc.moveBy(0.4,cc.p(0,-180)),
                cc.callFunc(function(){
                    playEffect(res_sound.broken_mp3);
                    setSpriteTxture(flowerVase,"k_03_flower2.png");
                    flowerVase.y-=60;

                    playEffect(res_sound.drop_mp3);
                    //钥匙
                    var key=createLevelSprite("k_ms_suo_yaochi.png");
                    key.attr({
                        x:winCenter().x+119.5,
                        y:winCenter().y-136.5
                    });
                    this.addChild(key);
                    addTouchCallBack(key,function(){
                        if(!this.isTouch)return;
                        key.removeFromParent();
                        this.manOpenDoor();
                    }.bind(this));
                },this)
            ));
        }.bind(this));

        //花盆
        var flowerPot=createLevelSprite("k_ms_huapen.png");
        flowerPot.attr({
            x:winCenter().x+206.5,
            y:winCenter().y-125.5
        });
        this.addChild(flowerPot,1);

        //草
        var grass=createLevelSprite("k_ms_grass1.png");
        grass.attr({
            x:winCenter().x+216.5,
            y:winCenter().y-59
        });
        this.addChild(grass,1);
        addTouchCallBack(grass,function(){
            if(!this.isTouch)return;
            removeListener(grass);
            setSpriteTxture(grass,"k_ms_grass2.png");

            //蓝色锁
            this.blueLocks=[];
            for(var i=0;i<2;i++){
                var blueLock=createLevelSprite("k_ms_suo2.png");
                blueLock.attr({
                    x:winCenter().x+215,
                    y:winCenter().y-60-i*18,
                    rotation:-8
                });
                this.addChild(blueLock);
                this.blueLocks.push(blueLock);
                if(i==0){
                    addTouchCallBack(blueLock,function(){
                        if(!this.isTouch)return;
                        this.addBlueLock();
                    }.bind(this));
                }
            }
        }.bind(this));

        //石头
        for(var i=0;i<2;i++){
            var stone=createLevelSprite("k_ms_tone1.png");
            stone.attr({
                x:winCenter().x+156+i*27.5,
                y:winCenter().y-281-i*13
            });
            this.addChild(stone);
            if(i==1)this.stone=stone;
        }

        //史小坑
        this.man=createLevelSprite("k_dxj_people_stand.png");
        this.man.attr({
            x:winCenter().x+19,
            y:winCenter().y-248-this.man.height*0.3,
            anchorY:0.2
        });
        this.addChild(this.man,2);

        //显示对话
        this.showDialog();
    },
    showDialog:function(){
        var dialog=createLevelSprite("k_jbthy_box_man.png");
        dialog.attr({
            x:winCenter().x+62,
            y:winCenter().y-115,
            anchorX:0.9,
            anchorY:0.1,
            scaleX:-1
        });
        this.addChild(dialog,3);
        dialog.runAction(cc.sequence(
            cc.rotateTo(0.2,5),
            cc.rotateTo(0.2,0)
        ).repeat(16));

        var dialogLabel=new cc.LabelTTF("这家伙装这么多锁...","",26,cc.size(160,95),cc.TEXT_ALIGNMENT_CENTER);
        dialogLabel.attr({
            x:dialog.width/2,
            y:dialog.height/2-20,
            scaleX:-1,
            color:cc.color(0,0,0)
        });
        dialog.addChild(dialogLabel);

        dialogLabel.runAction(cc.sequence(
            cc.delayTime(1.6),
            cc.callFunc(function(){
                dialogLabel.string="看我整整他！";
            }),
            cc.delayTime(1.6),
            cc.callFunc(function(){
                dialog.removeFromParent();
                this.isTouch=true;

                this.getParent().setMyNameTag(this.man);
            },this)
        ));
    },
    manUnLock:function(){
        this.isTouch=false;

        this.man.runAction(cc.sequence(
            cc.rotateTo(0.2,-3),
            cc.rotateTo(0.2,0)
        ).repeat(5));

        playEffect(res_sound.walk_mp3);
        this.man.runAction(cc.sequence(
            cc.moveBy(1,cc.p(-132,100)),
            cc.moveBy(1,cc.p(0,152)),
            cc.callFunc(function(){
                setSpriteTxture(this.man,"k_ms_people_nongsuo.png");
            },this),
            cc.sequence(
                cc.rotateTo(0.2,-3),
                cc.rotateTo(0.2,0)
            ).repeat(3),
            cc.callFunc(function(){
                this.loserMan=createLevelSprite("k_ms_man_find.png");
                this.loserMan.attr({
                    x:-this.loserMan.width/2,
                    y:winCenter().y-291,
                    anchorY:0.2
                });
                this.addChild(this.loserMan,2);
                this.getParent().setLoserNameTag(this.loserMan);

                //风
                var wind=createLevelSprite("k_lhs_people_line.png");
                wind.attr({
                    x:3.2,
                    y:96.4,
                    rotation:-20
                });
                this.loserMan.addChild(wind);

                this.loserMan.runAction(cc.sequence(
                    cc.moveTo(0.4,cc.p(winCenter().x-245,this.loserMan.y)),
                    cc.callFunc(function(){
                        wind.removeFromParent();
                        setSpriteTxture(this.man,"k_ms_people_scar.png");

                        //对话框
                        var dialog=createLevelSprite("k_jbthy_box_waiter.png");
                        dialog.attr({
                            x:this.loserMan.width-30,
                            y:this.loserMan.height-30,
                            anchorX:0.9,
                            anchorY:0.1,
                            scaleX:-1
                        });
                        this.loserMan.addChild(dialog,3);
                        dialog.runAction(cc.sequence(
                            cc.sequence(
                                cc.rotateTo(0.2,2),
                                cc.rotateTo(0.2,0)
                            ).repeat(3),
                            cc.removeSelf()
                        ));

                        var dialogLabel=new cc.LabelTTF("你丫给我站住！!","",26,cc.size(160,95),cc.TEXT_ALIGNMENT_CENTER);
                        dialogLabel.attr({
                            x:dialog.width/2,
                            y:dialog.height/2-20,
                            scaleX:-1,
                            color:cc.color(0,0,0)
                        });
                        dialog.addChild(dialogLabel);

                        playEffect(res_sound.angry_mp3);
                    },this),
                    cc.delayTime(1),
                    cc.callFunc(function(){
                        setSpriteTxture(this.loserMan,"k_ms_man_angry.png");
                    },this),
                    cc.spawn(
                        cc.sequence(
                            cc.rotateTo(0.2,10),
                            cc.rotateTo(0.2,0),
                            cc.rotateTo(0.2,10),
                            cc.rotateTo(0.2,0)
                        ),
                        cc.moveTo(0.8,cc.p(winCenter().x-221.4,winCenter().y-74.4))
                    ),
                    cc.callFunc(function(){
                        setSpriteTxture(this.loserMan,"k_ms_man_yibazhang1.png");
                    },this),
                    cc.delayTime(0.3),
                    cc.callFunc(function(){
                        setSpriteTxture(this.loserMan,"k_ms_man_yibazhang2.png");
                        shotDead(this.man,function(){
                            showGameOver("manUnLock");
                        });
                    },this)
                ));
            },this)
        ));
    },
    manThrowStone:function(){
        this.isTouch=false;
        this.man.runAction(cc.sequence(
            cc.moveTo(0.3,cc.p(winCenter().x+112.5,winCenter().y-297)),
            cc.callFunc(function(){
                setSpriteTxture(this.man,"k_ms_people_jianshitou.png");
            },this),
            cc.delayTime(0.3),
            cc.callFunc(function(){
                setSpriteTxture(this.man,"k_ms_people_zhunbeireng.png");
                this.stone.x=winCenter().x+15.3;
                this.stone.y=winCenter().y-99.4;
                this.stone.rotation=-10;
            },this),
            cc.delayTime(0.3),
            cc.callFunc(function(){
                setSpriteTxture(this.man,"k_ms_people_renglu.png");
                setSpriteTxture(this.stone,"k_ms_stone_fly.png");
                this.stone.x=winCenter().x+92.4;
                this.stone.y=winCenter().y-32.3;
                this.stone.rotation=0;

                this.stone.runAction(cc.sequence(
                    cc.moveTo(0.2,cc.p(winCenter().x+185.3,winCenter().y+86.3)),
                    cc.callFunc(function(){
                        playEffect(res_sound.broken_mp3);
                        setSpriteTxture(this.windows,"k_ms_window_broken.png");

                        var boom=createLevelSprite("k_zxx_boom_1.png");
                        boom.attr({
                            scale:0.5,
                            x:winCenter().x+222.2,
                            y:winCenter().y+126.4
                        });
                        this.addChild(boom);
                        boom.runAction(cc.sequence(
                            cc.delayTime(0.2),
                            cc.removeSelf()
                        ));

                        this.loserManLookWindowsBroken();
                    },this),
                    cc.removeSelf()
                ));
            },this)
        ));

    },
    loserManLookWindowsBroken:function(){
        this.loserMan=createLevelSprite("k_ms_man_yibazhang1.png");
        this.loserMan.attr({
            x:-this.loserMan.width/2,
            y:winCenter().y-291,
            anchorY:0.2,
            rotation:10
        });
        this.addChild(this.loserMan,1);
        this.getParent().setLoserNameTag(this.loserMan);

        //风
        var wind=createLevelSprite("k_lhs_people_line.png");
        wind.attr({
            x:3.2,
            y:96.4,
            rotation:-20
        });
        this.loserMan.addChild(wind);

        this.loserMan.runAction(cc.sequence(
            cc.moveTo(0.4,cc.p(winCenter().x-245,this.loserMan.y)),
            cc.callFunc(function(){
                wind.removeFromParent();

                //对话框
                var dialog=createLevelSprite("k_jbthy_box_waiter.png");
                dialog.attr({
                    x:this.loserMan.width-70,
                    y:this.loserMan.height-45,
                    anchorX:0.9,
                    anchorY:0.1,
                    scaleX:-1
                });
                this.loserMan.addChild(dialog,3);
                dialog.runAction(cc.sequence(
                    cc.sequence(
                        cc.rotateTo(0.2,2),
                        cc.rotateTo(0.2,0)
                    ).repeat(3),
                    cc.removeSelf()
                ));

                var dialogLabel=new cc.LabelTTF("你丫给我站住！!","",26,cc.size(160,95),cc.TEXT_ALIGNMENT_CENTER);
                dialogLabel.attr({
                    x:dialog.width/2,
                    y:dialog.height/2-20,
                    scaleX:-1,
                    color:cc.color(0,0,0)
                });
                dialog.addChild(dialogLabel);

                playEffect(res_sound.angry_mp3);
            },this),
            cc.delayTime(0.4),
            cc.spawn(
                cc.moveTo(0.8,cc.p(winCenter().x+10,this.loserMan.y)),
                cc.sequence(
                    cc.rotateTo(0.2,0),
                    cc.rotateTo(0.2,10),
                    cc.rotateTo(0.2,0),
                    cc.rotateTo(0.2,10)
                )
            ),
            cc.callFunc(function(){
                setSpriteTxture(this.loserMan,"k_ms_man_yibazhang2.png");
                shotDead(this.man,function(){
                    showGameOver("manThrowStone");
                })
            },this)
        ));
    },
    manOpenDoor:function(){
        this.isTouch=false;
        var key=createLevelSprite("k_ms_suo_yaochi.png");
        key.attr({
            x:2,
            y:140
        });
        this.man.addChild(key,-1);

        for(var i=0;i<3;i++){
            this.locks[i].runAction(cc.sequence(
                cc.delayTime(2.3+i*0.3),
                cc.callFunc(function(){
                    setSpriteTxture(this,"k_ms_suo_open.png");
                },this.locks[i])
            ));
        }

        this.man.runAction(cc.sequence(
            cc.rotateTo(0.2,-3),
            cc.rotateTo(0.2,0)
        ).repeat(5));

        this.man.runAction(cc.sequence(
            cc.moveBy(1,cc.p(-148,100)),
            cc.moveBy(1,cc.p(0,167)),
            cc.callFunc(function(){
                key.rotation=150;
                key.x=9;
                key.y=172;
            },this),
            cc.delayTime(0.3),
            cc.spawn(
                cc.moveBy(0.1,cc.p(60,10)),
                cc.rotateTo(0.1,-33)
            ),
            cc.callFunc(function(){
                key.rotation=180;
                key.x=16.7;
                key.y=167.8;
            },this),
            cc.spawn(
                cc.moveBy(0.2,cc.p(-60,-10)),
                cc.rotateTo(0.2,0)
            ),
            cc.delayTime(0.2),
            cc.spawn(
                cc.moveBy(0.1,cc.p(76,10)),
                cc.rotateTo(0.1,-60)
            ),
            cc.callFunc(function(){
                key.rotation=230;
                key.x=24;
                key.y=165;
            },this),
            cc.spawn(
                cc.moveBy(0.1,cc.p(-76,-10)),
                cc.rotateTo(0.1,0)
            ),
            cc.delayTime(0.5),
            cc.jumpTo(0.3,cc.p(winCenter().x,winCenter().y-243.5),80,1),
            cc.callFunc(function(){
                playEffect(res_sound.openDoor_mp3);
                setSpriteTxture(this.door,"k_ms_door_open.png");
                this.door.setLocalZOrder(1);
            },this),
            cc.delayTime(0.2),
            cc.callFunc(function(){
                setSpriteTxture(this.man,"k_ms_people_scar.png");
                this.man.runAction(cc.sequence(
                    cc.delayTime(0.5),
                    cc.spawn(
                        cc.sequence(
                            cc.rotateTo(0.2,-3),
                            cc.rotateTo(0.2,0),
                            cc.rotateTo(0.2,-3),
                            cc.rotateTo(0.2,0)
                        ),
                        cc.moveTo(0.8,cc.p(cc.winSize.width-this.man.width/1.3,this.man.y))
                    )
                ));

                playEffect(res_GameSceneKengLock_sound.bowwow_mp3);
                //狗
                var dog=createLevelSprite("k_ms_dog_big1.png");
                dog.attr({
                    scale:0.8,
                    x:winCenter().x-177,
                    y:winCenter().y-58.5
                });
                this.addChild(dog,1);
                setAnimation(dog,0.2,["k_ms_dog_big1.png","k_ms_dog_big2.png"]);
                dog.runAction(cc.sequence(
                    cc.flipX(true),
                    cc.spawn(
                        cc.scaleTo(0.5,1),
                        cc.moveTo(0.5,cc.p(winCenter().x-277,winCenter().y-174))
                    ),
                    cc.flipX(false),
                    cc.moveTo(0.8,cc.p(cc.winSize.width-this.man.width/1.3,winCenter().y-248.5)),
                    cc.callFunc(function(){
                        key.removeFromParent();
                        dog.removeFromParent();
                        setSpriteTxture(this.man,"k_dxz_fight1.png");

                        playEffect(res_sound.fightFightFight_mp3);
                        var fightAction=getAnimation(0.2,["k_dxz_fight1.png","k_dxz_fight2.png"]);
                        this.man.runAction(cc.sequence(
                            fightAction.repeat(6),
                            cc.callFunc(function(){
                                showGameOver("manOpenDoor");
                            })
                        ));
                    },this)
                ));
            },this)
        ));
    },
    addBlueLock:function(){
        this.isTouch=false;

        this.man.runAction(cc.sequence(
            cc.spawn(
                cc.sequence(
                    cc.rotateTo(0.25,3),
                    cc.rotateTo(0.25,0),
                    cc.rotateTo(0.25,-3),
                    cc.rotateTo(0.25,0)
                ),
                cc.moveTo(1,cc.p(winCenter().x+152.7,winCenter().y-152.9))
            ),
            cc.callFunc(function(){
                //锁
                for(var i=0;i<2;i++){
                    this.blueLocks[i].removeFromParent();
                    var blueLock=createLevelSprite("k_ms_suo2.png");
                    blueLock.attr({
                        x:174.2,
                        y:162.7-i*18,
                        rotation:-8
                    });
                    this.man.addChild(blueLock);
                    this.blueLocks[i]=blueLock;
                }
            },this),
            cc.spawn(
                cc.sequence(
                    cc.rotateTo(0.25,3),
                    cc.rotateTo(0.25,0),
                    cc.rotateTo(0.25,-3),
                    cc.rotateTo(0.25,0)
                ),
                cc.moveTo(1,cc.p(winCenter().x-138.9,winCenter().y-69.2))
            ),
            cc.callFunc(function(){
                this.manEscape();
            },this)
        ));
    },
    manEscape:function(){
        //锁
        for(var i=0;i<2;i++){
            this.blueLocks[i].removeFromParent();
            var blueLock=createLevelSprite("k_ms_suo2.png");
            blueLock.attr({
                x:winCenter().x-230,
                y:winCenter().y+69-i*70
            });
            this.addChild(blueLock);
        }

        this.man.runAction(cc.spawn(
            cc.sequence(
                cc.rotateTo(0.25,3),
                cc.rotateTo(0.25,0),
                cc.rotateTo(0.25,-3),
                cc.rotateTo(0.25,0)
            ),
            cc.moveTo(1,cc.p(winCenter().x+19,winCenter().y-248-this.man.height*0.3))
        ));


        playEffect(res_sound.laugh_boy_mp3);
        //史小坑大笑逃走
        var manAction=getAnimation(0.2,["k_dxj_people_laugh1.png","k_dxj_people_laugh2.png"]);
        this.man.attr({
            anchorY:0.2,
            y:this.man.y
        });
        this.man.runAction(cc.sequence(
            manAction.repeat(2),
            cc.delayTime(0.3),
            cc.rotateTo(0.1,-15),
            cc.delayTime(0.3),
            cc.spawn(
                cc.moveTo(0.6,cc.p(cc.winSize.width+this.man.width,winCenter().y-248-this.man.height*0.3)),
                cc.rotateTo(0.6,0)
            )
        ));
        this.runAction(cc.sequence(
            cc.delayTime(1.55),
            cc.callFunc(function(){
                playEffect(res_sound.fly_mp3);

                //风
                var wind=createLevelSprite("k_lhs_people_line.png");
                wind.attr({
                    x:winCenter().x-31,
                    y:winCenter().y-270
                });
                this.addChild(wind);
                wind.runAction(cc.sequence(
                    cc.delayTime(0.2),
                    cc.callFunc(function(){
                        //烟雾
                        var smoke=createLevelSprite("k_24_boom1.png");
                        smoke.attr({
                            x:winCenter().x+156,
                            y:winCenter().y-239.5
                        });
                        this.addChild(smoke,3);
                        setAnimation(smoke,0.2,["k_24_boom2.png","k_24_boom3.png","k_24_boom4.png","k_24_boom5.png"],false,function(){
                            this.loserManGoHome();
                            smoke.removeFromParent();
                        }.bind(this));
                    },this),
                    cc.removeSelf()
                ));
            },this)
        ));
    },
    loserManGoHome:function(){
        this.loserMan=createLevelSprite("k_ms_man_gohome.png");
        this.loserMan.attr({
            x:-this.loserMan.width/2,
            y:winCenter().y-331,
            anchorY:0.2
        });
        this.addChild(this.loserMan,1);
        this.getParent().setLoserNameTag(this.loserMan);

        var bezier=[
            cc.p(winCenter().x-182.6,winCenter().y-220),
            cc.p(winCenter().x-182.6,winCenter().y-80),
            cc.p(winCenter().x-182.6,winCenter().y-49)
        ];
        this.loserMan.runAction(cc.sequence(
            cc.rotateTo(0.2,3),
            cc.rotateTo(0.2,0)
        ).repeat(5));
        this.loserMan.runAction(cc.sequence(
            cc.bezierTo(2,bezier),
            cc.callFunc(function(){
                this.loserManUnLock();
            },this)
        ));
    },
    loserManUnLock:function(){
        for(var i=0;i<3;i++){
            this.locks[i].runAction(cc.sequence(
                cc.delayTime(0.3+i*0.3),
                cc.callFunc(function(){
                    setSpriteTxture(this,"k_ms_suo_open.png");
                },this.locks[i])
            ));
        }

        setAnimation(this.loserMan,0.3,[
            "k_ms_man_opendoor1.png",
            "k_ms_man_opendoor2.png",
            "k_ms_man_opendoor3.png",
            "k_ms_man_opendoor_lose.png"
        ],false,function(){
            //生气
            var shengqi=createLevelSprite("k_xcw_fuhao.png");
            shengqi.attr({
                scaleX:-1,
                x:winCenter().x-216.5,
                y:winCenter().y+141.5
            });
            this.addChild(shengqi,1);
            shengqi.runAction(cc.sequence(
                cc.place(winCenter().x-216.5,winCenter().y+141.5),
                cc.delayTime(0.2),
                cc.place(winCenter().x-210,winCenter().y+146),
                cc.delayTime(0.2)
            ).repeat(9));

            this.loserMan.runAction(cc.sequence(
                cc.sequence(
                    cc.rotateTo(0.2,3),
                    cc.rotateTo(0.2,0)
                ).repeat(6),
                cc.spawn(
                    cc.sequence(
                        cc.rotateTo(0.2,3),
                        cc.rotateTo(0.2,0),
                        cc.rotateTo(0.2,3),
                        cc.rotateTo(0.2,0),
                        cc.rotateTo(0.2,3),
                        cc.rotateTo(0.2,0)
                    ),
                    cc.callFunc(function(){
                        //霸气
                        var domineering=createLevelSprite("k_ms_angry_texiao.png");
                        domineering.attr({
                            anchorY:0,
                            x:this.loserMan.x+62.5,
                            y:this.loserMan.y-84.5
                        });
                        this.addChild(domineering,1);

                        playEffect(res_sound.energyLift_mp3);
                        domineering.runAction(cc.sequence(
                            cc.scaleTo(0.2,0.8),
                            cc.scaleTo(0.2,1),
                            cc.scaleTo(0.2,0.8),
                            cc.callFunc(function(){
                                playEffect(res_sound.energyLift_mp3);
                            },this),
                            cc.scaleTo(0.2,1),
                            cc.scaleTo(0.2,0.8),
                            cc.callFunc(function(){
                                playEffect(res_sound.energyLift_mp3);
                            },this),
                            cc.scaleTo(0.2,1),
                            cc.scaleTo(0.2,0.8),
                            cc.callFunc(function(){
                                shengqi.removeFromParent();

                                playEffect(res_sound.fightFightFight_mp3);
                                //打门
                                var hitDoorAction=getAnimation(0.25,["k_ms_door_close.png","k_ms_door_hit.png"]);
                                this.door.runAction(cc.sequence(
                                    hitDoorAction.repeat(2),
                                    cc.delayTime(0.25),
                                    cc.callFunc(function(){
                                        playEffect(res_sound.theFace_mp3);
                                        setSpriteTxture(this.door,"k_ms_door_landiao.png");

                                        //门碎片1
                                        this.doorFragment1=createLevelSprite("k_ms_door_landiao3.png");
                                        this.doorFragment1.attr({
                                            x:winCenter().x-72,
                                            y:winCenter().y+68
                                        });
                                        this.addChild(this.doorFragment1);
                                        this.doorFragment1.runAction(cc.spawn(
                                            cc.jumpBy(0.3,cc.p(123.5,-66),30,1),
                                            cc.rotateTo(0.3,15)
                                        ));

                                        //门碎片2
                                        this.doorFragment2=createLevelSprite("k_ms_door_landiao2.png");
                                        this.doorFragment2.attr({
                                            x:winCenter().x-123.5,
                                            y:winCenter().y+9.5
                                        });
                                        this.addChild(this.doorFragment2);
                                    },this),
                                    cc.delayTime(0.5),
                                    cc.callFunc(function(){
                                        playEffect(res_sound.theFace_mp3);
                                        this.doorFragment2.runAction(cc.jumpBy(0.3,cc.p(183.5,-63),30,1));
                                    },this)
                                ));

                                var loserManAttak=getAnimation(0.25,["k_ms_man_chuquan1.png","k_ms_man_chuquan2.png"]);
                                this.loserMan.runAction(cc.sequence(
                                    loserManAttak.repeat(4),
                                    cc.callFunc(function(){
                                        setSpriteTxture(this.loserMan,"k_ms_man_gohome.png");
                                        this.loserMan.x+=60;
                                    },this),
                                    cc.delayTime(0.3),
                                    cc.spawn(
                                        cc.sequence(
                                            cc.rotateTo(0.2,3),
                                            cc.rotateTo(0.2,0),
                                            cc.rotateTo(0.2,3)
                                        ),
                                        cc.fadeOut(0.6),
                                        cc.scaleTo(0.6,0.9),
                                        cc.moveBy(0.6,cc.p(0,20))
                                    ),
                                    cc.callFunc(function(){
                                        this.getParent().removeLoserNameTag();
                                        this.man.x=cc.winSize.width+this.man.width/2;
                                        playEffect(res_sound.laugh_boy_mp3);
                                        var manLaughAction=getAnimation(0.2,["k_dxj_people_laugh1.png","k_dxj_people_laugh2.png"]);
                                        this.man.runAction(cc.sequence(
                                            cc.spawn(
                                                cc.rotateTo(0.3,-15),
                                                cc.moveBy(0.3,cc.p(-this.man.width/2,0))
                                            ),
                                            manLaughAction.repeat(4),
                                            cc.delayTime(0.3),
                                            cc.callFunc(function(){
                                                showGameWin();
                                            })
                                        ));
                                    },this)
                                ))
                            },this),
                            cc.removeSelf()
                        ));
                    },this)
                )
            ));
        }.bind(this));
    }
});

var GameSceneKengLock=GameSceneBase.extend({
    ctor:function(){
        this._super();
        this.layer=new KengLockLayer();
        this.addChild(this.layer);
        this.setMyNameTag(this.layer.man,null,null,100);
    }
});