/**
 * Created by MingliC on 16/2/1.
 */

var KengdieSongLayer = cc.Layer.extend({
    sprite: null,
    sprite2: null,
    ctor: function () {
        this._super();
        this.size = cc.director.getWinSize();

        return true;
    },
    onEnter: function () {
        this._super();

        this.size = cc.director.getWinSize();
        var _this = this;

        var messageLoser = null;
        var txtArray = [
            "至", "爱", "节", "愚", "我", "了",
            "回", "很", "有", "少", "还", "乐",
            "无", "快", "你", "来", "无", "无"
        ];
        var inputString = "";
        var inputSize = 0;
        var XIAOKENG_FACE_TAG = 100;
        var messageArray = new Array();
        var isLoserSendTip = false;//Loser是否发送了“猜一首歌的提示”
        var isOver = true;//禁止操作

        var bg = createLevelSprite("k_wechat_bg");
        bg.setPosition(limitToPosition(0, -48));
        _this.addChild(bg);

        //返回按钮
        var kengchart = createLevelSprite("k_wechat_text");
        kengchart.setPosition(cc.p(102, this.size.height - 135));
        _this.addChild(kengchart);

        //人物
        var icon = createLevelSprite("k_wechat_icon");
        icon.setPosition(cc.p(this.size.width - 60, this.size.height - 135));
        _this.addChild(icon);

        //Loser名字
        var loserNameTagLabel = new cc.LabelTTF(_curLoserName, "", 36);
        loserNameTagLabel.attr({
            x: winCenter().x, y: this.size.height - 145,
            color: cc.color(255, 255, 255)
        });
        _this.addChild(loserNameTagLabel);

        //回删按钮
        var deleteBtn = createButton({
            img: "k_wechat_btn_delete",
            callback: clickDeleteBtn,
            txt: "回删",
            txtSize: 36,
            txtColor: cc.color(0, 0, 0)
        });
        deleteBtn.setPosition(limitToPosition(196, -386));
        _this.addChild(deleteBtn);

        //输入框
        var inputBox = createLevelSprite("k_wechat_frame_enter");
        inputBox.setPosition(limitToPosition(-56, -115));
        _this.addChild(inputBox);

        //输入的文字显示
        var inputLabel = new cc.LabelTTF("", "", 28);
        inputLabel.setPosition(limitToPosition(-144, -118));
        inputLabel.attr({
            anchorX: 0, anchorY: 0.5,
            color: cc.color(0, 0, 0)
        });
        _this.addChild(inputLabel);

        //输入光标
        var inputTag = createLevelSprite("k_wechat_light");
        inputTag.setPosition(inputLabel.getPosition());
        _this.addChild(inputTag);
        inputTag.runAction(cc.sequence(cc.fadeOut(0.4), cc.delayTime(0.3), cc.fadeIn(0.2)).repeatForever());//光标闪

        //发送按钮
        var postBtn = createButton({
            img: "k_wechat_btn_send",
            callback: clickPostBtn
        });
        postBtn.setPosition(limitToPosition(233, -117));
        _this.addChild(postBtn);

        initKeyBord();//初始化键盘
        this.schedule(inputStringUpdate, 0.3);
        function inputStringUpdate() {
            inputLabel.setString(inputString);
            inputTag.setPosition(cc.p(inputLabel.getPositionX() + inputLabel.width + 5, inputLabel.getPositionY()));
        }

        loserNameTagLabel.setString("对方正在输入...");
        delayTimeDoSomething(2.0, function () {
            messageLoser = createMessage("世界上的猪都死光了，\n怎么办?？", true);//开始说话了
            isOver = false;
        });

        delayTimeDoSomething(5.0, function () {
            loserNameTagLabel.setString("对方正在输入...");
            delayTimeDoSomething(2.0, function () {
                if (isOver) return;
                messageLoser = createMessage("猜一首歌", true);//开始说话了
            });
        });

        /** 初始化键盘 */
        function initKeyBord() {

            for (var i = 0; i < 3; i++) {
                for (var j = 0; j < 6; j++) {

                    var index = j + i * 6;
                    if (txtArray[index] == "无") continue;//遇到无就跳过
                    var btn = createButton({
                        img: "k_wechat_frame_text",
                        callback: function () {
                            clickTxtBtn(this)
                        },
                        txt: txtArray[index],
                        txtSize: 36,
                        txtColor: cc.color(0, 0, 0)
                    });
                    btn.setPosition(limitToPosition(-240 + j * 96, -195 - i * 96));
                    btn.setTag(index);

                    _this.addChild(btn);
                }
            }
        }

        /** 点击文字按钮 */
        function clickTxtBtn(target) {

            if (inputSize < 10) {
                inputSize++;
                inputString += txtArray[target.getTag()];
            }
        }

        /** 点击回删按钮 */
        function clickDeleteBtn() {
            if (inputSize > 0) {
                inputSize--;
                inputString = inputString.substring(0, inputSize);
            }
        }

        /** 点击发送按钮 */
        function clickPostBtn() {
            if (inputSize == 0) return;
            if (isOver) return;

            isOver = true;

            //1、小坑回复内容
            var messageXiaokeng = createMessage(inputString, false);

            //内容正确
            if (inputString == "至少还有你") {
                inputString = "";
                //2、小坑回复内容
                var messageXiaokeng2;
                var messageLoser2;
                //第一种情况，Loser没有回复"猜一首歌”
                //对方正在输入
                delayTimeDoSomething(0.5, function () {
                    loserNameTagLabel.setString("对方正在输入...");
                    delayTimeDoSomething(2.0, function () {
                        //Loser回复我不是猪
                        messageLoser2 = createMessage("          我不是猪", true);
                        var faceLeft = createLevelSprite("k_wechat_face_cry");
                        faceLeft.attr({anchorX: 0, anchorY: 0, x: 140, y: 20});
                        var faceRight = createLevelSprite("k_wechat_face_pig");
                        faceRight.attr({anchorX: 1, anchorY: 0, x: messageLoser2.width - 30, y: 20});
                        messageLoser2.addChild(faceLeft);
                        messageLoser2.addChild(faceRight);
                        loserNameTagLabel.setString(_curLoserName);
                    });

                    delayTimeDoSomething(3.0, function () {
                        messageXiaokeng2 = createMessage("哈哈哈～愚人节快乐！", false);
                        var face = messageXiaokeng2.getChildByTag(XIAOKENG_FACE_TAG);
                        setAnimation(face, 0.2, ["k_wechat_man_2", "k_wechat_man_3"], true);
                        playLevelEffect("laugh_boy.mp3");
                    });

                    delayTimeDoSomething(5.0, function () {
                        _this.gameWin();//过关
                    });
                });
            } else {//内容错误
                inputString = "";
                loserNameTagLabel.setString("对方正在输入...");
                delayTimeDoSomething(2.0, function () {
                    //Loser回复我不是猪
                    messageLoser2 = createMessage("至少还有你啊！", true);
                    var faceRight = createLevelSprite("k_wechat_face_pig");
                    faceRight.attr({anchorX: 1, anchorY: 0, x: messageLoser2.width - 30, y: 20});
                    messageLoser2.addChild(faceRight);
                });

                delayTimeDoSomething(3.0, function () {
                    messageXiaokeng2 = createMessage("。。。。。。。。", false);
                    var face = messageXiaokeng2.getChildByTag(XIAOKENG_FACE_TAG);
                    setAnimation(face, 0.2, ["k_wechat_man_4", "k_wechat_man_5"], true);
                    playLevelEffect("boy_kry.mp3");
                });

                delayTimeDoSomething(5.0, function () {
                    _this.gameOver("lossWord1");//失败
                });
            }
        }

        /**
         * 创建消息
         * @param string
         * @param position
         * @param isLoser
         * @returns {*}
         */
        function createMessage(string, isLoser) {

            var position = cc.p(0, 0);

            if (isLoser) {
                position.x = 20;
            } else {
                position.x = _this.size.width - 130;
            }
            position.y = winCenter().y + 300 - (messageArray.length > 2 ? 2 : messageArray.length) * 150;

            var message;
            if (isLoser) {
                message = createLevelSprite("k_wechat_frame_loser");
                message.attr({x: position.x, y: position.y, anchorX: 0});
                var messageLabel = new cc.LabelTTF(string, "", 32);
                messageLabel.attr({ x: 140, y: 50, anchorX: 0, color: cc.color(0, 0, 0) });
                message.addChild(messageLabel);
            } else {
                message = createLevelSprite("k_wechat_frame_man");
                message.setPosition(position);
                message.attr({anchorX: 1, anchorY: 0.6});

                var messageLabel = new cc.LabelTTF(string, "", 34);
                messageLabel.attr({ x: 16, y: 60, anchorX: 0, color: cc.color(255, 255, 255) });
                message.addChild(messageLabel);

                var face = createLevelSprite("k_wechat_man_1");
                face.attr({x: message.width + face.width / 2, y: message.height / 2 + face.height / 2});
                face.setTag(XIAOKENG_FACE_TAG);
                message.addChild(face);
            }

            if (messageArray.length > 2) {
                messageArray[messageArray.length - 3].visible = false;
                //剩下的向上移动
                for (var i = messageArray.length - 2; i < messageArray.length; i++) {
                    messageArray[i].runAction(cc.moveBy(0.1, cc.p(0, 150)));
                }
            }

            messageArray.push(message);

            playLevelEffect("message.mp3");
            loserNameTagLabel.setString(_curLoserName);
            _this.addChild(message);

            return message;
        }

    },
    gameOver: function (faileKey) {

        //失败的时候调用父节点（当前场景）的gameOver方法，传入失败KEY（对应配置表不同的文案）
        this.getParent().gameOver(faileKey);
    },
    gameWin: function () {
        //游戏胜利的时候调用当前场景的gameWin方法
        this.getParent().gameWin();
    },
    propCallBack: function (tag, pos) {
        switch (tag) {
            case "prop1":
                if (this.sprite2 && cc.rectContainsPoint(this.sprite2.getBoundingBox(), pos)) {
                    this.sprite2.removeFromParent();
                    this.sprite2 = null;
                    return true;
                }
                break;
            default:
                break;
        }
    }
});

var GameSceneKengdieSong = GameSceneBase.extend({
    layer: null,
    ctor: function () {
        this._super();
        this.layer = new KengdieSongLayer();
        this.addChild(this.layer);

    },
    pauseTheGame: function () {
        //暂停游戏处理
    },
    resumeTheGame: function () {
        //恢复游戏处理
    }
});

