/**
 * Created by eeee on 16/1/25.
 */

var MagicGlovesLayer=cc.Layer.extend({
    isTouch:true,
    manLevel:0,
    rotateAction:null,
    ctor:function(){
        this._super();

        //背景
        var bg=createLevelSprite("k_qz_bg.png");
        bg.attr({
            anchorY:0,
            x:winCenter().x,
            y:0
        });
        this.addChild(bg);

        //旗子
        var flag=createLevelSprite("k_qz_zhuangshi.png");
        flag.attr({
            anchorY:0.9,
            x:winCenter().x-25.5,
            y:winCenter().y+315.5+flag.height*0.4
        });
        this.addChild(flag);
        addTouchCallBack(flag,function(){
            if(!this.isTouch)return;
            removeListener(flag);
            this.showMagicGloves(flag);

        }.bind(this));

        //左右摇动作
        this.rotateAction=cc.sequence(
            cc.rotateTo(0.3,-3),
            cc.rotateTo(0.3,0)
        ).repeatForever();

        //被整人
        this.loserMan=createLevelSprite("k_qz_dazhilao_stand.png");
        this.loserMan.attr({
            anchorY:0.2,
            x:winCenter().x+91.5,
            y:winCenter().y-115-this.loserMan.height*0.3
        });
        this.addChild(this.loserMan);
        addTouchCallBack(this.loserMan,function(){
            if(!this.isTouch)return;

            if(this.manLevel==2){
                this.manAttak();
            }else {
                this.isTouch=false;
                this.loserManAttak("loserManHit");
            }
        }.bind(this));
        this.loserMan.runAction(this.rotateAction);

        //史小坑
        this.man=createLevelSprite("k_qz_man_stand.png");
        this.man.attr({
            anchorY:0.2,
            x:winCenter().x-126,
            y:winCenter().y-102.5-this.man.height*0.3
        });
        this.addChild(this.man);
        addTouchCallBack(this.man,function(){
            if(!this.isTouch)return;
            this.manAttak();
        }.bind(this));
        this.man.runAction(this.rotateAction.clone());

        //普通拳套
        var gloves=createLevelSprite("k_qz_red.png");
        gloves.attr({
            x:winCenter().x-105,
            y:winCenter().y-353.5
        });
        this.addChild(gloves,1);
        addTouchCallBack(gloves,function(){
            if(!this.isTouch || this.manLevel==2)return;
            gloves.removeFromParent();
            this.manLevel=1;
            setSpriteTxture(this.man,"k_qz_man2_stand.png");
            
        }.bind(this));

    },
    showMagicGloves:function(target){
        target.runAction(cc.sequence(
            cc.scaleTo(0.2,1,1.1),
            cc.scaleTo(0.2,1.2,0.8),
            cc.scaleTo(0.2,1,1),
            cc.callFunc(function(){

                //金色拳套
                var magicGloves=createLevelSprite("k_qz_yellow.png");
                magicGloves.attr({
                    x:winCenter().x-30,
                    y:winCenter().y+190
                });
                this.addChild(magicGloves,2);
                magicGloves.runAction(cc.sequence(
                    cc.moveBy(0.6,cc.p(0,-470)),
                    cc.callFunc(function(){
                        playEffect(res_sound.drop_mp3);
                        playEffect(res_sound.shine_mp3);
                        //光
                        var light=createLevelSprite("k_xxl_light.png");
                        light.attr({
                            scaleX:0.4,
                            scaleY:0.4,
                            x:magicGloves.x,
                            y:magicGloves.y
                        });
                        this.addChild(light,1);
                        light.runAction(cc.sequence(
                            cc.scaleTo(0.3,1),
                            cc.scaleTo(0.3,0.6),
                            cc.scaleTo(0.3,1),
                            cc.scaleTo(0.3,0.6),
                            cc.callFunc(function(){
                                addTouchCallBack(magicGloves,function(){
                                    if(!this.isTouch)return;
                                    magicGloves.removeFromParent();
                                    this.manLevel=2;
                                    setSpriteTxture(this.man,"k_qz_man3_stand.png");
                                    
                                }.bind(this));
                            },this),
                            cc.removeSelf()
                        ));

                    },this)
                ));

            },this)
        ));
    },
    manAttak:function(){
        if(!this.isTouch)return;
        this.isTouch=false;
        switch(this.manLevel){
            case 0:
            case 1:
                setSpriteTxture(this.man,"k_qz_man"+(this.manLevel==1?"2":"")+"_attack.png");
                

                this.man.runAction(cc.sequence(
                    cc.jumpTo(0.2,cc.p(winCenter().x-8.5,this.man.y),40,1),
                    cc.callFunc(function(){
                        this.man.stopAllActions();
                        setSpriteTxture(this.man,"k_qz_man"+(this.manLevel==1?"2":"")+"_attack2.png");
                        
                        this.man.rotation=0;

                        playEffect(res_sound.theFace_mp3);
                        var boom=createLevelSprite("k_zxx_boom_1.png");
                        boom.attr({
                            scale:0.3,
                            x:winCenter().x+80.5,
                            y:winCenter().y-122.5
                        });
                        this.addChild(boom);
                        boom.runAction(cc.sequence(
                            cc.delayTime(0.2),
                            cc.removeSelf()
                        ));

                        this.man.runAction(cc.sequence(
                            cc.delayTime(0.2),
                            cc.callFunc(function(){
                                setSpriteTxture(this.man,"k_qz_man"+(this.manLevel==1?"2":"")+"_stand.png");
                                
                                this.man.runAction(this.rotateAction.clone());
                            },this),
                            cc.jumpTo(0.2,cc.p(winCenter().x-126,this.man.y),40,1),
                            cc.callFunc(function(){
                                this.loserManAttak("manFist"+this.manLevel);
                            },this)
                        ));
                    },this)
                ));
                break;
            case 2:
                //霸气
                var domineering=createLevelSprite("k_ms_angry_texiao.png");
                domineering.attr({
                    anchorY:0,
                    x:winCenter().x-100,
                    y:winCenter().y-260
                });
                this.addChild(domineering);
                playEffect(res_sound.energyLift_mp3);
                domineering.runAction(cc.sequence(
                    cc.scaleTo(0.2,0.8),
                    cc.scaleTo(0.2,1),
                    cc.scaleTo(0.2,0.8),
                    cc.callFunc(function(){
                        playEffect(res_sound.energyLift_mp3);
                    },this),
                    cc.scaleTo(0.2,1),
                    cc.scaleTo(0.2,0.8),
                    cc.callFunc(function(){
                        this.man.stopAllActions();
                        setSpriteTxture(this.man,"k_qz_man3_attack.png");
                        this.man.rotation=0;

                        this.man.runAction(cc.sequence(
                            cc.jumpTo(0.2,cc.p(winCenter().x-8.5,this.man.y),40,1),
                            cc.callFunc(function(){
                                setSpriteTxture(this.man,"k_qz_man3_attack2.png");
                                playEffect(res_sound.theFace_mp3);
                                var boom=createLevelSprite("k_zxx_boom_1.png");
                                boom.attr({
                                    scale:0.8,
                                    x:winCenter().x+100.5,
                                    y:winCenter().y-122.5
                                });
                                this.addChild(boom);
                                boom.runAction(cc.sequence(
                                    cc.delayTime(0.3),
                                    cc.removeSelf()
                                ));

                                this.loserMan.stopAllActions();
                                this.loserMan.rotation=30;
                            },this),
                            cc.delayTime(0.2),
                            cc.callFunc(function(){
                                setSpriteTxture(this.man,"k_qz_man3_attack2.png");
                                setSpriteTxture(this.loserMan,"k_qz_dazhilao_die.png");
                                this.loserMan.rotation=0;
                            },this),
                            cc.jumpTo(0.2,cc.p(winCenter().x-126,this.man.y),40,1),
                            cc.delayTime(0.3),
                            cc.callFunc(function(){
                                setSpriteTxture(this.man,"k_qz_man_laugh.png");
                                this.man.x+=43;
                                this.man.y-=8;

                                playEffect(res_sound.sinisterSmile_mp3);
                                var manAction=getAnimation(0.2,["k_qz_man_laugh.png","k_qz_man_laugh2.png"]);
                                this.man.runAction(cc.sequence(
                                    manAction.repeat(5),
                                    cc.callFunc(function(){
                                        showGameWin();
                                    },this)
                                ))
                            },this)
                        ));
                    },this),
                    cc.removeSelf()
                ));
                break;
            default:
                break;
        }
    },
    loserManAttak:function(faileKey){
        this.loserMan.stopAllActions();
        this.loserMan.rotation=0;
        setSpriteTxture(this.loserMan,"k_qz_dazhilao_attack1.png");
        this.loserMan.runAction(cc.sequence(
            cc.jumpBy(0.3,cc.p(-100,0),30,1),
            cc.callFunc(function(){
                setSpriteTxture(this.loserMan,"k_qz_dazhilao_attack2.png");

                playEffect(res_sound.theFace_mp3);
                var boom=createLevelSprite("k_zxx_boom_1.png");
                boom.attr({
                    scale:0.6,
                    x:winCenter().x-79.5,
                    y:winCenter().y-109
                });
                this.addChild(boom);
                boom.runAction(cc.sequence(
                    cc.delayTime(0.2),
                    cc.callFunc(function(){
                        this.man.stopAllActions();
                        setSpriteTxture(this.man,"k_dxj_people_die.png");
                        this.man.y-=60;

                        playEffect(res_sound.laught_brawn_mp3);
                    },this),
                    cc.removeSelf()
                ));
            },this),
            cc.delayTime(1.5),
            cc.callFunc(function(){
                showGameOver(faileKey);
            },this)
        ));
    }
});


var GameSceneMagicGloves=GameSceneBase.extend({
    ctor:function(){
        this._super();
        this.layer=new MagicGlovesLayer();
        this.addChild(this.layer);
        this.setMyNameTag(this.layer.man);
        this.setLoserNameTag(this.layer.loserMan,null,45);
    }
});