/**
 * Created by eeee on 16/1/27.
 */
var MischiefLayer=cc.Layer.extend({
    isTouch:true,
    stone1:null,
    stone2:null,
    doorbell:null,
    man:null,
    loserMan:null,
    onEnter:function(){
        this._super();
        //绿色地面
        var ground=new cc.LayerColor(cc.color(186,186,159),cc.winSize.width,536);
        this.parent.addChild(ground,-1);

        this.runAction(cc.sequence(
            cc.delayTime(0.1),
            cc.callFunc(function(){
                ground.height=536*(1+(1-this.scale)/12);
            },this)
        ));
    },
    ctor:function(){
        this._super();

        // //绿色地面
        // var ground=new cc.LayerColor(cc.color(186,186,159),cc.winSize.width,536);
        // this.addChild(ground);

        //线
        var line=createLevelSprite("k_com_line.png");
        line.attr({
            x:winCenter().x,
            y:536
        });
        this.addChild(line);

        //门
        this.door=createLevelSprite("k_ms_door_close.png");
        this.door.attr({
            x:winCenter().x-110.5,
            y:winCenter().y+119
        });
        this.addChild(this.door);
        addTouchCallBack(this.door,function(){
            if(!this.isTouch)return;
            removeListener(this.door);
            this.knockTheDoor();
        }.bind(this));

        //门前地板
        var floor=createLevelSprite("k_ms_door_di.png");
        floor.attr({
            x:winCenter().x-110.5,
            y:winCenter().y-49.5
        });
        this.addChild(floor);

        //门铃
        this.doorbell=createLevelSprite("k_ljddg_menling.png");
        this.doorbell.attr({
            x:winCenter().x-260,
            y:winCenter().y+163.7,
            scale:1.2
        });
        this.addChild(this.doorbell);
        addTouchCallBack(this.doorbell,function(){
            if(!this.isTouch)return;
            removeListener(this.doorbell);
            this.ringDoorBell();
        }.bind(this));

        //窗
        var windows=createLevelSprite("k_ms_window.png");
        windows.attr({
            x:winCenter().x+180,
            y:winCenter().y+216.5
        });
        this.addChild(windows);
        this.windows=windows;
        addTouchCallBack(windows,function(){
            if(!this.isTouch)return;
            removeListener(windows);
            this.throwStone();
        }.bind(this));

        //花瓶
        var flowerVase=createLevelSprite("k_03_flower.png");
        flowerVase.attr({
            x:winCenter().x+118,
            y:winCenter().y+195
        });
        this.addChild(flowerVase);

        //花盆
        var flowerPot=createLevelSprite("k_ms_huapen.png");
        flowerPot.attr({
            x:winCenter().x+206.5,
            y:winCenter().y-49.5
        });
        this.addChild(flowerPot);

        //草
        var grass=createLevelSprite("k_ms_grass1.png");
        grass.attr({
            x:winCenter().x+216.5,
            y:winCenter().y+17
        });
        this.addChild(grass);

        //石头
        for(var i=0;i<2;i++){
            var stone=createLevelSprite("k_ms_tone1.png");
            stone.attr({
                x:winCenter().x-145.5+i*27.5,
                y:winCenter().y-138-i*13
            });
            this.addChild(stone);
            this["stone"+(i+1)]=stone;
        }

        //史小坑
        this.man=createLevelSprite("k_ljddg_man.png");
        this.man.attr({
            x:winCenter().x-111.2,
            y:winCenter().y-360,
            anchorY:0.2
        });
        this.addChild(this.man,2);

        //被整人
        this.loserMan=createLevelSprite("k_ljddg_hou_talk01.png",0.2,["k_ljddg_hou_talk01.png","k_ljddg_hou_talk02.png"]);
        this.loserMan.attr({
            x:winCenter().x+76.7,
            y:winCenter().y-362.2,
            anchorY:0.2
        });
        this.addChild(this.loserMan,2);

    },
    throwStone:function(){
        this.isTouch=false;
        setSpriteTxture(this.man,"k_ljddg_man_walk.png");

        this.man.runAction(cc.sequence(
            cc.rotateTo(0.2,-3),
            cc.rotateTo(0.2,0)
        ).repeat(3));

        playEffect(res_sound.walk_mp3);
        var manAction=getAnimation(0.2,["k_ms_people_zhunbeireng.png","k_ms_people_renglu.png"]);

        this.man.runAction(cc.sequence(
            cc.moveTo(1.2,cc.p(winCenter().x-208.3,winCenter().y-140)),
            cc.callFunc(function(){
                setSpriteTxture(this.man,"k_ms_people_jianshitou.png");
                this.stone1.visible=false;
                this.stone1.rotation=20;
                this.stone1.x=winCenter().x-60.8;
                this.stone1.y=winCenter().y+20;
            },this),
            manAction,
            cc.callFunc(function(){
                playEffect(res_sound.fly_mp3);
                this.stone1.visible=true;
                setSpriteTxture(this.stone1,"k_ms_stone_fly.png");
                this.stone1.runAction(cc.sequence(
                    cc.spawn(
                        cc.rotateBy(0.8,80),
                        cc.jumpTo(0.8,cc.p(winCenter().x+177,winCenter().y+38.7),100,1)
                    ),
                    cc.callFunc(function(){
                        setSpriteTxture(this.stone1,"k_ms_tone1.png");
                        this.stone1.rotation=0;
                        this.stone1.x=winCenter().x+209.4;
                        this.stone1.y=winCenter().y-3.6;
                    },this)
                ));
            },this),
            cc.delayTime(0.8),
            cc.callFunc(function(){
                setSpriteTxture(this.man,"k_ljddg_man_walk.png");

                this.man.runAction(cc.sequence(
                    cc.delayTime(0.3),
                    cc.sequence(
                        cc.rotateTo(0.2,-3),
                        cc.rotateTo(0.2,0)
                    ).repeat(3)
                ));

                this.loserManThrowStone();
            },this),
            cc.delayTime(0.3),
            cc.moveTo(1.2,cc.p(winCenter().x+161.5,winCenter().y-47.9)),
            cc.callFunc(function(){
                this.stone1.removeFromParent();
                setSpriteTxture(this.man,"k_ljddg_man_nashitou01.png");
            },this)
        ));
    },
    loserManThrowStone:function(){
        var loserManAction=getAnimation(0.2,["k_ljddg_hou_reng02.png","k_ljddg_hou_reng03.png"]);
        var loserManAction2=getAnimation(0.2,["k_ljddg_hou_jianxiao01.png","k_ljddg_hou_jianxiao02.png"]);

        this.loserMan.stopAllActions();
        setSpriteTxture(this.loserMan,"k_ljddg_hou_walk.png");
        this.loserMan.runAction(cc.sequence(
            cc.rotateTo(0.2,3),
            cc.rotateTo(0.2,0)
        ).repeat(4));

        this.loserMan.runAction(cc.sequence(
            cc.moveTo(1,cc.p(winCenter().x-183.6,winCenter().y-161.8)),
            cc.callFunc(function(){
                this.stone2.visible=false;
                setSpriteTxture(this.loserMan,"k_ljddg_hou_reng01.png");
            },this),
            loserManAction,
            cc.callFunc(function(){
                playEffect(res_sound.fly_mp3);
                this.stone2.visible=true;
                setSpriteTxture(this.stone2,"k_ms_stone_fly.png");
                this.stone2.rotation=20;
                this.stone2.x=winCenter().x-108.1;
                this.stone2.y=winCenter().y+54.8;
                this.stone2.runAction(cc.sequence(
                    cc.moveTo(0.4,cc.p(winCenter().x+179.5,winCenter().y+180.4)),
                    cc.callFunc(function(){
                        playEffect(res_sound.broken_mp3);
                        setSpriteTxture(this.windows,"k_ms_window_broken.png");

                        var boom=createLevelSprite("k_zxx_boom_1.png");
                        boom.attr({
                            scale:0.5,
                            x:winCenter().x+222.2,
                            y:winCenter().y+196.4
                        });
                        this.addChild(boom);
                        boom.runAction(cc.sequence(
                            cc.delayTime(0.2),
                            cc.removeSelf()
                        ));
                    },this),
                    cc.removeSelf()
                ))
            },this),
            cc.delayTime(0.5),
            cc.spawn(
                cc.sequence(
                    cc.rotateTo(0.2,3),
                    cc.rotateTo(0.2,0)
                ).repeat(2),
                cc.moveTo(0.8,cc.p(-this.loserMan.width,winCenter().y-161.8))
            ),
            cc.callFunc(function(){
                playEffect(res_sound.openDoor_mp3);
                setSpriteTxture(this.door,"k_ljddg_men03.png");
                this.door.setLocalZOrder(1);

                setSpriteTxture(this.man,"k_ljddg_man_nashitou02.png");

                //大妈
                var dama=createLevelSprite("k_100_mom_3.png");
                dama.attr({
                    x:winCenter().x-163.1,
                    y:winCenter().y+18.9,
                    anchorY:0.2
                });
                this.addChild(dama,1);

                dama.runAction(cc.sequence(
                    cc.delayTime(0.2),
                    cc.callFunc(function(){
                        setSpriteTxture(dama,"k_ljddg_damashengqi.png");
                        dama.y+=20;
                    },this),
                    cc.delayTime(0.7),
                    cc.callFunc(function(){
                        dama.runAction(cc.sequence(
                            cc.rotateTo(0.2,3),
                            cc.rotateTo(0.2,0)
                        ).repeat(2));
                    },this),
                    cc.moveTo(0.3,cc.p(winCenter().x-107.1,winCenter().y-39.5)),
                    cc.moveTo(0.5,cc.p(winCenter().x+90,winCenter().y-39.5)),
                    cc.rotateTo(0.2,-15),
                    cc.rotateTo(0.2,15),
                    cc.callFunc(function(){
                        var hand=createLevelSprite("k_com_bighand1.png");
                        hand.attr({
                            x:133.5,
                            y:88.3,
                            scale:0.7
                        });
                        dama.addChild(hand);
                        shotDead(this.man,function(){
                            showGameOver("throwStone");
                        });
                    },this),
                    cc.rotateTo(0.2,0)
                ));
            },this),
            cc.delayTime(2),
            cc.spawn(
                cc.rotateTo(0.4,20),
                cc.moveBy(0.4,cc.p(this.loserMan.width,0))
            ),
            cc.callFunc(function(){
                this.getParent().setLoserNameTag(this.loserMan,null,80);
                playEffect(res_sound.laugh_boy_mp3);
            },this),
            loserManAction2.repeat(6)
        ));
    },
    ringDoorBell:function(){
        this.isTouch=false;
        setSpriteTxture(this.man,"k_ljddg_man_walk.png");

        this.man.runAction(cc.sequence(
            cc.rotateTo(0.2,-3),
            cc.rotateTo(0.2,0)
        ).repeat(3));

        playEffect(res_sound.walk_mp3);
        this.man.runAction(cc.sequence(
            cc.moveTo(1.2,cc.p(winCenter().x-207,winCenter().y+15)),
            cc.callFunc(function(){
                playEffect(res_GameSceneMischief_sound.ringDoorBell_mp3);
                setSpriteTxture(this.man,"k_ljddg_man_anmenling.png");
                this.doorbell.runAction(cc.sequence(
                    cc.scaleTo(0.3,1),
                    cc.scaleTo(0.3,1.2)
                ).repeat(5));
            },this),
            cc.sequence(
                cc.rotateTo(0.3,-3),
                cc.rotateTo(0.3,0)
            ).repeat(5),
            cc.callFunc(this.manSurprised,this)
        ));
    },
    manSurprised:function(){
        //惊讶
        var surprised=createLevelSprite("k_ljddg_a.png");
        surprised.attr({
            x:this.man.width+30,
            y:this.man.height
        });
        this.man.addChild(surprised);
        surprised.runAction(cc.sequence(
            cc.sequence(
                cc.rotateTo(0.2,-5),
                cc.rotateTo(0.2,0)
            ).repeat(4),
            cc.removeSelf()
        ));

        setSpriteTxture(this.man,"k_ljddg_man_jingya01.png");
        this.man.x+=40;

        var manAction=getAnimation(0.2,["k_ljddg_man_jingya01.png","k_ljddg_man_jingya02.png"]);
        this.man.runAction(cc.sequence(
            manAction.repeat(4),
            cc.callFunc(function(){
                setSpriteTxture(this.man,"k_ljddg_man.png");
            },this),
            cc.moveBy(0.3,cc.p(-20,-180)),
            cc.moveBy(0.3,cc.p(-this.man.x-this.man.width/2,0))
        ));

        this.loserMan.stopAllActions();
        this.loserMan.runAction(cc.sequence(
            cc.delayTime(0.4),
            cc.callFunc(function(){
                setSpriteTxture(this.loserMan,"k_ljddg_hou_walk.png");
                this.loserMan.runAction(cc.sequence(
                    cc.sequence(
                        cc.rotateTo(0.2,3),
                        cc.rotateTo(0.2,0)
                    ).repeat(4),
                    cc.callFunc(function(){
                        setSpriteTxture(this.loserMan,"k_ljddg_hou_kan.png");
                    },this),
                    cc.rotateTo(0.2,-3),
                    cc.rotateTo(0.2,0),
                    cc.callFunc(function(){
                        playEffect(res_sound.openDoor_mp3);
                        setSpriteTxture(this.door,"k_ljddg_men03.png");
                        this.door.setLocalZOrder(1);

                        //大妈
                        var dama=createLevelSprite("k_100_mom_3.png");
                        dama.attr({
                            x:winCenter().x-163.1,
                            y:winCenter().y+98.4-dama.height*0.3,
                            anchorY:0.2
                        });
                        this.addChild(dama,1);

                        dama.runAction(cc.sequence(
                            cc.delayTime(0.2),
                            cc.callFunc(function(){
                                setSpriteTxture(dama,"k_ljddg_damashengqi.png");
                                dama.y+=10;
                            },this),
                            cc.delayTime(0.7),
                            cc.callFunc(function(){
                                dama.runAction(cc.sequence(
                                    cc.rotateTo(0.2,3),
                                    cc.rotateTo(0.2,0)
                                ).repeat(2));
                            },this),
                            cc.moveTo(0.3,cc.p(winCenter().x-107.1,winCenter().y+77.2-dama.height*0.3)),
                            cc.moveTo(0.5,cc.p(winCenter().x+36.1,winCenter().y+76-dama.height*0.3)),
                            cc.rotateTo(0.2,-15),
                            cc.rotateTo(0.2,15),
                            cc.callFunc(function(){
                                this.loserMan.shotDeadImg=this.loserMan.shotFlyImg=getResImg("k_ljddg_hou_die.png");
                                var hand=createLevelSprite("k_com_bighand1.png");
                                hand.attr({
                                    x:133.5,
                                    y:88.3,
                                    scale:0.7
                                });
                                dama.addChild(hand);
                                shotDead(this.loserMan,function(){
                                    showGameWin();
                                });

                                this.man.runAction(cc.sequence(
                                    cc.place(-this.man.width/2,this.man.y),
                                    cc.spawn(
                                        cc.rotateTo(0.2,30),
                                        cc.moveBy(0.2,cc.p(30,0))
                                    ),
                                    cc.callFunc(function(){
                                        playEffect(res_sound.laugh_boy_mp3);
                                    },this),
                                    cc.sequence(
                                        cc.rotateBy(0.2,-3),
                                        cc.rotateBy(0.2,3)
                                    ).repeat(4)
                                ));
                            },this),
                            cc.rotateTo(0.2,0)
                        ));

                    },this),
                    cc.rotateTo(0.2,-5),
                    cc.rotateTo(0.2,0)
                ));
            },this),
            cc.moveTo(1.2,cc.p(winCenter().x+131.6,winCenter().y-33.5))
        ));
    },
    knockTheDoor:function(){
        this.isTouch=false;
        setSpriteTxture(this.man,"k_ljddg_man_walk.png");

        this.man.runAction(cc.sequence(
            cc.rotateTo(0.2,-3),
            cc.rotateTo(0.2,0)
        ).repeat(3));

        playEffect(res_sound.walk_mp3);
        var manAction=getAnimation(0.2,["k_ljddg_man_tuo02.png","k_ljddg_man_tuo03.png"]);
        this.man.runAction(cc.sequence(
            cc.moveTo(1.2,cc.p(winCenter().x-125,winCenter().y+15)),
            cc.delayTime(0.4),
            cc.callFunc(function(){
                setSpriteTxture(this.man,"k_ljddg_man_paimen.png");
                this.man.x+=15;

                playEffect(res_GameSceneMischief_sound.knockDoor_mp3);
                var hitDoorAction=getAnimation(0.2,["k_ms_door_hit.png","k_ms_door_close.png"]);
                this.door.runAction(hitDoorAction.repeat(4));
            },this),
            cc.sequence(
                cc.rotateTo(0.2,-5),
                cc.rotateTo(0.2,0)
            ).repeat(2),
            cc.callFunc(function(){
                playEffect(res_GameSceneMischief_sound.knockDoor_mp3);
            },this),
            cc.sequence(
                cc.rotateTo(0.2,-5),
                cc.rotateTo(0.2,0)
            ).repeat(2),
            cc.callFunc(function(){
                setSpriteTxture(this.man,"k_ljddg_man_tuo01.png");
                this.man.x-=20;
            },this),
            manAction,
            cc.callFunc(function(){
                playEffect(res_sound.openDoor_mp3);
                setSpriteTxture(this.door,"k_ljddg_men03.png");
                this.door.setLocalZOrder(1);

                //大妈
                var dama=createLevelSprite("k_100_mom_3.png");
                dama.attr({
                    x:winCenter().x-163.1,
                    y:winCenter().y+98.4-dama.height*0.3,
                    anchorY:0.2
                });
                this.addChild(dama,1);

                dama.runAction(cc.sequence(
                    cc.delayTime(0.3),
                    cc.callFunc(function(){
                        setSpriteTxture(dama,"k_ljddg_damashengqi.png");
                        dama.y+=10;

                        var dialog=createLevelSprite("k_jbthy_box_woman.png");
                        dialog.attr({
                            anchorX:0.1,
                            anchorY:0.1,
                            x:winCenter().x-125,
                            y:winCenter().y+204.3,
                            rotation:-15
                        });
                        this.addChild(dialog,1);
                        dialog.runAction(cc.sequence(
                            cc.rotateTo(0.2,-7),
                            cc.rotateTo(0.2,-15)
                        ).repeat(3));

                        var dialogLabel=new cc.LabelTTF("打死你这个变态！！","",26,cc.size(160,95),cc.TEXT_ALIGNMENT_CENTER);
                        dialogLabel.attr({
                            x:dialog.width/2,
                            y:dialog.height/2-20,
                            color:cc.color(0,0,0)
                        });
                        dialog.addChild(dialogLabel);
                    },this),
                    cc.delayTime(1),
                    cc.rotateTo(0.2,-15),
                    cc.rotateTo(0.2,15),
                    cc.callFunc(function(){
                        var hand=createLevelSprite("k_com_bighand1.png");
                        hand.attr({
                            x:133.5,
                            y:88.3,
                            scale:0.7
                        });
                        dama.addChild(hand);
                        shotDead(this.man,function(){
                            showGameOver("knockTheDoor");
                        });
                    },this),
                    cc.rotateTo(0.2,0)
                ));
            },this),
            cc.sequence(
                cc.skewBy(0.2,0,5),
                cc.skewBy(0.2,0,-5)
            ).repeat(4)
        ));

        var loserManAction=getAnimation(0.2,["k_ljddg_hou_tuo02.png","k_ljddg_hou_tuo03.png"]);
        this.loserMan.runAction(cc.sequence(
            cc.delayTime(2),
            cc.callFunc(function(){
                this.loserMan.stopAction(this.loserMan.animationAction);
                setSpriteTxture(this.loserMan,"k_ljddg_hou_walk.png");
            },this),
            cc.moveTo(1.2,cc.p(winCenter().x-49,winCenter().y-59.5)),
            cc.callFunc(function(){
                setSpriteTxture(this.loserMan,"k_ljddg_hou_tuo01.png");
            },this),
            loserManAction,
            cc.spawn(
                cc.sequence(
                    cc.rotateTo(0.15,15),
                    cc.rotateTo(0.15,0),
                    cc.rotateTo(0.15,15),
                    cc.rotateTo(0.15,0)
                ),
                cc.moveBy(0.6,cc.p(155,0))
            ),
            cc.callFunc(function(){
                playEffect(res_sound.laugh_boy_mp3);
                setSpriteTxture(this.loserMan,"k_ljddg_hou_jianxiao01.png");
                setAnimation(this.loserMan,0.15,["k_ljddg_hou_jianxiao01.png","k_ljddg_hou_jianxiao02.png"]);
            },this)

        ));
    }
});

var GameSceneMischief=GameSceneBase.extend({
    ctor:function(){
        this._super();
        this.layer=new MischiefLayer();
        this.addChild(this.layer);
        this.setMyNameTag(this.layer.man);
        this.setLoserNameTag(this.layer.loserMan);
    }
});