/**
 * Created by eeee on 16/1/29.
 */
var OpenDoorTrickyLayer=cc.Layer.extend({
    isTouch:false,
    man:null,
    loserMan:null,
    door:null,
    cactus:null,
    bucket:null,
    manMove:false,
    ctor:function(){
        this._super();

        //背景
        var bg=createLevelSprite("k_kmzr_bg.png");
        bg.attr({
            anchorY:1,
            x:winCenter().x,
            y:cc.winSize.height
        });
        this.addChild(bg);

        //窗
        var windows=createLevelSprite("k_kmzr_chuang.png");
        windows.attr({
            x:winCenter().x+174.3,
            y:winCenter().y+180.5
        });
        this.addChild(windows,1);

        //门
        this.door=createLevelSprite("k_kmzr_men01.png");
        this.door.attr({
            x:winCenter().x-91,
            y:winCenter().y+76
        });
        this.addChild(this.door,1);
        addTouchCallBack(this.door,function(){
            if(!this.isTouch)return;
            removeListener(this.door);
            this.isTouch=false;
            this.manOpenDoor();
        }.bind(this));

        //桌子
        var table=createLevelSprite("k_kmzr_zuozi.png");
        table.attr({
            x:winCenter().x+256.5,
            y:winCenter().y-125.8
        });
        this.addChild(table);

        //仙人掌
        this.cactus=createLevelSprite("k_kmzr_xianrenzhang01.png");
        this.cactus.attr({
            x:winCenter().x+82.2,
            y:winCenter().y-52.3
        });
        this.addChild(this.cactus);
        addTouchCallBack(this.cactus,function(){
            if(!this.isTouch)return;
            removeListener(this.cactus);
            this.isTouch=false;
            this.manSetCactus();
        }.bind(this));

        //水桶
        this.bucket=createLevelSprite("k_kmzr_shuitong01.png");
        this.bucket.attr({
            x:winCenter().x-265.2,
            y:winCenter().y-141.9
        });
        this.addChild(this.bucket,2);
        addTouchCallBack(this.bucket,function(){
            if(!this.isTouch)return;
            removeListener(this.bucket);
            this.isTouch=false;
            this.manPourWater();
        }.bind(this));

        //窗遮罩
        var windowsMask=createLevelSprite("k_kmzr_chuang.png");
        windowsMask.attr({
            x:winCenter().x+174.3,
            y:winCenter().y+180.5,
            scale:0.8
        });

        //裁剪节点
        var clipping=new cc.ClippingNode(windowsMask);
        this.addChild(clipping);

        //被整人
        this.loserMan=createLevelSprite("k_kmzr_feng.png");
        this.loserMan.attr({
            x:winCenter().x+176.8,
            y:winCenter().y+6
        });
        clipping.addChild(this.loserMan);
        this.loserMan.runAction(cc.sequence(
            cc.delayTime(0.3),
            cc.moveBy(0.6,cc.p(-30,30)),
            cc.moveBy(0.4,cc.p(30,-30)),
            cc.delayTime(0.3),
            cc.moveBy(0.5,cc.p(20,30)),
            cc.moveBy(0.4,cc.p(-20,-30)),
            cc.delayTime(0.5),
            cc.moveBy(0.6,cc.p(0,100)),
            cc.moveTo(0.6,cc.p(winCenter().x+53.5,winCenter().y+106)),
            cc.removeSelf()
        ));

        //门遮罩
        var doorMask=createLevelSprite("k_kmzr_men01.png");
        doorMask.attr({
            x:winCenter().x-91,
            y:winCenter().y+76,
            scale:0.9
        });

        //门裁剪节点
        this.clipping=new cc.ClippingNode(doorMask);
        this.addChild(this.clipping);

        //门遮罩里的被整人
        var loserMan=createLevelSprite("k_kmzr_feng.png");
        loserMan.attr({
            x:winCenter().x+53.5,
            y:winCenter().y+106
        });
        this.clipping.addChild(loserMan);
        loserMan.runAction(cc.sequence(
            cc.delayTime(4.2),
            cc.callFunc(function(){
                this.loserMan=loserMan;
                this.getParent().removeLoserNameTag();
                this.isTouch=true;
            },this)
        ));

        //史小坑
        this.man=createLevelSprite("k_kmzr_man_zoulu01.png");
        this.man.attr({
            x:winCenter().x-242.8,
            y:winCenter().y+37.3
        });
        this.addChild(this.man,1);
    },
    loserManOpenDoor:function(callback,delayTime){
        this.getParent().setLoserNameTag(this.loserMan);
        this.loserMan.runAction(cc.sequence(
            cc.delayTime(delayTime || 0.001),
            cc.moveTo(0.8,cc.p(winCenter().x-64.8,winCenter().y+106)),
            cc.callFunc(function(){
                setSpriteTxture(this.door,"k_kmzr_men02.png");
                if(callback)callback();
            },this)
        ));
    },
    manPourWater:function(){
        playEffect(res_GameSceneOpenDoorTricky_sound.pourWater_mp3);
        setSpriteTxture(this.bucket,"k_kmzr_shuitong02.png");
        this.bucket.attr({x:winCenter().x-97.1,y:winCenter().y-159.3});
        this.bucket.runAction(cc.sequence(
            cc.delayTime(0.2),
            cc.callFunc(function(){
                setSpriteTxture(this.bucket,"k_kmzr_shuitong03.png");
            },this)
        ));

        var manLuaghAction=getAnimation(0.15,["k_kmzr_man_jianxiao01.png","k_kmzr_man_jianxiao02.png"]);
        this.man.runAction(cc.sequence(
            cc.spawn(
                cc.sequence(
                    cc.rotateTo(0.15,3),
                    cc.rotateTo(0.15,0),
                    cc.rotateTo(0.15,3),
                    cc.rotateTo(0.15,0)
                ),
                cc.moveTo(1,cc.p(winCenter().x+115.8,winCenter().y-15))
            ),
            cc.moveTo(0.2,cc.p(winCenter().x+133.2,winCenter().y+-44.9)),
            cc.callFunc(function(){
                playEffect(res_sound.laugh_boy_mp3);

                this.loserManOpenDoor(function(){
                    this.loserMan.runAction(cc.sequence(
                        cc.moveTo(0.2,cc.p(winCenter().x+-39.9,winCenter().y+21.3)),
                        cc.callFunc(function(){
                            var loserMan=createLevelSprite("k_kmzr_feng.png");
                            loserMan.attr({
                                x:winCenter().x-39.9,y:winCenter().y+21.3
                            });
                            this.addChild(loserMan,4);

                            this.loserMan.removeFromParent();
                            this.loserMan=loserMan;
                            this.getParent().setLoserNameTag(this.loserMan);

                            var loserManAction=getAnimation(0.2,["k_kmzr_feng_shuaidao01.png","k_kmzr_feng_shuaidao02.png"]);
                            this.loserMan.runAction(cc.sequence(
                                cc.moveTo(0.5,cc.p(winCenter().x+-27.4,winCenter().y+-48.4)),
                                cc.callFunc(function(){
                                    playEffect(res_GameSceneOpenDoorTricky_sound.slip_mp3);
                                },this),
                                loserManAction.repeat(5),
                                cc.callFunc(function(){
                                    setSpriteTxture(this.loserMan,"k_kmzr_feng_kiss01.png");
                                    this.loserMan.attr({x:winCenter().x+14.9,y:winCenter().y-58});

                                    setSpriteTxture(this.man,"k_kmzr_man_kiss01.png");
                                    this.man.attr({x:winCenter().x+148.1,y:winCenter().y+-49.9});
                                },this),
                                cc.delayTime(0.2),
                                cc.callFunc(function(){
                                    setSpriteTxture(this.loserMan,"k_kmzr_feng_kiss02.png");
                                    this.loserMan.attr({x:winCenter().x+50,y:winCenter().y-59.1});

                                    setSpriteTxture(this.man,"k_kmzr_man_kiss02.png");
                                    this.man.attr({x:winCenter().x+166.8,y:winCenter().y+-47.4});
                                },this),
                                cc.moveBy(0.2,cc.p(-3,0)),
                                cc.callFunc(function(){
                                    var heart=createLevelSprite("k_kmzr_xin.png");
                                    heart.attr({x:winCenter().x+146.9,y:winCenter().y+11.2,scale:0.3,opacity:0});
                                    this.addChild(heart,5);
                                    heart.runAction(cc.sequence(
                                        cc.spawn(
                                            cc.fadeIn(0.5),
                                            cc.scaleTo(0.5,1.3)
                                        ),
                                        cc.spawn(
                                            cc.fadeOut(0.5),
                                            cc.scaleTo(0.5,2.3)
                                        ),
                                        cc.removeSelf()
                                    ));
                                },this),
                                cc.delayTime(2),
                                cc.callFunc(function(){
                                    showGameOver("manPourWater");
                                },this)
                            ));
                        },this)
                    ));
                }.bind(this))
            },this),
            manLuaghAction.repeat(10)
        ));
    },
    manOpenDoor:function(){
        var manAction=getAnimation(0.2,["k_kmzr_man_kaimen02.png","k_kmzr_man_kaimen01.png"]);
        this.man.runAction(cc.sequence(
            cc.spawn(
                cc.sequence(
                    cc.rotateTo(0.15,3),
                    cc.rotateTo(0.15,0),
                    cc.rotateTo(0.15,3),
                    cc.rotateTo(0.15,0)
                ),
                cc.moveTo(0.6,cc.p(winCenter().x-62.3,winCenter().y+2.5))
            ),
            cc.callFunc(function(){
                setSpriteTxture(this.man,"k_kmzr_man_kaimen01.png");
                this.loserManOpenDoor(function(){
                    setSpriteTxture(this.loserMan,"k_kmzr_feng_jinmen01.png");
                    this.loserMan.attr({x:winCenter().x+-49.9,y:winCenter().y+59.9});
                    setSpriteTxture(this.man,"k_kmzr_man_bainle01.png");
                    this.man.attr({x:winCenter().x+-149.0,y:winCenter().y+31.0});

                    playEffect(res_sound.peng_mp3);
                    this.man.runAction(cc.sequence(
                        cc.delayTime(0.2),
                        cc.callFunc(function(){
                            setSpriteTxture(this.door,"k_kmzr_men03.png");

                            this.clipping.setLocalZOrder(2);
                            setSpriteTxture(this.loserMan,"k_kmzr_feng_jinmen02.png");
                            this.loserMan.attr({x:winCenter().x-113.4,y:winCenter().y+45});

                            playEffect(res_sound.scream_mp3);
                            setSpriteTxture(this.man,"k_kmzr_man_bainle02.png");
                            this.man.attr({x:winCenter().x-252.3,y:winCenter().y+31.0});
                            this.man.setLocalZOrder(0);

                            //啪
                            var pa=createLevelSprite("k_kmzr_man_bainle_pa.png");
                            pa.attr({x:winCenter().x-199.2,y:winCenter().y+373.5});
                            this.addChild(pa,2);

                            playEffect(res_sound.laugh_boy_mp3);

                            this.loserMan.runAction(cc.sequence(
                                cc.rotateTo(0.2,-3),
                                cc.rotateTo(0.2,0),
                                cc.rotateTo(0.2,3),
                                cc.rotateTo(0.2,0)
                            ).repeat(2));
                        },this),
                        cc.delayTime(1.5),
                        cc.callFunc(function(){
                            showGameOver("manOpenDoor");
                        },this)
                    ));
                }.bind(this));
            },this),
            manAction.repeat(2)
        ));
    },
    manSetCactus:function(){
        var manAction=getAnimation(0.1,["k_kmzr_man_reng01.png","k_kmzr_man_reng02.png","k_kmzr_man_reng03.png"]);
        var manLuaghAction=getAnimation(0.15,["k_kmzr_man_jianxiao01.png","k_kmzr_man_jianxiao02.png"]);
        this.man.runAction(cc.sequence(
                cc.rotateTo(0.15,3),
                cc.rotateTo(0.15,0)
        ).repeat(4));
        this.man.runAction(cc.sequence(
            cc.moveTo(1.2,cc.p(winCenter().x+112.1,winCenter().y+11.2)),
            cc.callFunc(function(){
                this.cactus.visible=false;
                setSpriteTxture(this.man,"k_kmzr_man_reng01.png");
                this.man.attr({x:winCenter().x+81.0,y:winCenter().y+29.9});
            },this),
            manAction,
            cc.callFunc(function(){
                setSpriteTxture(this.man,"k_kmzr_man_reng04.png");

                this.cactus.visible=true;
                this.cactus.setLocalZOrder(4);
                this.cactus.attr({x:winCenter().x+66.0,y:winCenter().y+129.5});
                this.cactus.runAction(cc.jumpTo(0.5,cc.p(winCenter().x-6.2,winCenter().y+334.9),185,1));

                this.loserManOpenDoor(function(){
                    this.loserMan.runAction(cc.sequence(
                        cc.delayTime(0.2),
                        cc.callFunc(function(){
                            setSpriteTxture(this.door,"k_kmzr_men03.png");

                            this.clipping.setLocalZOrder(2);
                            setSpriteTxture(this.loserMan,"k_kmzr_feng_jinmen02.png");
                            this.loserMan.attr({x:winCenter().x-113.4,y:winCenter().y+45});

                            //如果史小坑设置完仙人掌移动后，仙人掌就掉到被整人头上
                            if(this.manMove){
                                this.loserMan.stopAllActions();
                                this.loserMan.runAction(cc.sequence(
                                    cc.delayTime(0.1),
                                    cc.callFunc(function(){
                                        setSpriteTxture(this.loserMan,"k_kmzr_feng.png");
                                        this.loserMan.attr({x:winCenter().x+-8.8,y:winCenter().y+13.8});
                                    },this)
                                ));
                            }
                        },this),
                        cc.delayTime(1),
                        cc.callFunc(function(){
                            setSpriteTxture(this.loserMan,"k_kmzr_feng.png");
                            this.loserMan.attr({x:winCenter().x-96.0,y:winCenter().y+32.5});
                        },this)
                    ));
                }.bind(this),1.1)
            },this),
            cc.delayTime(0.5),
            cc.callFunc(function(){
                setSpriteTxture(this.man,"k_kmzr_man_jianxiao01.png");
                this.man.attr({x:winCenter().x+112.1,y:winCenter().y+11.2});
                addTouchCallBack(this.man,function(){
                    removeListener(this.man);
                    this.manMove=true;
                    this.man.runAction(cc.moveTo(0.3,cc.p(winCenter().x+140.7,winCenter().y+-59.8)));
                }.bind(this));

                this.man.laughtAudio=playEffect(res_sound.laugh_boy_mp3);
            },this),
            manLuaghAction.repeat(5),
            cc.callFunc(function(){
                removeListener(this.man);
                if(this.manMove){
                    this.man.stopAllActions();
                    this.man.setLocalZOrder(5);

                    playEffect(res_sound.fly_peng_mp3);
                    this.cactus.runAction(cc.sequence(
                        cc.delayTime(0.2),
                        cc.moveBy(0.2,cc.p(0,-105)),
                        cc.callFunc(function(){
                            var loserMan=createLevelSprite("k_kmzr_feng_yundao02.png");
                            loserMan.attr({
                                x:this.loserMan.x,
                                y:this.loserMan.y
                            });
                            this.addChild(loserMan,3);
                            this.loserMan.removeFromParent();
                            this.loserMan=loserMan;
                            this.getParent().setLoserNameTag(this.loserMan);
                            var loserManAction=getAnimation(0.2,["k_kmzr_feng_yundao01.png","k_kmzr_feng_yundao02.png"]);
                            this.loserMan.runAction(cc.sequence(
                                loserManAction.repeat(2),
                                cc.delayTime(0.2),
                                cc.callFunc(function(){
                                    setSpriteTxture(this.loserMan,"k_kmzr_feng_yundao03.png");
                                },this),
                                cc.delayTime(0.2),
                                cc.callFunc(function(){
                                    setSpriteTxture(this.loserMan,"k_kmzr_feng_yundao04.png");
                                    this.loserMan.setLocalZOrder(4);
                                },this),
                                cc.delayTime(1.2),
                                cc.callFunc(function(){
                                    showGameWin();
                                },this)
                            ));
                        },this),
                        cc.delayTime(0.5),
                        cc.spawn(
                            cc.moveTo(0.4,cc.p(winCenter().x-89,winCenter().y-155)),
                            cc.rotateTo(0.4,-90)
                        ),
                        cc.callFunc(function(){
                            setSpriteTxture(this.cactus,"k_kmzr_xianrenzhang02.png");
                            this.cactus.rotation=0;
                        },this)
                    ));
                }else{
                    stopEffect(this.man.laughtAudio);
                    playEffect(res_sound.fly_peng_mp3);
                    this.cactus.runAction(cc.sequence(
                        cc.spawn(
                            cc.jumpTo(0.2,cc.p(winCenter().x+100.8,winCenter().y+171.8),50,1),
                            cc.rotateTo(0.2,135)
                        ),
                        cc.delayTime(0.25),
                        cc.jumpTo(0.5,cc.p(winCenter().x+153.1,winCenter().y-169.4),30,1)
                    ));
                }
            },this),
            cc.delayTime(0.5),
            cc.callFunc(function(){
                setSpriteTxture(this.man,"k_kmzr_man_zhazhong.png");
                this.man.setLocalZOrder(3);
                this.man.anchorY=0.1;
                this.man.y-=this.man.height*0.4;
            },this),
            cc.delayTime(0.25),
            cc.rotateTo(0.5,-90),
            cc.callFunc(function(){
                playEffect(res_sound.laugh_boy_mp3);
                this.loserMan.runAction(cc.sequence(
                    cc.rotateTo(0.2,-3),
                    cc.rotateTo(0.2,0),
                    cc.rotateTo(0.2,3),
                    cc.rotateTo(0.2,0)
                ).repeat(2));

                soulFluttering(this,winCenter().x-62.3,winCenter().y-46.1,110,300,function(){
                    showGameOver("manSetCactus");
                })
            },this)
        ));
    }
});

var GameSceneOpenDoorTricky=GameSceneBase.extend({
    ctor:function(){
        this._super();
        this._bgFile=getResImg("bg2.png");
        this.layer=new OpenDoorTrickyLayer();
        this.addChild(this.layer);
        this.setMyNameTag(this.layer.man);
        this.setLoserNameTag(this.layer.loserMan);
    }
});