/**
 * Created by eeee on 16/1/22.
 */
var RollBallWarLayer=cc.Layer.extend({
    isTouch:true,
    state:1,
    manDir:"right",
    hills:null,
    grounds:null,
    ground:null,
    stone:null,
    loserMan:null,
    man:null,
    moveSpeed:6,
    isFlip:false,
    ctor:function(){
        this._super();

        //太阳
        var sun=createLevelSprite("sun.png");
        sun.attr({
            scale:1.6,
            x:winCenter().x+200,
            y:winCenter().y+390
        });
        this.addChild(sun);

        //云
        var couldConfig=[
            {x:-291,y:395.5},
            {x:-119,y:277},
            {x:251.5,y:338}
        ];
        for(var i=0;i<couldConfig.length;i++){
            var could=createLevelSprite(i!=0?"k_dxz_cloud1.png":"k_dxz_cloud3.png");
            could.attr({
                scale:0.7,
                x:winCenter().x+couldConfig[i].x,
                y:winCenter().y+couldConfig[i].y
            });
            this.addChild(could);

            could.runAction(cc.sequence(
                cc.moveBy(15+Math.random()*15,cc.p(-cc.director.getWinSize().width/2,0)),
                cc.moveBy(15+Math.random()*15,cc.p(cc.director.getWinSize().width/2,0))
            ).repeatForever());
        }

        //地面
        this.ground=createSprite();
        this.ground.setTextureRect(cc.rect(0,0,1330,550));
        this.ground.attr({
            anchorY:1,
            rotation:12,
            x:winCenter().x,
            y:400,
            opacity:0
        });
        this.addChild(this.ground);

        this.hills=[];
        this.grounds=[];
        for(var i=0;i<3;i++){
            //山
            var hill=createLevelSprite("k_dxj_hill.png");
            hill.attr({
                opacity:200,
                scaleX:2.2*(i==1?-1:1),
                scaleY:2.2,
                anchorY:0,
                anchorX:i==1?1:0,
                y:480,
                x:i*hill.width*2.2
            });
            this.ground.addChild(hill,-1);
            this.hills.push(hill);

            //地
            var ground=createLevelSprite("k_gqdz_land.png");
            ground.attr({
                anchorY:0,
                y:0,
                x:i*ground.width
            });
            this.ground.addChild(ground);
            this.grounds.push(ground);
        }
        this.schedule(this.hillMove,0.01);

        //被整人
        this.loserMan=createLevelSprite("k_gqdz_evil_push_1.png");
        this.loserMan.attr({
            anchorY:0,
            x:this.ground.width/2-227,
            y:this.ground.height-8
        });
        this.ground.addChild(this.loserMan,2);
        setAnimation(this.loserMan,0.15,["k_gqdz_evil_push_1.png","k_gqdz_evil_push_2.png","k_gqdz_evil_push_3.png","k_gqdz_evil_push_2.png"]);

        //石头
        this.stone=createLevelSprite("k_gqdz_stone.png");
        this.stone.attr({
            x:this.ground.width/2-60-this.stone.width/2*0.3,
            y:this.ground.height-6+this.stone.height/2*0.7,
            scale:0.7
        });
        this.ground.addChild(this.stone,1);
        this.stone.runAction(cc.rotateBy(1,360).repeatForever());
        addTouchCallBack(this.stone,function(){
            if(!this.isTouch)return;
            this.isTouch=false;
            removeListener(this.stone);
            this.stoneLarge();
        }.bind(this));

        //史小坑
        this.man=createLevelSprite("k_gqdz_man_run_1.png");
        this.man.attr({
            anchorY:0,
            x:this.ground.width/2+100,
            y:this.ground.height-15
        });
        this.ground.addChild(this.man,2);
        setAnimation(this.man,0.15,["k_gqdz_man_run_1.png","k_gqdz_man_run_2.png"]);
        addTouchCallBack(this.man,function(){
            if(!this.isTouch)return;
            this.isTouch=false;
            removeListener(this.man);
            this.fall("touchMan");
        }.bind(this));

        this.runAction(cc.sequence(
            cc.delayTime(0.5),
            cc.callFunc(function(){
                this.isFlip=true;
            },this),
            cc.delayTime(9.5),
            cc.callFunc(this.slip,this)
        ));

        var _this=this;
        cc.inputManager.setAccelerometerInterval(1/30);    //加速计的时间间隔
        cc.inputManager.setAccelerometerEnabled(true);    //加速计开关
        cc.eventManager.addListener({
            event: cc.EventListener.ACCELERATION,
            callback: function(acc, event){
                var target=event.getCurrentTarget();
                var x=acc.x.toFixed(2);
                var y=acc.y.toFixed(2);

                if(_this.isFlip){
                    if(_this.isTouch){
                        if(x<-0.9 && y>-0.1){
                            _this.groundFlip();
                        }
                    }else{
                        cc.inputManager.setAccelerometerEnabled(false);
                        removeListener(_this);
                    }
                }
            }
        }, this);

    },
    hillMove:function(){
        if(this.state==1){
            if(this.manDir=="right"){
                for(var i=0;i<3;i++){
                    this.hills[i].x-=this.moveSpeed*0.8;
                }
                if(this.hills[1].x<=-this.hills[1].width*2.2){
                    for(var i=0;i<3;i++){
                        this.hills[i].x=i*this.hills[i].width*2.2;
                    }
                }

                for(var i=0;i<3;i++){
                    this.grounds[i].x-=this.moveSpeed;
                }
                if(this.grounds[1].x<=0){
                    for(var i=0;i<3;i++){
                        this.grounds[i].x=i*this.grounds[i].width;
                    }
                }

            }else if(this.manDir=="left"){
                for(var i=0;i<3;i++){
                    this.hills[i].x+=this.moveSpeed*0.8;
                }
                if(this.hills[1].x>=this.hills[1].width*2.2){
                    for(var i=0;i<3;i++){
                        this.hills[i].x=-i*this.hills[i].width*2.2;
                    }
                }

                for(var i=0;i<3;i++){
                    this.grounds[i].x+=this.moveSpeed;
                }
                if(this.grounds[1].x>=this.grounds[1].width){
                    for(var i=0;i<3;i++){
                        this.grounds[i].x=-(i-1)*this.grounds[i].width;
                    }
                }
            }
        }
    },
    stoneLarge:function(){
        this.moveSpeed=15;
        this.stone.stopAllActions();
        playEffect(res_sound.change_mp3);
        this.stone.runAction(cc.sequence(
            cc.spawn(
                cc.scaleTo(1,1),
                cc.moveBy(1,cc.p(this.stone.width/2*0.3,this.stone.height/2*0.3))
            ),
            cc.delayTime(0.4),
            cc.callFunc(function() {
                this.fall("touchStone");
            },this)
        ));
        this.stone.runAction(cc.rotateBy(0.3,360).repeatForever());
    },
    fall:function(faileKey){    //摔倒
        this.stopAllActions();
        this.man.stopAllActions();
        setSpriteTxture(this.man,"k_gqdz_man_run_1.png");
        this.man.x+=60;
        this.man.anchorX=1;
        this.man.anchorY=0;
        this.man.setLocalZOrder(0);
        this.man.runAction(cc.sequence(
            cc.callFunc(function(){
                this.unscheduleAllCallbacks();
            },this),
            cc.rotateBy(0.2,5),
            cc.rotateBy(0.2,-5),
            cc.callFunc(function(){
                this.getParent().setMyNameTag(this.man,null,150,-30,false);
            },this),
            cc.spawn(
                cc.rotateTo(0.5,88),
                cc.moveBy(0.5,cc.p(-45,-20))
            ),
            cc.callFunc(function(){
                playEffect(res_GameSceneRollBallWar_sound.shout_mp3);
            },this),
            cc.spawn(
                cc.scaleTo(0.3,0.2,1),
                cc.moveBy(0.3,cc.p(-10,20))
            ),
            cc.callFunc(function(){
                //灵魂
                soulFluttering(this,winCenter().x+287,winCenter().y-172,0,150,function(){
                    this.getParent().gameOver(faileKey);
                }.bind(this),2.5);

            },this)
        ));

        this.stone.runAction(cc.sequence(
            cc.delayTime(0.2),
            cc.moveBy(3,cc.p(800,0))
        ));
        this.loserMan.runAction(cc.sequence(
            cc.delayTime(0.2),
            cc.moveBy(3,cc.p(800,0))
        ));
    },
    slip:function(){    //滑倒
        if(!this.isTouch)return;
        this.isTouch=false;
        this.man.stopAllActions();
        setSpriteTxture(this.man,"k_gqdz_man_slip_1.png");
        this.man.anchorY=0;
        this.man.setLocalZOrder(0);

        this.man.runAction(cc.sequence(
            cc.spawn(
                cc.rotateTo(0.5,-83),
                cc.moveBy(0.5,cc.p(100,28))
            ),
            cc.callFunc(function(){
                this.unscheduleAllCallbacks();
                setSpriteTxture(this.man,"k_gqdz_man_slip_2.png");
                this.man.rotation=0;
                this.man.y+=10;
                this.man.x-=103;
                playEffect(res_GameSceneRollBallWar_sound.shout_mp3);
            },this),
            cc.spawn(
                cc.scaleTo(0.3,1,0.2),
                cc.moveBy(0.3,cc.p(10,-40))
            ),
            cc.callFunc(function(){
                //灵魂
                soulFluttering(this,winCenter().x+58,winCenter().y-127,0,150,function(){
                    this.getParent().gameOver("slipDie");
                }.bind(this),2.5);

            },this)
        ));

        this.stone.runAction(cc.sequence(
            cc.delayTime(0.3),
            cc.moveBy(3,cc.p(800,0))
        ));
        this.loserMan.runAction(cc.sequence(
            cc.delayTime(0.3),
            cc.moveBy(3,cc.p(800,0))
        ));
    },
    groundFlip:function(){
        if(!this.isTouch)return;
        this.isTouch=false;
        this.stopAllActions();
        this.state=-1;
        this.manDir="left";
        //this.ground.rotation=-12;
        this.ground.runAction(cc.rotateTo(0.2,-12));


        this.man.stopAllActions();
        setSpriteTxture(this.man,"k_gqdz_man_run_1.png");
        this.man.anchorY=0;

        this.loserMan.stopAllActions();
        //this.loserMan.x+=35;
        //this.loserMan.y+=80;
        //this.loserMan.rotation=15;
        this.loserMan.runAction(cc.sequence(
            //cc.delayTime(0.4),
            //cc.moveBy(0.2,cc.p(0,-78)),
            cc.moveBy(0.2,cc.p(0,2)),
            cc.delayTime(0.2),
            cc.callFunc(function(){
                this.gameWin();
            },this)
        ));

        this.stone.stopAllActions();
        this.stone.x+=50;
        this.stone.y+=40;
        this.stone.runAction(cc.sequence(
            //cc.delayTime(0.4),
            cc.moveBy(0.2,cc.p(0,-40))
        ));
    },
    gameWin:function(){
        cc.inputManager.setAccelerometerEnabled(false);
        removeListener(this);

        this.state=1;
        this.stone.runAction(cc.rotateBy(1,-360).repeatForever());

        setAnimation(this.man,0.15,["k_gqdz_man_push_1.png","k_gqdz_man_push_2.png","k_gqdz_man_push_3.png","k_gqdz_man_push_2.png"]);
        this.man.x-=25;
        this.man.y+=10;
        this.man.anchorY=0;

        setAnimation(this.loserMan,0.15,["k_gqdz_evil_run_1.png","k_gqdz_evil_run_2.png"]);
        this.loserMan.rotation=0;
        this.loserMan.setLocalZOrder(0);
        this.getParent().setLoserNameTag(this.loserMan,null,-45,null,false);

        //成功逆袭
        var title=createLevelSprite("k_gqdz_title.png");
        title.attr({
            x:winCenter().x-10,
            y:winCenter().y+120
        });
        this.addChild(title);
        title.runAction(cc.sequence(
            cc.scaleTo(0.4,0.8),
            cc.scaleTo(0.4,1),
            cc.scaleTo(0.4,0.8),
            cc.scaleTo(0.4,1),
            cc.scaleTo(0.4,0.8),
            cc.callFunc(function(){
                this.state=-1;

                this.loserMan.stopAllActions();
                this.loserMan.runAction(cc.sequence(
                    cc.delayTime(0.3),
                    cc.rotateTo(0.3,-88),
                    cc.callFunc(function(){
                        playEffect(res_GameSceneRollBallWar_sound.shout_mp3);
                    },this),
                    cc.delayTime(0.2),
                    cc.scaleTo(0.3,0.2,1),
                    cc.callFunc(function(){
                        //灵魂
                        soulFluttering(this,winCenter().x-278,winCenter().y-178,40,150,function(){
                            this.getParent().gameWin();
                        }.bind(this),2.5);

                    },this)
                ));

                this.stone.runAction(cc.moveBy(3,cc.p(-700,0)));
                this.man.runAction(cc.moveBy(3,cc.p(-700,0)));
            },this),
            cc.removeSelf()
        ));
    }
});


var GameSceneRollBallWar=GameSceneBase.extend({
    onEnter:function(){
        this._super();
        this.layer=new RollBallWarLayer();
        this.addChild(this.layer);
        this.setMyNameTag(this.layer.man,null,null,null,false);
        this.setLoserNameTag(this.layer.loserMan,null,39.5,null,false);

        this.stopAllActions();
    },
    pauseTheGame:function(){
        if(this.layer.state!=-1){
            this.layer.state=0;
        }
    },
    resumeTheGame:function(){
        if(this.layer.state!=-1){
            this.layer.state=1;
        }
        //this.layer.groundFlip();
    },
    shakeSkill:function(){
        this.layer.groundFlip();
    }
});