/**
 * Created by eeee on 16/1/31.
 */
var ShootPigHeadLayer=cc.Layer.extend({
    state:1,
    isTouch:true,
    scoreLabel:null,
    bigHead:null,
    man:null,
    moveArr:null,
    flyCutter:null,
    hitCount:0,
    shakeCount:0,
    ctor:function(){
        this._super();
        this.moveArr=[];

        //背景
        var bg=createLevelSprite("k_szt_bg.png");
        bg.attr({x:winCenter().x-12.4,y:winCenter().y+73.5});
        this.addChild(bg);

        //分数
        this.scoreLabel=new cc.LabelTTF("分数："+(this.hitCount*10),"",40);
        this.scoreLabel.attr({
            x:winCenter().x,
            y:winCenter().y+450,
            color:cc.color(73,45,19)
        });
        this.addChild(this.scoreLabel);

        //装饰
        for(var i=0;i<2;i++){
            var decorate=createLevelSprite("k_szt_zhuangshi.png");
            decorate.attr({
                x:winCenter().x-1.2,
                y:winCenter().y+400-i*673,
                scaleY:i==1?-1:1
            });
            this.addChild(decorate);
        }

        //猪头
        this.bigHead=new ShootPigHeadSprite_pigHead("k_szt_pig_daiji.png");
        this.bigHead.attr({x:winCenter().x+-11.2,y:winCenter().y+189.3});
        this.addChild(this.bigHead,1);
        this.bigHead.standBy();
        this.moveArr.push(this.bigHead);

        //史小坑
        this.man=createLevelSprite("k_szt_people_reng.png");
        this.man.attr({x:winCenter().x+-44.8,y:winCenter().y+-336.2,scale:0.7});
        this.addChild(this.man,3);

        addTouchCallBack(this,function(touch){
            var posX=touch.getLocation().x;
            this.man.runAction(cc.sequence(
                cc.moveTo(0.05,cc.p(posX,this.man.y)),
                cc.callFunc(function(){
                    setSpriteTxture(this.man,"k_szt_people_reng2.png");
                    this.createFlyCutter();
                },this),
                cc.delayTime(0.2),
                cc.callFunc(function(){
                    setSpriteTxture(this.man,"k_szt_people_reng.png");
                },this)
            ));
        });
        this.beganCallback=function(touch){
            if(this.isTouch){
                this.isTouch=false;
                return true;
            }
            return false;
        };

        this.scheduleUpdate();

        var _this=this;
        var shakeCnt=0;
        cc.inputManager.setAccelerometerInterval(1/30);
        cc.inputManager.setAccelerometerEnabled(true);
        cc.eventManager.addListener({
            event: cc.EventListener.ACCELERATION,
            callback: function(acc, event){
                var target=event.getCurrentTarget();
                var x=acc.x;
                var y=acc.y;
                var z=acc.z;
                var all= x*x + y*y + z*z;

                if(all<1.2){
                    if (shakeCnt>2) {
                        _this.addShakeCount();
                    }
                    shakeCnt=0;
                }else if (all>2){
                    shakeCnt++;
                }
            }
        }, this);
    },
    addShakeCount:function(){
        this.shakeCount++;
        if(this.shakeCount==2){
            this.pigHeadHalo();
        }
    },
    pigHeadHalo:function(){
        this.isTouch=false;
        removeListener(this);
        this.unscheduleAllCallbacks();

        for(var i=0;i<this.moveArr.length;i++){
            this.moveArr[i].moveState=0;
        }
        this.bigHead.halo();
    },
    createFlyCutter:function(){
        this.flyCutter=createLevelSprite("k_szt_people_dao.png");
        this.flyCutter.attr({
            x:this.man.x+45,
            y:this.man.y+116,
            anchorY:0.8
        });
        this.addChild(this.flyCutter,2);

        playEffect(res_sound.launch_mp3);
        this.flyCutter.runAction(cc.sequence(
            cc.moveTo(1,cc.p(this.flyCutter.x,cc.winSize.height+this.flyCutter.height)),
            cc.callFunc(function(){
                this.flyCutter=null;
            },this),
            cc.delayTime(0.2),
            cc.removeSelf(),
            cc.callFunc(function(){
                this.superBomb();
            },this)
        ));

    },
    bombDrop:function(target){
        target.setLocalZOrder(4);
        playEffect(res_sound.fly_mp3);
        target.runAction(cc.sequence(
            cc.moveTo(0.3,cc.p(target.x,this.man.y)),
            cc.callFunc(function(){
                explosion(this,target.getPosition(),function(){
                    this.manBombAction("pigBomb");
                }.bind(this));
            },this),
            cc.removeSelf()
        ));
    },
    manBombAction:function(faileKey){
        var manAction=getAnimation(0.2,[
            "k_szt_people_black1.png",
            "k_szt_people_black2.png",
            "k_szt_people_black3.png",
            "k_szt_people_black4.png"
        ]);
        setSpriteTxture(this.man,"k_szt_people_black1.png");
        this.man.x+=30;
        this.man.y+=20;
        this.man.runAction(cc.sequence(
            manAction.repeat(2),
            cc.callFunc(function(){
                showGameOver(faileKey);
            },this)
        ));
    },
    superBomb:function(){
        var _this=this;
        var num=Math.floor(cc.winSize.width/150);
        for(var i=0;i<num;i++){
            var pigBomb=createLevelSprite("k_szt_pig_small.png");
            pigBomb.attr({
                x:pigBomb.width+i*150,
                y:cc.winSize.height
            });
            this.addChild(pigBomb);
            pigBomb.bombNum=i+1;
            pigBomb.runAction(cc.sequence(
                cc.delayTime(0.2+i*0.2),
                cc.callFunc(function(){
                    playEffect(res_sound.fly_mp3);
                },this),
                cc.moveTo(1,cc.p(pigBomb.x,this.man.y)),
                cc.callFunc(function(){
                    explosion(this.getParent(),this.getPosition(),function(){
                        if(this.bombNum==num){
                            _this.manBombAction("superBomb");
                        }
                    }.bind(this))
                },pigBomb),
                cc.removeSelf()
            ));
        }

        this.bigHead.laught();
    },
    createPigBomb:function(){
        var pig=new ShootPigHeadSprite_pigHead("k_szt_pig_small_before.png",2,40);
        pig.attr({x:this.bigHead.x+this.bigHead.width/3-33,y:this.bigHead.y-this.bigHead.height/2+33});
        this.addChild(pig);
        pig.standBy();
        this.moveArr.push(pig);
    },
    update:function(){
        if(this.state==1){
            for(var i=0;i<this.moveArr.length;i++){
                if(this.moveArr[i]){
                    var bigHead=this.moveArr[i];
                    if(this.flyCutter && bigHead.collision(this.flyCutter)){
                        playEffect(res_sound.theFace_mp3);
                        this.flyCutter.stopAllActions();
                        this.flyCutter.removeFromParent();
                        this.flyCutter=null;

                        bigHead.moveState=0;
                        if(bigHead.bigType==1){
                            ++this.hitCount;
                            this.scoreLabel.string="分数："+(this.hitCount*10);
                            if(this.hitCount%5==0){
                                playEffect(res_sound.angry_mp3);
                                bigHead.veryAngry(function(){
                                    this.createPigBomb();
                                    this.isTouch=true;
                                }.bind(this));
                            }else{
                                bigHead.angry(function(){
                                    this.isTouch=true;
                                }.bind(this));
                            }
                        }else if(bigHead.bigType==2){
                            bigHead.angry(function(){
                                this.bombDrop(bigHead);
                            }.bind(this));

                            this.bigHead.laught();
                        }
                        break;
                    }
                    if(this.moveArr[i].Move)this.moveArr[i].Move();
                }
            }
        }
    }
});

var ShootPigHeadSprite_pigHead=cc.Sprite.extend({
    _img:null,
    moveSpeed:2,
    moveXOffset:0,
    moveYOffset:0,
    dirX:0,
    dirY:0,
    moveState:1,
    bigType:1,
    isHit:false,
    radius:90,
    ctor:function(_img,bigType,radius){
        this._super(getResImg(_img));
        this._img=_img;
        this.dirX=Math.random()<0.5?-1:1;
        this.dirY=Math.random()<0.5?-1:1;
        this.moveXOffset=this.moveSpeed*this.dirX;
        this.moveYOffset=this.moveSpeed*this.dirY;
        if(bigType)this.bigType=bigType || 1;
        if(radius)this.radius=radius || 90;
    },
    standBy:function(){
        this.stopAllActions();
        if(this.bigType==1){
            setAnimation(this,0.2,["k_szt_pig_daiji.png","k_szt_pig_daiji2.png"]);
            this.moveState=1;
        }else if(this.bigType==2){
            this.runAction(cc.sequence(
                cc.delayTime(0.2),
                cc.callFunc(function(){
                    this.moveState=1;
                    setAnimation(this,0.2,["k_szt_pig_small.png","k_szt_pig_small2.png"]);
                },this)
            ));
        }
    },
    angry:function(callback){
        this.stopAllActions();
        if(this.bigType==1) {
            setSpriteTxture(this,"k_szt_pig_be_attack"+(Math.random()<0.5?2:"")+".png");
            playEffect(res_GameSceneShootPigHead_sound.er_mp3);
        }else if(this.bigType==2){
            setSpriteTxture(this,"k_szt_pig_small_angry.png");
        }
        this.runAction(cc.sequence(
            cc.delayTime(0.2),
            cc.callFunc(function(){
                if(this.bigType==1) {
                    this.standBy();
                }
                if(callback)callback();
            },this)
        ));

    },
    laught:function(){
        if(this.bigType!=1)return;
        this.stopAllActions();
        setAnimation(this,0.2,["k_szt_pig_laugh.png","k_szt_pig_laugh2.png"]);
        playEffect(res_sound.hahahahaha_mp3);
    },
    halo:function(){
        this.moveState=0;
        this.stopAllActions();
        if(this.bigType==1){
            setSpriteTxture(this,"k_szt_pig_yunxuan.png");
            var curY=this.y;
            var offsetY=(this.y-(winCenter().y-336.2))/4;

            this.runAction(cc.sequence(
                cc.spawn(
                    cc.rotateTo(0.2,85),
                    cc.moveTo(0.2,cc.p(cc.winSize.width-this.width/2+80,984-this.height))
                ),
                cc.callFunc(function(){
                    playEffect(res_GameSceneShootPigHead_sound.collision_mp3);
                },this),
                cc.spawn(
                    cc.rotateTo(0.2,30),
                    cc.moveTo(0.2,cc.p(winCenter().x-140,984-this.height/2))
                ),
                cc.callFunc(function(){
                    playEffect(res_GameSceneShootPigHead_sound.collision_mp3);
                },this),
                cc.spawn(
                    cc.rotateTo(0.2,-65),
                    cc.moveTo(0.2,cc.p(this.width/2-80,curY-offsetY*1.7))
                ),
                cc.callFunc(function(){
                    playEffect(res_GameSceneShootPigHead_sound.collision_mp3);
                },this),
                cc.spawn(
                    cc.rotateTo(0.2,85),
                    cc.moveTo(0.2,cc.p(cc.winSize.width-this.width/2+80,984-this.height*2))
                ),
                cc.callFunc(function(){
                    playEffect(res_GameSceneShootPigHead_sound.collision_mp3);
                },this),
                cc.spawn(
                    cc.rotateTo(0.2,-85),
                    cc.moveTo(0.2,cc.p(this.width/2-80,curY-offsetY*2))
                ),
                cc.callFunc(function(){
                    playEffect(res_GameSceneShootPigHead_sound.collision_mp3);
                },this),
                cc.spawn(
                    cc.rotateTo(0.2,-85),
                    cc.moveTo(0.2,cc.p(winCenter().x,984-this.height/2))
                ),
                cc.callFunc(function(){
                    playEffect(res_GameSceneShootPigHead_sound.collision_mp3);
                },this),
                cc.spawn(
                    cc.rotateTo(0.2,85),
                    cc.moveTo(0.2,cc.p(cc.winSize.width-this.width/2+80,winCenter().y))
                ),
                cc.callFunc(function(){
                    playEffect(res_GameSceneShootPigHead_sound.collision_mp3);
                },this),
                cc.spawn(
                    cc.rotateTo(0.2,-85),
                    cc.moveTo(0.2,cc.p(this.width/2-80,winCenter().y-150))
                ),
                cc.callFunc(function(){
                    playEffect(res_GameSceneShootPigHead_sound.collision_mp3);
                },this),
                cc.spawn(
                    cc.rotateTo(0.2,0),
                    cc.moveTo(0.2,cc.p(cc.winSize.width-this.width/2,winCenter().y-336.2))
                ),
                cc.callFunc(function(){
                    playEffect(res_GameSceneShootPigHead_sound.collision_mp3);
                    playEffect(res_sound.peng_mp3);
                },this),
                cc.callFunc(function(){
                    this.rotation=0;
                    setSpriteTxture(this,"k_szt_pig_die.png");
                },this),
                cc.rotateBy(0.1,3),
                cc.rotateBy(0.1,-3),
                cc.rotateBy(0.1,3),
                cc.rotateBy(0.1,-3),
                cc.delayTime(1.8),
                cc.callFunc(function(){
                    showGameWin();
                })
            ));
        }
    },
    veryAngry:function(callback){
        this.stopAllActions();
        setSpriteTxture(this,"");
        if(this.bigType==1){
            this.runAction(cc.sequence(
                cc.delayTime(1.2),
                cc.callFunc(function(){
                    playEffect(res_sound.change_mp3);
                })
            ));
            setAnimation(this,0.2,[
                "k_szt_pig_angry.png",
                "k_szt_pig_angry2.png",
                "k_szt_pig_angry.png",
                "k_szt_pig_angry2.png",
                "k_szt_pig_angry.png",
                "k_szt_pig_angry2.png",
                "k_szt_pig_born.png",
                "k_szt_pig_born2.png",
                "k_szt_pig_angry.png"
            ],false,function(){
                if(callback)callback();
                this.moveSpeed++;
                this.standBy();
                setSpriteTxture(this,"k_szt_pig_daiji.png");
            },this);
        }
    },
    Move:function(){
        if(this.moveState==1) {
            if (this.x + this.width / 2 >= cc.winSize.width || this.x - this.width / 2 <= 0) {
                if(this.x + this.width / 2 >= cc.winSize.width){
                    this.x=cc.winSize.width-this.width/2;
                }else{
                    this.x=this.width/2;
                }
                this.dirX*=-1;
            }
            if (this.y + this.height / 2 >= 984 || this.y - this.height / 2 <= 276) {
                if(this.y + this.height / 2 >= 984){
                    this.y=984-this.height/2;
                }else{
                    this.y=276+this.height/2;
                }
                this.dirY*=-1;
            }
            this.moveXOffset=this.moveSpeed*this.dirX;
            this.moveYOffset=this.moveSpeed*this.dirY;
            this.x += this.moveXOffset;
            this.y += this.moveYOffset;

        }
    },
    collision:function(obj){
        var distance = cc.pDistance(this.getPosition(), obj.getPosition());
        if(distance<this.radius+11){
            return true;
        }
        return false;
    }
});

var GameSceneShootPigHead=GameSceneBase.extend({
    ctor:function(){
        this._super();
        this.layer=new ShootPigHeadLayer();
        this.addChild(this.layer);
        this.setMyNameTag(this.layer.man);
        this.setLoserNameTag(this.layer.bigHead);
    },
    pauseTheGame:function(){
        this.layer.state=0;
    },
    resumeTheGame:function(){
        this.layer.state=1;
    },
    shakeSkill:function(){
        this.layer.addShakeCount();
    }
});