/**
 * Created by eeee on 16/1/19.
 */
var SkullCryLayer=cc.Layer.extend({
    isTouch:true,
    bossBody:null,
    bossHead:null,
    man:null,
    onOff:null,
    flower:null,
    picture:null,
    hitCount:0,
    smoke:null,
    ctor:function(){
        this._super();

        //线
        var link=createLevelSprite("k_com_line.png");
        link.attr({
            x:winCenter().x,
            y:330
        });
        this.addChild(link);

        //开关
        var onOff=createLevelSprite("k_kl_switch.png");
        onOff.attr({
            x:winCenter().x+174.5,
            y:winCenter().y-167
        });
        this.addChild(onOff);
        this.onOff=onOff;

        //灯
        var lamp=createLevelSprite("k_kl_lamp.png");
        lamp.attr({
            anchorY:1,
            x:winCenter().x-201,
            y:winCenter().y+394.5+lamp.height/2
        });
        this.addChild(lamp);
        addTouchCallBack(lamp,function(){
            if(!this.isTouch)return;
            this.isTouch=false;
            removeListener(lamp);
            var time=0.1;
            var rotation=8;
            lamp.runAction(cc.sequence(
                cc.rotateBy(time,rotation),
                cc.rotateBy(time*2,-rotation*2),
                cc.rotateBy(time*2,rotation*2),
                cc.rotateBy(time,-rotation),
                cc.callFunc(function(){
                    this.electrocution();
                },this)
            ));
        }.bind(this));

        //壁画
        var picture=createLevelSprite("k_kl_picture.png");
        picture.attr({
            anchorY:1,
            x:winCenter().x+148.5,
            y:winCenter().y+445
        });
        this.addChild(picture);
        this.picture=picture;
        addTouchCallBack(picture,function(){
            if(!this.isTouch)return;
            this.isTouch=false;
            removeListener(picture);
            var time=0.1;
            var rotation=8;
            picture.runAction(cc.sequence(
                cc.rotateBy(time,rotation),
                cc.rotateBy(time*2,-rotation*2),
                cc.rotateBy(time*2,rotation*2),
                cc.rotateBy(time,-rotation*1.4),
                cc.callFunc(function(){
                    this.shotDead("touchPicture");
                },this)
            ));

            playEffect(res_sound.click_mp3);
        }.bind(this));

        //桌子
        var table=createLevelSprite("k_kl_table.png");
        table.attr({
            x:winCenter().x+35.5,
            y:winCenter().y-168
        });
        this.addChild(table);

        //花瓶
        var flower=createLevelSprite("k_03_flower.png");
        flower.attr({
            x:table.x+8.5,
            y:winCenter().y+12.5
        });
        this.addChild(flower);
        this.flower=flower;
        addTouchCallBack(flower,function(){
            if(!this.isTouch)return;
            this.isTouch=false;
            removeListener(flower);
            this.touchFlower();
        }.bind(this));

        //老鼠
        var mouse=createLevelSprite("k_kl_mouse_1.png");
        mouse.attr({
            x:winCenter().x-256.5,
            y:winCenter().y-297.5
        });
        this.addChild(mouse);
        this.mouse=mouse;
        addTouchCallBack(mouse,function(){
            if(!this.isTouch)return;
            mouse.setTouchEnabled(false);
            mouse.stopAllActions();
            mouse.runAction(cc.sequence(
                cc.spawn(
                    cc.flipX(false),
                    cc.moveTo(0.8,cc.p(winCenter().x+270,winCenter().y-297.5))
                ),
                cc.callFunc(function(){
                    setAnimation(mouse,0.2,["k_kl_mouse_3.png","k_kl_mouse_4.png"]);
                    if(!this.isTouch)return;
                    this.bossBody.setTouchEnabled(false);
                    picture.setTouchEnabled(false);
                    flower.setTouchEnabled(false);
                    this.bossFear();
                },this),
                cc.delayTime(2),
                cc.flipX(true),
                cc.callFunc(function(){
                    setAnimation(mouse,0.2,["k_kl_mouse_1.png","k_kl_mouse_2.png"]);
                },this),
                cc.moveTo(2.6,winCenter().x-256.5,winCenter().y-297.5),
                cc.flipX(false),
                cc.callFunc(function(){
                    this.resetBoss();
                },this)
            ));
        }.bind(this));
        setAnimation(mouse,0.2,["k_kl_mouse_1.png","k_kl_mouse_2.png"]);
        mouse.runAction(cc.sequence(
            cc.moveBy(2,cc.p(330,0)),
            cc.flipX(true),
            cc.moveBy(2,cc.p(-330,0)),
            cc.flipX(false)
        ).repeatForever());

        //BOSS
        var bossBody=createLevelSprite("k_kl_boss_01_body.png");
        bossBody.attr({
            x:winCenter().x+174.5,
            y:winCenter().y-219
        });
        this.addChild(bossBody);
        addTouchCallBack(bossBody,function(){
            if(!this.isTouch)return;
            this.isTouch=false;
            removeListener(bossBody);
            this.touchBoss();
        }.bind(this));
        this.bossBody=bossBody;

        var bossHead=createLevelSprite("k_kl_boss_01_head1.png");
        bossHead.attr({
            x:bossBody.width/2,
            y:350
        });
        bossBody.addChild(bossHead);
        setAnimation(bossHead,0.2,["k_kl_boss_01_head1.png","k_kl_boss_01_head2.png"]);
        this.bossHead=bossHead;

        //史小坑
        var man=createLevelSprite("k_kl_man_01.png");
        man.attr({
            x:winCenter().x-113.5,
            y:winCenter().y-190.5
        });
        this.addChild(man);
        this.man=man;

        //史小坑手
        var manHand=createLevelSprite("k_kl_man_01_hand1.png");
        manHand.attr({
            x:172,
            y:314.5
        });
        man.addChild(manHand,-1);
        setAnimation(manHand,0.3,["k_kl_man_01_hand1.png","k_kl_man_01_hang2.png"]);
        man.hand=manHand;
    },
    touchBoss:function(){
        this.man.hand.stopAllActions();
        setSpriteTxture(this.man.hand,"k_kl_man_01_hand1.png");
        this.man.hand.rotation=40;
        this.man.hand.anchorX=0;
        this.man.hand.x-=this.man.hand.width*0.3+12;

        this.man.runAction(cc.sequence(
            cc.spawn(
                cc.moveBy(0.4,cc.p(57,60)),
                cc.sequence(
                    cc.rotateTo(0.12,2),
                    cc.rotateTo(0.12,0),
                    cc.rotateTo(0.12,-2),
                    cc.rotateTo(0.12,0)
                )
            ),
            cc.callFunc(function(){
                this.man.hand.anchorX=0.5;
                this.man.hand.x+=this.man.hand.width*0.3+12;
                this.man.hand.rotation=0;

                playEffect(res_sound.click_mp3);
                var light=createLevelSprite("k_kl_man_01_hang3.png");
                light.attr({
                    x:this.man.hand.width,
                    y:this.man.hand.height-20
                });
                this.man.hand.addChild(light);
                light.runAction(cc.sequence(
                    cc.delayTime(0.4),
                    cc.removeSelf()
                ));
            },this),
            cc.delayTime(0.8),
            cc.callFunc(function(){
                this.shotDead("touchBoss",true);
            },this)
        ));
    },
    touchFlower:function(){
        this.man.hand.stopAllActions();
        setSpriteTxture(this.man.hand,"k_kl_man_01_hand1.png");
        this.man.hand.rotation=40;
        this.man.hand.anchorX=0;
        this.man.hand.x-=this.man.hand.width*0.3+12;

        this.man.runAction(cc.sequence(
            cc.spawn(
                cc.moveBy(0.5,cc.p(0,70)),
                cc.sequence(
                    cc.rotateTo(0.12,2),
                    cc.rotateTo(0.12,0),
                    cc.rotateTo(0.12,-2),
                    cc.rotateTo(0.12,0)
                )
            ),
            cc.callFunc(function(){
                this.man.hand.anchorX=0.5;
                this.man.hand.x+=this.man.hand.width*0.3+12;
                this.man.hand.rotation=0;

                playEffect(res_sound.click_mp3);
                var light=createLevelSprite("k_kl_man_01_hang3.png");
                light.attr({
                    x:this.man.hand.width,
                    y:this.man.hand.height-20
                });
                this.man.hand.addChild(light);
                light.runAction(cc.sequence(
                    cc.delayTime(0.4),
                    cc.removeSelf()
                ));

                this.flower.runAction(cc.sequence(
                    cc.delayTime(0.8),
                    cc.moveBy(0.4,cc.p(0,-260)),
                    cc.callFunc(function(){
                        playEffect(res_sound.broken_mp3);
                        setSpriteTxture(this.flower,"k_03_flower2.png");
                        this.flower.y-=60;
                    },this),
                    cc.delayTime(0.4),
                    cc.callFunc(function(){
                        this.shotDead("touchFlower");
                    },this)
                ));
            },this)
        ));
    },
    resetBoss:function(){
        if(!this.isTouch)return;
        this.bossBody.stopAllActions();
        this.bossHead.visible=true;
        this.getParent().setLoserNameTag(this.bossHead);
        setSpriteTxture(this.bossBody,"k_kl_boss_01_body.png");
        removeListener(this.onOff);
        this.smoke.removeFromParent();
        playEffect(res_sound.jump_mp3);
        this.bossBody.runAction(cc.sequence(
            cc.jumpTo(0.3,cc.p(winCenter().x+174.5,winCenter().y-219),100,1),
            cc.callFunc(function(){
                this.bossBody.setTouchEnabled(true);
                this.picture.setTouchEnabled(true);
                this.flower.setTouchEnabled(true);
                this.mouse.setTouchEnabled(true);
            },this)
        ));

        this.mouse.stopAllActions();
        this.mouse.runAction(cc.sequence(
            cc.moveBy(2,cc.p(330,0)),
            cc.flipX(true),
            cc.moveBy(2,cc.p(-330,0)),
            cc.flipX(false)
        ).repeatForever());

        var bossBody=createLevelSprite();
        bossBody.attr({
            x:winCenter().x+174.5,
            y:winCenter().y-219
        });
    },
    bossFear:function(){
        this.getParent().setLoserNameTag(this.bossBody);
        this.bossHead.visible=false;
        setAnimation(this.bossBody,0.2,["k_kl_boss_02.png","k_kl_boss_02_2.png"]);
        this.bossBody.y=winCenter().y-133;

        //烟
        var smoke=createLevelSprite("k_kl_smoke.png");
        smoke.attr({
            x:winCenter().x+115,
            y:winCenter().y-75
        });
        this.addChild(smoke);
        this.smoke=smoke;
        smoke.runAction(cc.moveBy(0.4,cc.p(0,-303)));

        this.bossBody.runAction(cc.sequence(
            cc.delayTime(0.3),
            cc.callFunc(function(){
                playEffect(res_sound.jump_mp3);
            },this),
            cc.jumpBy(0.3,cc.p(-170,0),100,1),
            cc.callFunc(function(){
                //添加开关触碰
                addTouchCallBack(this.onOff,function(){
                    if(!this.isTouch)return;
                    removeListener(this.onOff);
                    this.closeOnOff();
                }.bind(this));
            },this)
        ));
    },
    closeOnOff:function(){
        this.isTouch=false;
        var blackLayer=new SwallowViewBase();
        blackLayer.blackBg.opacity=255;
        this.getParent().addChild(blackLayer,20);
        this.getParent().removeMyNameTag();
        this.getParent()._loserNameTag.opacity=0;

        blackLayer.runAction(cc.sequence(
            cc.delayTime(0.4),
            cc.blink(0.3,2),
            cc.delayTime(0.2),
            cc.callFunc(function(){
                this.getParent()._loserNameTag.opacity=255;

                this.man.hand.removeFromParent();
                setSpriteTxture(this.man,"k_kl_skeleton.png");
                this.man.x-=37;
                this.man.y+=50;

                this.bossBody.runAction(cc.sequence(
                    cc.delayTime(0.5),
                    cc.callFunc(function(){
                        playEffect(res_GameSceneSkullCry_sound.shock_mp3);

                        this.bossBody.stopAllActions();
                        setSpriteTxture(this.bossBody,"k_kl_boss_03.png");
                        this.bossBody.x+=166.5;
                        this.bossBody.y-=195;

                        //灵魂
                        soulFluttering(this,winCenter().x+268,winCenter().y-272,0,150,function(){
                            this.getParent().gameWin();
                        }.bind(this),2.5);
                    },this)
                ));
            },this),
            cc.removeSelf()
        ));
    },
    shotDead:function(faileKey,isLossSmoke){
        this.bossHead.stopAllActions();
        setSpriteTxture(this.bossHead,"k_kl_boss_01_head3.png");

        playEffect(res_sound.enheng_mp3);

        //烟
        var smoke=createLevelSprite("k_kl_smoke.png");
        smoke.attr({
            x:winCenter().x+115,
            y:winCenter().y-75
        });
        this.addChild(smoke);

        var moveDelay=0.2;
        if(isLossSmoke){
            moveDelay=1;
            smoke.runAction(cc.moveBy(0.4,cc.p(0,-303)));
        }else{
            smoke.runAction(cc.sequence(
                cc.delayTime(0.2),
                cc.moveBy(0.4,cc.p(-90,0))
            ));
        }

        //生气##
        var shengqi=createLevelSprite("k_xcw_fuhao.png");
        shengqi.attr({
            x:winCenter().x+218.5,
            y:winCenter().y+66
        });
        this.addChild(shengqi);

        shengqi.runAction(cc.sequence(
            cc.delayTime(moveDelay),
            cc.moveBy(0.4,cc.p(-90,0))
        ));

        this.bossBody.runAction(cc.sequence(
            cc.delayTime(0.2+(isLossSmoke?0.8:0)),
            cc.spawn(
                cc.sequence(
                    cc.rotateTo(0.1,-3),
                    cc.rotateTo(0.1,0),
                    cc.rotateTo(0.1,3),
                    cc.rotateTo(0.1,0)
                ),
                cc.moveBy(0.4,cc.p(-90,0))
            ),
            cc.callFunc(function(){
                //boss手
                var bossHand=createLevelSprite("k_com_bighand1.png");
                bossHand.attr({
                    scaleY:-1,
                    x:this.bossBody.x-131,
                    y:this.bossBody.y+44,
                    rotation:-115
                });
                this.addChild(bossHand);

                this.man.hand.removeFromParent();
                shotDead(this.man,function(){
                    this.getParent().gameOver(faileKey);
                }.bind(this))
            },this)
        ));
    },
    electrocution:function(){
        this.man.hand.stopAllActions();
        setSpriteTxture(this.man,"k_kl_man_02.png");
        this.man.hand.removeFromParent();
        this.man.anchorY=0.2;
        this.man.y+=30-this.man.height*0.3;
        this.man.runAction(cc.sequence(
            cc.spawn(
                cc.scaleTo(0.5,0.9),
                cc.moveBy(0.5,cc.p(-95,160)),
                cc.sequence(
                    cc.rotateTo(0.16,-2),
                    cc.rotateTo(0.16,0),
                    cc.rotateTo(0.16,2),
                    cc.rotateTo(0.16,0)
                )
            ),
            cc.delayTime(0.8),
            cc.callFunc(function(){
                setSpriteTxture(this.man,"k_kl_man_03.png");
                this.man.anchorY=0.5;
                this.man.y-=30-this.man.height*0.3;
                playEffect(res_sound.jump_mp3);

                this.runAction(cc.sequence(
                    cc.delayTime(0.8),
                    cc.callFunc(function(){
                        playEffect(res_sound.jump_mp3);
                    })
                ));
            },this),
            cc.jumpBy(0.8,cc.p(0,0),170,1),
            cc.moveBy(0.3,cc.p(0,180)),
            cc.callFunc(function(){
                playEffect(res_sound.electricShock_mp3);

                //雷电
                var lightning=createLevelSprite("k_kl_lightning_01.png");
                lightning.attr({
                    x:winCenter().x-200,
                    y:winCenter().y+253.5
                });
                this.addChild(lightning);
                setAnimation(lightning,0.2,["k_kl_lightning_01.png","k_kl_lightning_02.png"])

                setSpriteTxture(this.man,"k_kl_man_04.png");
            },this),
            cc.delayTime(1.4),
            cc.callFunc(function(){
                this.getParent().gameOver("electrocution");
            },this)
        ));
    }
});

var GameSceneSkullCry=GameSceneBase.extend({
    ctor:function(){
        this._super();
        this.layer=new SkullCryLayer();
        this.addChild(this.layer);
        this.setMyNameTag(this.layer.man);
        this.setLoserNameTag(this.layer.bossHead);
    }
});