/**
 * Created by weicheng on 15/10/14.
 *
 * 关于我们窗口
 */

var AboutUsLayer=PanelViewBase.extend({
    ctor:function(){
        this._super();
        this.initSurface();
    },
    initSurface:function(){

        var bg=createSprite(getResImg("com_bg_01"));
        bg.attr({
            anchorY:1,
            x:this.size.width/2,
            y:this.size.height
        });
        this.addChild(bg,-1);

        //关闭按钮
        var closeBtn=createButton({img:getResImg("com_btn_back")});
        closeBtn.attr({
            x:80,
            y:this.size.height-110
        });
        this.addChild(closeBtn);
        closeBtn.callback=function(){
            this.onClose();
        }.bind(this);


        var list=this.createList();
        this.addChild(list);

    },
    createList:function(){

        var scrollView=new ccui.ScrollView();
        scrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);
        scrollView.setTouchEnabled(true);
        scrollView.setBounceEnabled(false);
        scrollView.setContentSize(cc.size(this.size.width,970));
        scrollView.addTouchEventListener(function(sender,type){
            switch(type){
                case ccui.Widget.TOUCH_MOVED:
                    sender.getInnerContainer().stopAllActions();
                    break;
                default:
                    break;
            }
        },this);

        var node=new cc.Node();
        node.attr({
            x:this.size.width/2,
            y:1400
        });
        scrollView.addChild(node);

        //装饰
        var decorationList=[
            {
                img:getResImg("about_bg_01","res_Panel"),
                x:-235,
                y:-310
            },
            {
                img:getResImg("about_bg_02","res_Panel"),
                x:-220,
                y:-690
            },
            {
                img:getResImg("about_bg_03","res_Panel"),
                x:240,
                y:-460
            }
        ];
        for(var i=0;i<decorationList.length;i++){
            var decoration=createSprite(decorationList[i].img);
            decoration.attr({
                x:decorationList[i].x,
                y:decorationList[i].y
            });
            node.addChild(decoration);
        }

        //内容
        var txtImgList=[
            getResImg("about_txt_01","res_Panel"),    //title
            // getResImg("about_txt_03","res_Panel"),    //合作单位
            getResImg("about_txt_04","res_Panel")    //制作人员
        ];

        //if(getOnlineData("isShowAboutWeChat")=="true"){
        //    //微信号、官网
        //    txtImgList.splice(1,0,getResImg("about_txt_02","res_Panel"));
        //}

        //电信平台添加免责声明
        if(isMobile("Android") && getChannel()=="play"){
                txtImgList.push(getResImg("about_txt_05","res_Panel"));
        }


        var txtList=[];
        for(var i=0;i<txtImgList.length;i++){
            var txt=createSprite(txtImgList[i]);
            txt.attr({
                anchorY:1,
                y:i>0?-(Math.abs(txtList[i-1].y)+txtList[i-1].height+50):0
            });
            node.addChild(txt);
            txtList[i]=txt;

        }

        //内容总高度
        var contentHeight=300;
        for(var i=0;i<txtList.length;i++){
            contentHeight+=txtList[i].height;
        }
        node.y=contentHeight;
        scrollView.setInnerContainerSize(cc.size(this.size.width,contentHeight));
        scrollView.getInnerContainer().runAction(
            cc.sequence(cc.delayTime(1),
            cc.moveTo(5,cc.p(0,0))
        ));



        return scrollView;

    }
});