/**
 * Created by dev on 15/10/14.
 *
 * 全通关窗口
 */

var AllLevelPassLayer=PanelViewBase.extend({
    ctor:function(){
        this._super();
        this.initSurface();
    },
    initSurface:function(){
        imgSearchPath="res_allPass";

        addLevelSpriteFrames();
        addPlistCache("allPass","allPass.plist");

        stopMusic();
        playEffect(res_sound.game_all_pass_1_mp3);
        playEffect(res_sound.game_all_pass_2_mp3);

        //if(curMusicIndex!=1){
        //    curMusicIndex=1;
        //    stopMusic();
        //    playMusic(res_sound.music_MainScene_mp3,true);
        //}

        //面板
        var frame=createLevelSprite("K8_BG");
        frame.attr({
            x:0,
            y:0
        });
        this.nodeUI_.addChild(frame);

        //游戏总时长
        var hour=Math.floor(getGameTime()/3600);
        var minute=Math.floor(getGameTime()/60%60);

        var timeLabel=new cc.LabelBMFont("t"+addZero(hour)+"时"+addZero(minute)+"分",res_allPass.allpassWord_fnt);
        timeLabel.attr({
            x:frame.width/2,
            y:frame.height/2+250
        });
        frame.addChild(timeLabel);

        //失败次数
        var lossCount=new cc.LabelBMFont("败"+getLossCount()+"次",res_allPass.allpassWord_fnt);
        lossCount.attr({
            x:frame.width/2,
            y:frame.height/2+200
        });
        frame.addChild(lossCount);



        //小坑
        var man=createLevelSprite("k8_sxk0000");
        man.attr({
            x:frame.width/2-0.3,
            y:frame.height/2+42.5
        });
        frame.addChild(man);

        var manAnim=[];
        for(var i=0;i<=3;i++){
            manAnim.push("k8_sxk0000");
        }
        for(var i=0;i<=14;i++){
            manAnim.push("k8_sxk00"+addZero(i));
        }
        setAnimation(man,0.15,manAnim);

        //灯
        var act=createLevelSprite("K8_actFront");
        act.attr({
            x:frame.width/2-1.1,y:frame.height/2-229.4
        });
        frame.addChild(act);


        //返回菜单按钮
        var homeBtn=createButton({img:getResImg("K8_ButtonHome")});
        homeBtn.attr({
            x:frame.width/2-233,
            y:104
        });
        frame.addChild(homeBtn);
        homeBtn.callback=function(){
            stopAllEffect();
            removePlistCache("allPass","allPass.plist");
            removeLevelScenePlist(function(){
                _preSelectLevel=25;
                cc.director.runScene(new LevelSelectScene());
            });
        };

        //再玩一次按钮
        var agentBtn=createButton({img:getResImg("K8_ButtonAgain")});
        agentBtn.attr({
            x:frame.width/2+233,
            y:104
        });
        frame.addChild(agentBtn);
        agentBtn.callback=function(){
            var blackBg=new cc.LayerColor(cc.color(0,0,0,100));
            this.addChild(blackBg,10);
            addSwallowTouch(blackBg);

            //重置关卡选择页面
            var resetLevel = createLevelSprite("windowsRP");
            resetLevel.attr({
                x:blackBg.width/2,
                y:blackBg.height/2
            });
            blackBg.addChild(resetLevel);
            resetLevel.scale=1.5;

            //确认重置关卡
            var resetTrue = createButton({img:"button_ok"});
            resetTrue.attr({x:268.7,y:77.5});
            resetLevel.addChild(resetTrue);

            resetTrue.callback=function(){
                stopAllEffect();
                removePlistCache("allPass","allPass.plist");
                removeLevelScenePlist(function() {
                    initData();
                    _preSelectLevel = 1;
                    cc.director.runScene(new MainScene());
                });
            };

            //取消重置关卡
            var resetFalse = createButton({img:"button_cancel"});
            resetFalse.attr( {x:124.9,y:76.8});
            resetLevel.addChild(resetFalse);

            //关闭重置关卡页面
            var resetClose = createButton({img:"button_off"});
            resetClose.attr({x:365.2,y:160.4});
            resetLevel.addChild(resetClose);


            resetClose.callback=resetFalse.callback=function() {
                blackBg.removeFromParent();
            };


        }.bind(this);


        if(cc.director.getWinSize().width/cc.director.getWinSize().height < 0.53){
            homeBtn.x +=40;
            agentBtn.x -=40;
        }

        if(isBaoXiao){
            //挑战下一个游戏按钮
            if(isOpen("gameAppDownload")) {
                var nextGameBtn = createButton(getResImg("B8_ButtonNextGame1", "res_common"));
                nextGameBtn.attr({
                    x: frame.width / 2,
                    y: 104
                });
                frame.addChild(nextGameBtn);
                nextGameBtn.callback = function () {
                    if (!isMobile())return;
                    CommonPlatform.getInstance().openNextGame();
                }
                setAnimation(nextGameBtn,0.23,["B8_ButtonNextGame1","B8_ButtonNextGame2"]);
            }
        }else {
            //挑战下一个游戏按钮
            if(isOpen("gameAppDownload")) {
                var nextGameBtn = createButton({img: "K8_ButtonNextGame1"});
                nextGameBtn.attr({
                    x: frame.width / 2,
                    y: 104
                });
                frame.addChild(nextGameBtn);
                nextGameBtn.callback = function () {
                    if (!isMobile())return;
                    CommonPlatform.getInstance().openNextGame();
                }
                setAnimation(nextGameBtn,0.23,["K8_ButtonNextGame1","K8_ButtonNextGame2"]);
            }
        }

    },
    createFrameItem:function(iconPath){
        var frameItem=createSprite(getResImg("all_pass_little_frame","res_Panel"));

        var icon=createSprite(iconPath);
        icon.attr({
            anchorX:1,
            anchorY:0,
            x:45,
            y:0
        });
        frameItem.addChild(icon);

        return frameItem
    }
});