/**
 * Created by weicheng on 15/10/7.
 *
 * 商店
 */

var StoreLayer=PanelViewBase.extend({
    btnList:[],
    freeBtnList:[],
    freeTitle:null,
    ctor:function(){
        this._super();
        this.initSurface();
    },
    initSurface:function(){

        imgSearchPath="res_storeLayer";

        //背景
        var bg=new cc.Sprite();
        bg.setTextureRect(cc.rect(0,0,this.size.width,this.size.height));
        bg.color=cc.color(209,197,173);
        this.nodeUI_.addChild(bg);

        //商店移除广告提示
        if(isOpen("outAdTips")){
            var outAdTips=createLevelSprite("outAdTips");
            outAdTips.attr({
                x:0,
                y:-420
            });
            this.nodeUI_.addChild(outAdTips);
        }

        //顶部
        var top=createSprite(getResImg("shop_top","res_storeLayer"));
        top.attr({
            anchorY:1,
            x:bg.width/2,
            y:bg.height
        });
        bg.addChild(top);

        //关闭按钮
        var closeBtn=createButton({img:getResImg("com_btn_back"),soundOff:false});
        closeBtn.attr({
            x:80,
            y:bg.height-110
        });
        bg.addChild(closeBtn,99);
        closeBtn.callback=function(){
            this.onClose(function(){
                //if(isMobile("iOS") && getOnlineData("isShowLookMoive")=="1"){
                //    CommonPlatform.getInstance().hideVideoAdBtn();
                //}
                _resumeGame();
            });
        }.bind(this);

        //面板
        this.storeFrame=createSprite(getResImg("com_frame_bg.png"));
        this.storeFrame.attr({
            x:bg.width/2,
            y:490
        });
        bg.addChild(this.storeFrame);

        //标题
        var titleFrame=createSprite(getResImg("shop_title_frame","res_storeLayer"));
        titleFrame.attr({
            x:this.storeFrame.width/2,
            y:this.storeFrame.height-10
        });
        this.storeFrame.addChild(titleFrame);

        var title=createSprite(getResImg("shop_title_txt","res_storeLayer"));
        title.attr({
            x:titleFrame.width/2,
            y:titleFrame.height/2
        });
        titleFrame.addChild(title);

        //史小坑
        var man=createLevelSprite("shop_man.png");
        man.attr({x:488.8,y:41.2});
        this.storeFrame.addChild(man);


        //按钮列表
        this.createBtnList();
    },
    createBtnList:function(){
        var that=this;

        this.btnList=[];
        this.freeBtnList=[];

        var storeParam=[
            {type:"novice",img:"gift_btn_new",money:18,code:1006,fn:function(){
                if(getIsBuyNovicePackage()==0){
                    payFn=function(){
                        that.removeBtnFromTag("novice");
                    }
                    new NovicePackageLayer().addToCurScene();
                }else{
                    that.removeBtnFromTag("novice");
                }
            }},
            {type:"master",img:"gift_btn_excellent",money:28,code:1007,fn:function(){
                if(getIsBuyMasterPackage()==0) {
                    payFn=function(){
                        that.removeBtnFromTag("master");
                    }
                    new MasterPackageLayer().addToCurScene();
                }else{
                    that.removeBtnFromTag("master");
                }
            }},
            {type:"strategy",img:"shop_cheat",money:8,code:1008,fn:function(){
                if (getIsBuyStrategy() == 0) {
                    payFn=function(){
                        that.removeBtnFromTag("strategy");
                    }
                    new StrategyLayer().addToCurScene();
                }else{
                    that.removeBtnFromTag("strategy");
                }
            }},
            {type:"gold",img:"shop_gold_03",money:2,num:200,code:1001},
            {type:"gold",img:"shop_gold_04",money:4,num:440,code:1002},
            {type:"gold",img:"shop_gold_05",money:6,num:720,code:1003},
            {type:"gold",img:"shop_gold_02",money:8,num:1040,code:1004},
            {type:"gold",img:"shop_gold_06",money:10,num:1400,code:1005}
        ];

        if(isMobile("iOS")){
            storeParam=[
                {type:"gold",img:"shop_gold_03",money:1,num:100,code:1001},
                {type:"gold",img:"shop_gold_05",money:3,num:360,code:1002},
                {type:"gold",img:"shop_gold_06",money:6,num:900,code:1003}
            ]
        }

        var scrollView=new ccui.ScrollView();
        scrollView.setDirection(ccui.ScrollView.DIR_VERTICAL);
        //scrollView.setTouchEnabled(true);
        scrollView.setContentSize(cc.size(this.storeFrame.width,610));
        scrollView.y=120;
        this.storeFrame.addChild(scrollView);
        this.scrollView=scrollView;

        scrollView.setInnerContainerSize(cc.size(this.size.width, 1000));
        scrollView.getInnerContainer().y=0;

        var node=new cc.Node();
        node.x=this.storeFrame.width/2;
        node.y=540;
        scrollView.addChild(node);

        if(isMobile("iOS")){
            scrollView.setTouchEnabled(false);
            scrollView.setBounceEnabled(false);
            scrollView.setInertiaScrollEnabled(false);
        }else {
            scrollView.setBounceEnabled(true);
        }


        for(var i=0;i<storeParam.length;i++){
            var btn;
            var item=storeParam[i];
            switch(item.type){
                case "novice":
                    if(getIsBuyNovicePackage()!=0)break;
                    btn=this.createBtnItem3(item.img,item.money,item.fn);
                    node.addChild(btn);
                    this.btnList.push({btn:btn,tag:item.type});
                    break;
                case "master":
                    if(getIsBuyMasterPackage()!=0)break;
                    btn=this.createBtnItem3(item.img,item.money,item.fn);
                    node.addChild(btn);
                    this.btnList.push({btn:btn,tag:item.type});
                    break;
                case "strategy":
                    if(getIsBuyStrategy()!=0)break;
                    btn=this.createBtnItem3(item.img,item.money,item.fn);
                    node.addChild(btn);
                    this.btnList.push({btn:btn,tag:item.type});
                    break;
                case "gold":
                    btn=this.createBtnItem(item.img,item.num,item.money,item.code);
                    node.addChild(btn);
                    btn.setDelayTime(0.3);
                    this.btnList.push({btn:btn,tag:item.type});
                    break;
            }

            if(btn){
                btn.touchContentNode=scrollView;
            }

        }


        //免费金币标题
        var freeTitle = createSprite(getResImg("shop_free_title", "res_storeLayer"));
        node.addChild(freeTitle);
        this.freeTitle=freeTitle;

        if(isMobile() && isReview!=1) {

            //分享得金币
            if(!isHideShare() && getOnlineData("isShowShareGold")=="1"){
                var shareBtn=this.createBtnItem2(getResImg("shop_free_01","res_storeLayer"),"分享得金币");
                node.addChild(shareBtn);
                shareBtn.callback=function(){
                    //createUnTouchLayer();
                    trace("分享得金币！");

                    share("坑爹永不止，快乐价更高。","http://h5.kdyx.cn/"+gameKey+"three",1001,function(){
                        var gold=10;
                        var onlineGold=getOnlineData("shareGold");
                        if(onlineGold && onlineGold!=""){
                            gold=parseInt(onlineGold)
                        }
                        addGoldNum(gold,true);
                    });
                }
                this.freeBtnList.push({btn:shareBtn,tag:"share"});
            }

        }

        //看片得金币
        if(isMobile("iOS") || (isMobile("Android") && isReview!=1 && getOnlineData("isShowVideoBtn")=="true")){
            var lookmoiveBtn=createVideoBtn();
            node.addChild(lookmoiveBtn);
            this.freeBtnList.push({btn:lookmoiveBtn,tag:"lookVideo"});
        }

        this.updateBtnPos();
    },
    removeBtnFromTag:function(tag){
        if(this.btnList.length>0){
            var b=false;
            for(var i=this.btnList.length-1;i>=0;i--){
                if(this.btnList[i].tag==tag){
                    b=true;
                    this.btnList[i].btn.removeFromParent();
                    this.btnList.splice(i,1);
                }
            }

            b && this.updateBtnPos();
        }
    },
    updateBtnPos:function(){
        var rowShowNum=3;
        var len=this.btnList.length-1;	            //列表数量
        var maxRow=Math.ceil(len/rowShowNum);	//最大行数
        var cell,row,curRowNum;

        //金币、礼包按钮
        for(var i=0;i<=len;i++){
            cell=i%rowShowNum;						                        //当前行位数
            row=Math.floor(i/rowShowNum);				                    //行数
            curRowNum=(row+1)*rowShowNum<=len?rowShowNum-1:len%rowShowNum;  //当前行数量

            var btn=this.btnList[i].btn;
            btn.x=(cell-curRowNum/2)*160;
            btn.y=350-row*210;
        }

        //免费金币按钮
        if(this.freeBtnList.length>0){
            this.freeTitle.y=350-maxRow*210;
            len=this.freeBtnList.length-1;

            for(var i=0;i<this.freeBtnList.length;i++){
                cell=i%rowShowNum;						                        //当前行位数
                row=Math.floor(i/rowShowNum);				                    //行数
                curRowNum=(row+1)*rowShowNum<=len?rowShowNum-1:len%rowShowNum;  //当前行数量

                var btn=this.freeBtnList[i].btn;
                btn.x=(cell-curRowNum/2)*160;
                btn.y=this.freeTitle.y-160-row*210;
            }
        }else{
            this.freeTitle.visible=false;
        }
    },
    createBtnItem:function(iconPath,goldNum,money,code){
        var btn=createButton({img:getResImg("shop_free_frame","res_storeLayer"),swallow:false,mode:1});
        var icon=createLevelSprite(iconPath);
        icon.attr({
            anchorY:0,
            x:btn.width/2,
            y:56
        });
        btn.addChild(icon);

        var goldLabel=new cc.LabelTTF("X "+goldNum,"",24);
        goldLabel.attr({
            x:btn.width/2,
            y:40,
            color:cc.color(120,40,11)
        });
        btn.addChild(goldLabel);

        var moneyFrame=createSprite(getResImg("box_btn_buy"));
        moneyFrame.attr({
            x:btn.width/2,
            y:2,
            scale:0.6
        });
        btn.addChild(moneyFrame);

        var moneyLabel=new cc.LabelTTF(money+"元","",40);
        moneyLabel.attr({
            x:moneyFrame.width/2,
            y:moneyFrame.height/2,
            color:cc.color(37,52,62)
        });
        moneyFrame.addChild(moneyLabel);

        btn.callback=function(){
            //createUnTouchLayer();
            buyPropId=code;
            payFn=null;

            if(isFree==1){
                getPayProp('{"id":'+code+'}');
                return;
            }

            if(isMobile()) {
                CommonPlatform.getInstance().buy(code);
            }
        };

        return btn;
    },
    createBtnItem2:function(iconPath,btnName){
        var btn=createButton({img:getResImg("shop_free_frame","res_storeLayer")});

        var icon=createSprite(iconPath);
        icon.attr({
            anchorY:0,
            x:btn.width/2,
            y:12
        });
        btn.addChild(icon);

        var nameLabel=new cc.LabelTTF(btnName,"",20);
        nameLabel.attr({
            x:btn.width/2,
            y:28,
            color:cc.color(93,71,67)
        });
        btn.addChild(nameLabel);
        btn.label=nameLabel;

        return btn;
    },
    createBtnItem3:function(iconPath,money,fn){
        var btn=createButton({img:getResImg("shop_free_frame","res_storeLayer"),swallow:false,mode:1});
        //var btn=createLevelSprite("shop_free_frame")
        var icon=createLevelSprite(iconPath);
        icon.attr({
            anchorY:0,
            x:btn.width/2,
            y:35
        });
        btn.addChild(icon);

        var moneyFrame=createSprite(getResImg("box_btn_buy"));
        moneyFrame.attr({
            x:btn.width/2,
            y:2,
            scale:0.6
        });
        btn.addChild(moneyFrame);

        var moneyLabel=new cc.LabelTTF(money+"元","",40);
        moneyLabel.attr({
            x:moneyFrame.width/2,
            y:moneyFrame.height/2,
            color:cc.color(37,52,62)
        });
        moneyFrame.addChild(moneyLabel);

        btn.callback=function(){
            //createUnTouchLayer();
            if(fn)fn();
        };

        return btn;
    },
    onEnter:function(){
        this._super();
//        if(isMobile("iOS")){
//            CommonPlatform.getInstance().showVideoAdBtn("cb",0,90);
//        }
    },
    onExit:function(){
        this._super();
//        if(isMobile("iOS")){
//            CommonPlatform.getInstance().hideVideoAdBtn();
//        }
    }
});