/**
 * Created by weicheng on 15/10/6.
 *
 * 游戏场景类
 */
var GameSceneBase=cc.Scene.extend({
    level:1, //当前关卡序号
    _className:"GameSceneBase",//关卡类名
    _propBox:null,      //道具栏
    _menuLayer:null,    //菜单栏
    _bgFile:null,
    state:0, //场景状态、0：游戏中，1：胜利，2：失败
    ctor:function(){
        this._super();
        cc.director.getRunningScene().cleanup();

        closeNativeAd();

        //音效清除
        effectArray = [];

        var _this=this;

        this.level=_preSelectLevel || 1;
        this._className=getClassName(this.level);
        this.size=cc.director.getWinSize();
        this.initSurface();

        stopAllEffect();
        stopMusic();

        this.state=0;

        curMusicIndex=2;
        try{
            var musicPath=eval("res_"+getClassName(this.level)+"_sound");
            if(musicPath){
                var music=musicPath["bg_mp3"];
                if(music)playMusic(music,true);
            }
        }catch(err){
            trace("背景音乐找不到："+err);
        }

        //设置游戏总时长
        setGameTime();

        if(isMobile()){
            //友盟统计
            CommonPlatform.getInstance().umengStartLevel(getClassName(this.level));
        }

        cc.eventManager.addCustomListener(cc.game.EVENT_HIDE, function(){
            if(_this.state==0){
                _this.pauseTheGame();
            }
        });
        cc.eventManager.addCustomListener(cc.game.EVENT_SHOW, function(){
            if(_this.state==0){
                _this.resumeTheGame();
            }
        });


        if(isBrowser() && isTestMode==1){
            cc.eventManager.addListener(cc.EventListener.create({
                event : cc.EventListener.MOUSE,
                onMouseDown : function(event) {

                    trace("----------------------begin--------------------------");
                    trace("为方便屏幕定位，提供了鼠标点击位置，发布时可移除!");

                    trace("点击位置 ： \nX = " + Math.round(event._prevX) + "   Y = " + Math.round(event._prevY));
                    trace("相对于屏幕中心的偏移量 ： \n X = " + Math.round(event._prevX - winCenter().x) + "   Y = " + Math.round(event._prevY - winCenter().y));

                    trace("-----------------------end-------------------------");

                    return true;
                },
                onMouseUp : function(event) {
                    //trace("Mouse up");
                    return true;
                }
            }), this);

            //拖动框————对位置
            var rectSprite=new cc.DrawNode();
            this.addChild(rectSprite,9999);
            rectSprite.initialX=0;
            rectSprite.initialY=0;

            var valueLabel=new cc.LabelTTF("","",16);
            //valueLabel.color=cc.color(0,0,0);
            valueLabel.lineWidth=3;
            valueLabel.strokeStyle=cc.color(0,0,0);
            valueLabel.anchorX=0;
            valueLabel.anchorY=0;
            valueLabel.x=20;
            valueLabel.y=20;
            rectSprite.addChild(valueLabel);

            try {
                cc.eventManager.addListener({
                    event: cc.EventListener.TOUCH_ONE_BY_ONE,
                    swallowTouches: false,
                    onTouchBegan: function (touch, event) {
                        if (isTestMode == 1) {
                            var pos = touch.getLocation();
                            rectSprite.visible = true;
                            rectSprite.initialX = pos.x;
                            rectSprite.initialY = pos.y;
                            valueLabel.string = "";
                            return true;
                        }
                        return false;
                    },
                    onTouchMoved: function (touch, event) {
                        var pos = touch.getLocation();
                        //_this.rectSprite.attr({
                        //    width:Math.abs(pos.x-_this.rectSprite.x),
                        //    height:Math.abs(pos.y-_this.rectSprite.y)
                        //});
                        rectSprite.clear();
                        rectSprite.drawRect(
                            cc.p(rectSprite.initialX, rectSprite.initialY),
                            cc.p(pos.x, pos.y),
                            cc.color(255, 0, 0, 80),
                            2
                        );

                        var rectSize = cc.size((pos.x - rectSprite.initialX).toFixed(1), (pos.y - rectSprite.initialY).toFixed(1));
                        valueLabel.string = "beginPos：[" + rectSprite.initialX.toFixed(1) + "，" + rectSprite.initialY.toFixed(1) + "]" +
                            "\ncurPos：[" + pos.x.toFixed(1) + "，" + pos.y.toFixed(1) + "]" +
                            "\nanchorPos：[" + (pos.x - rectSize.width / 2).toFixed(1) + "，" + (pos.y - rectSize.height / 2).toFixed(1) + "]" +
                            "\nsize：[" + Math.abs(rectSize.width) + "，" + Math.abs(rectSize.height) + "]" +
                            "\nbeginWinPos：[" + (rectSprite.initialX - winCenter().x).toFixed(1) + "，" + (rectSprite.initialY - winCenter().y).toFixed(1) + "]" +
                            "\ncurWinPos：[" + (pos.x - winCenter().x).toFixed(1) + "，" + (pos.y - winCenter().y).toFixed(1) + "]" +
                            "\nanchorWinPos：[" + ((pos.x - winCenter().x) - rectSize.width / 2).toFixed(1) + "，" + ((pos.y - winCenter().y) - rectSize.height / 2).toFixed(1) + "]";
                    },
                    onTouchEnded: function (touch, event) {
                        rectSprite.clear();
                        rectSprite.visible = false;
                        valueLabel.string = "";
                    }
                }, this);
            }catch(err){
                trace("测试拖拉区域报错："+err);
            }
        }

        return true;
    },
    gameOver:function(faileKey,lossType){
        faileKey=faileKey || "lossWord1";

        //var swallowLayer=new SwallowViewBase();
        //swallowLayer.blackBg.opacity=0;
        //this.addChild(swallowLayer,99);

        //if(lossType==1){
        //    //炸死
        //    this._menuLayer.kengBBAsh(function(){
        //        this.gameOverCallBack(faileKey);
        //    }.bind(this));
        //}else if(lossType==2){
        //    //吓死（吐奶嘴）
        //    this._menuLayer.kengBBSurprised(function(){
        //        this.gameOverCallBack(faileKey);
        //    }.bind(this));
        //}else{
        //    //哭死
        //    this._menuLayer.kengBBCry(function(){
        //        this.gameOverCallBack(faileKey);
        //    }.bind(this));
        //}

        this.gameOverCallBack(faileKey);
    },
    gameWin:function(winWordKey,winType){
        //var swallowLayer=new SwallowViewBase();
        //swallowLayer.blackBg.opacity=0;
        //this.addChild(swallowLayer,99);
        //this._menuLayer.kengBBLaugh(function(){
        //    this.gameWinCallBack(winWordKey,winType);
        //}.bind(this));


        this.gameWinCallBack(winWordKey,winType);
    },
    gameOverCallBack:function(faileKey){ //faileKey:文案键名（对应失败文案）
        trace("GameOver！");
        _pauseGame();
        this.unAllSchedule();

        this.rotation=0;
        this.state=2;

        //设置游戏总时长
        setGameTime();

        //添加死亡次数
        addLossCount();

        if(isMobile()){
            //友盟统计
            CommonPlatform.getInstance().umengfailLevel(getClassName(this.level));
        }

        if(isMobile()){
            CommonPlatform.getInstance().gameOverHandler(this.level);
        }

        //插屏广告
        //if(isMobile()){
        //    _faileCount++;
        //    if(adHz>0 && _faileCount%adHz==0){
        //        if(isShieldGdt==1){
        //            CommonPlatform.getInstance().showInterstitialAd();
        //        }else{
        //            CommonPlatform.getInstance().showInterstitialAd2();
        //        }
        //    }
        //    trace("广告频率："+adHz+", 当前次数："+_faileCount%adHz);
        //}

        playEffect(res_sound.faile_mp3);

        var layer=new PanelViewBase();
        this.addChild(layer,99);

        var frame=createSprite(getResImg("failure_bg.png","res_GameOver"));
        layer.nodeUI_.addChild(frame);

        //文案背景
        var wordBg=createSprite(getResImg("failure_dialog.png","res_GameOver"));
        wordBg.attr({
            x:frame.width/2+100,
            y:frame.height/2+85
        });
        frame.addChild(wordBg);

        //失败文案
        var faileWordLabel=new cc.LabelTTF(getWordByKey(faileKey),"",24,cc.size(275,80),cc.TEXT_ALIGNMENT_CENTER);
        faileWordLabel.attr({
            x:wordBg.width/2+20,
            y:wordBg.height/2,
            color:cc.color(125,105,101)
        });
        wordBg.addChild(faileWordLabel);

        //史小坑
        var animNumFrames=[0,1,0,1,0,1,2,3,4,5,6,5,6,5,6,5,4,3,2,1];
        var animFrames=[];
        var repeatAnimNum=0;
        for(var i=0;i<animNumFrames.length;i++){
            var repeat=false;
            for(var j=0;j<i;j++){
                if(animNumFrames[i]==animNumFrames[j]){
                    repeat=true;
                    repeatAnimNum=j;
                    break;
                }
            }
            animFrames[i]=repeat?animFrames[repeatAnimNum]:getResImg("failure_man_"+animNumFrames[i]+".png","res_GameOver");
        }
        var man=createSprite(getResImg("failure_man_1.png","res_GameOver"));
        man.attr({
            x:frame.width/2-190,
            y:frame.height/2
        });
        frame.addChild(man);
        setAnimation(man,0.2,animFrames);

        var btnList=[];
        //返回菜单按钮
        var exitBtn=createButton({img:getResImg("failure_btn_menu.png","res_GameOver")});
        exitBtn.attr({
            x:frame.width/2-35,
            y:frame.height/2-70
        });
        frame.addChild(exitBtn);
        exitBtn.callback=function(){
            stopAllEffect();
            removeLevelScenePlist(function(){
                cc.director.runScene(new LevelSelectScene());
            });
        }.bind(this);
        btnList.push(exitBtn);

        //重来按钮
        var againBtn=createButton({img:getResImg("pause_btn_restart.png","res_GameOver")});
        againBtn.attr({
            x:frame.width/2+95,
            y:frame.height/2-70
        });
        frame.addChild(againBtn);
        againBtn.callback=function(){
            stopAllEffect();
            addLevelSpriteFrames(getClassName(this.level));
            try{
                cc.director.runScene(eval("new "+getClassName(this.level)+"()"));
            }catch(err){
                cc.director.runScene(new HelloWorldScene());
            }
        }.bind(this);
        btnList.push(againBtn);

        if(cc.director.getWinSize().width/cc.director.getWinSize().height < 0.53){
            frame.scale = 0.8;
        }

        //购买金币按钮
        getOnlineData("gameOverBuyBtnCode",function(code){
            var param=checkCodeIsShow(code);

            cc.log("～js～～按钮参数："+JSON.stringify(param));

            if(param && param.isShow){
                var name=param.name.substr(0,param.name.length-2)+"\n"+param.name.substr(param.name.length-2,2);

                var storeBtn=createButton({img:"btn_coin"});
                storeBtn.attr({
                    x: frame.width / 2 + 225,
                    y: frame.height / 2 - 70
                });
                frame.addChild(storeBtn);

                var storeLabel=createLabel(name,24,cc.color(116,94,93),cc.size(storeBtn.width,storeBtn.height),cc.TEXT_ALIGNMENT_CENTER,cc.TEXT_ALIGNMENT_CENTER);
                storeLabel.attr({
                    x:storeBtn.width/2,
                    y:storeBtn.height/2
                });
                storeBtn.addChild(storeLabel);


                storeBtn.callback=function(){
                    if(!checkCodeIsShow(param.code).isShow){
                        this.visible=false;
                        var index=btnList.indexOf(this);
                        if(index>-1){
                            btnList.splice(index,1);
                        }
                        resetPos();
                        return;
                    }

                    switch(param.code){
                        case "1001":
                        case "1002":
                        case "1003":
                        case "1004":
                        case "1005":
                            new PurchaseLayer(param.code).addToCurScene();
                            break;
                        case "1006":
                            new NovicePackageLayer().addToCurScene();
                            break;
                        case "1007":
                            new MasterPackageLayer().addToCurScene();
                            break;
                        case "1008":
                            new StrategyLayer().addToCurScene();
                            break;
                        case "1009":
                            new SkipLevelLayer().addToCurScene();
                            break;
                        case "1010":
                            new GoldTipsLayer().addToCurScene();
                            break;
                    }
                }
                btnList.push(storeBtn);
            }

        });


        //求助按钮
        // if(!isHideShare()) {
        //     var helpBtn = createButton({img: getResImg("failure_btn_help.png", "res_GameOver")});
        //     helpBtn.attr({
        //         x: frame.width / 2 + 225,
        //         y: frame.height / 2 - 70
        //     });
        //     frame.addChild(helpBtn);
        //     helpBtn.callback = function () {
        //         trace("求助");
        //         createUnTouchLayer();
        //         share("坑爹游戏8："+levelConfig[_preSelectLevel-1]["helpWord"], "http://h5.kdyx.cn/"+gameKey, 1002);
        //     }.bind(this);
        //     btnList.push(helpBtn);
        // }

        //按钮位置按照数量适配
        function resetPos() {
            for (var i = 0; i < btnList.length; i++) {
                var btn = btnList[i];
                if (btnList.length >= 4) {
                    btn.__scale = btn.scale = 0.8;
                }
                btn.attr({
                    x: frame.width / 2 + 95 + (i - ((btnList.length - 1) / 2)) * (btn.width * btn.scale + 15 * (5 - btnList.length)),
                    y: frame.height / 2 - 70
                })
            }
        }
        resetPos();

        //失败界面视频广告按钮
        if (isOpen("gameOverVideo")) {

            //视频广告按钮
            var videoBtn = createButton({img:"Video_button"});
            videoBtn.attr({
                x: frame.width / 2,
                y: frame.height / 2 + 330
            });
            videoBtn.callback = function () {
                videoBtn.visible = false;
                if (!isMobile()) return;
                CommonPlatform.getInstance().showVideoAd();
            };
            frame.addChild(videoBtn, 99);
        }

        //失败界面弹出原生广告
        showAd("gameOver",function(data){
            showNativeAdPanel(frame,data);
        });

        //死亡弹出新手/高手礼包
        markLevelLoseCount(this.level);

    },
    gameWinCallBack:function(winWordKey,winType){
        trace("GameWin！");
        _pauseGame();
        this.unAllSchedule();

        this.rotation=0;
        this.state=1;

        //设置游戏总时长
        setGameTime();

        if(isMobile()){
            //友盟统计
            CommonPlatform.getInstance().umengFinishLevel(getClassName(this.level));
        }

        if(isMobile()){
            CommonPlatform.getInstance().gameWinHandler(this.level);
        }

        if(isMobile("iOS") && isReview!=1){
            CommonPlatform.getInstance().comment("求评价","程序猿哥哥说了，给个评价，下次会做得更好！评价后不再提示哦！","评价并不再提示","残忍拒绝");
        }

        _winCount++;

        //设置游戏已全通关
        if(this.level==gameMaxLevel){
            setIsLevelAllPass(1);
        }

        playEffect(res_sound.win_mp3);

        //胜利文案键值
        winWordKey=winWordKey || "winWord";

        //获取当前关卡是否首次通过
        var isFirstPass=false;

        //跳过金币消耗提示
        if(winType==1){
            showGoldChange(-100);
        }

        if(getLevelStatusByLevel(this.level)!=1){
            //首次通关加金币
            addGoldNum(10);

            showGoldChange(10,0.5);

            //修改关卡通关状态
            setLevelStatusByLevel(this.level,1);

            isFirstPass=true;
        }

        var layer=new PanelViewBase();
        this.addChild(layer,99);

        var frame=createSprite(getResImg("failure_bg.png","res_GameOver"));
        layer.nodeUI_.addChild(frame);

        //文案背景
        var wordBg=createSprite(getResImg("failure_dialog.png","res_GameOver"));
        wordBg.attr({
            x:frame.width/2+100,
            y:frame.height/2+85
        });
        frame.addChild(wordBg);

        //通关文案
        var winWordLabel=new cc.LabelTTF(winType!=1?getWordByKey(winWordKey):"鄙视用金币过关的人！","",24,cc.size(275,80),cc.TEXT_ALIGNMENT_CENTER);
        winWordLabel.attr({
            x:wordBg.width/2+20,
            y:wordBg.height/2,
            color:cc.color(125,105,101)
        });
        wordBg.addChild(winWordLabel);

        //史小坑
        var animFrames=[2,3,4,5,6,5,4,3,2,1];
        for(var i=0;i<animFrames.length;i++){
            animFrames[i]=getResImg("win_man_"+animFrames[i]+".png","res_GameOver");
        }
        var animateAction=getAnimation(0.08,animFrames);
        var man=createSprite(getResImg("win_man_1.png","res_GameOver"));
        man.attr({
            x:frame.width/2-190,
            y:frame.height/2
        });
        frame.addChild(man);
        man.runAction(cc.sequence(animateAction, cc.delayTime(0.5)).repeatForever());

        //返回菜单按钮
        var exitBtn=createButton({img:getResImg("failure_btn_menu.png","res_GameOver")});
        exitBtn.attr({
            x:frame.width/2-35,
            y:frame.height/2-70
        });
        frame.addChild(exitBtn);
        exitBtn.callback=function(){
            stopAllEffect();
            if(this.level<gameMaxLevel){
                removeLevelScenePlist(function(){
                    cc.director.runScene(new LevelSelectScene());
                });
            }else{
                _preSelectLevel=0;
                new AllLevelPassLayer().addToCurScene();
            }
        }.bind(this);


        //下一关按钮
        var nextBtn=createButton({img:getResImg("win_btn_next.png","res_GameOver")});
        nextBtn.attr({
            x:frame.width/2+95,
            y:frame.height/2-70
        });
        frame.addChild(nextBtn);
        nextBtn.callback=function(){
            stopAllEffect();
            if(this.level<gameMaxLevel){
                cc.director.runScene(new ReadyScene(this.level+1));
            }else{
                _preSelectLevel=0;
                new AllLevelPassLayer().addToCurScene();
            }
        }.bind(this);

        //炫耀按钮
        if(false && !isHideShare()) {
            //var shareBtn = createButton({img: getResImg("win_btn_show.png", "res_GameOver")});
            //shareBtn.attr({
            //    x: frame.width / 2 + 225,
            //    y: frame.height / 2 - 70
            //});
            //frame.addChild(shareBtn);
            //shareBtn.callback = function () {
            //    trace("炫耀");
            //    createUnTouchLayer();
            //    share("坑爹游戏8："+levelConfig[_preSelectLevel-1]["winShareWord"], "http://h5.kdyx.cn/"+gameKey, 1003);
            //}.bind(this);
        }else{
            exitBtn.x=frame.width/2+65;
            nextBtn.x=frame.width/2+195;
        }

        if(cc.director.getWinSize().width/cc.director.getWinSize().height < 0.53){
            frame.scale = 0.8;
        }

        //失败界面弹出原生广告
        showAd("gameWin",function(data){
            showNativeAdPanel(frame,data);
        });

    },
    unAllSchedule:function(){
        this.unscheduleAllCallbacks();
        for(var i=0;i<this.getChildren().length;i++){
            this.getChildren()[i].unscheduleAllCallbacks();
        }
    },
    onExit:function(){
        this._super();
        if(isMobile()){
            CommonPlatform.getInstance().removeBanner();
        }
    },
    onEnter:function(){
        this._super();

        addBackground(this._bgFile, this);//设备背景图片

        if(isMobile()){
           
            CommonPlatform.getInstance().showBanner();
        }

        this.runAction(cc.sequence(
            cc.delayTime(0.001),
            cc.callFunc(function(){
                if(this.layer) {
                    if (true || cc.director.getWinSize().width / cc.director.getWinSize().height < 0.53) {
                        this.layer.scale = 0.8;
                    }
                }
            },this)
        ));
    },
    pauseTheGame:function(){
        trace("暂停游戏处理");
    },
    resumeTheGame:function(){
        trace("恢复游戏处理");
    },
    hideMenuGoldBtn:function(){ //隐藏金币按钮
        this._menuLayer.goldBtn.visible=false;
    },
    showMenuGoldBtn:function(){ //隐藏金币按钮
        this._menuLayer.goldBtn.visible=true;
    },
    hideMenuTipsBtn:function(){ //隐藏提示按钮
        this._menuLayer.tipsBtn.visible=false;
    },
    showMenuTipsBtn:function(){ //显示提示按钮
        this._menuLayer.tipsBtn.visible=true;
    },
    hidePropBox:function(){ //隐藏道具栏
        //this._propBox.visible=false;
    },
    showPropBox:function(){ //显示道具栏
        //this._propBox.visible=true;
    },
    initSurface:function(){
        //this._propBox=new GamePropBox();
        //this.addChild(this._propBox,97);

        this._menuLayer=new GameMenuLayer();
        this.addChild(this._menuLayer,98);
    },
    //道具栏道具拖动松开时触发的回调,返回参数：propTag（道具tag），propEndPos，（松开时的位置）prop（道具）
    propCallBack:function(propTag,propEndPos,prop){
        trace("道具Tag："+propTag+",道具当前位置：[x:"+propEndPos.x+",y:"+propEndPos.y+"]");
        if(this.layer && this.layer.propCallBack){
            return this.layer.propCallBack(propTag,propEndPos,prop) || false;
        }
        return false;
    },
    //道具栏道具点击时触发的回调,返回参数：propTag（道具tag），propMovePos，（移动中的位置）prop（道具）
    propBeganCallBack:function(propTag,propMovePos,prop){
        if(this.layer && this.layer.propBeganCallBack){
            this.layer.propBeganCallBack(propTag,propMovePos,prop);
        }
    },
    //道具栏道具拖动时触发的回调,返回参数：propTag（道具tag），propMovePos，（移动中的位置）prop（道具）
    propMoveCallBack:function(propTag,propMovePos,prop){
        if(this.layer && this.layer.propMoveCallBack){
            this.layer.propMoveCallBack(propTag,propMovePos,prop);
        }
    },
    //添加道具到道具栏，需传入参数：propImg（道具图片），tag（道具tag），pos（道具当前的位置）
    addPropToBox:function(propImg,tag,pos){
        pos=pos || winCenter();
        this._propBox.addProp(propImg,tag,pos);
    },
    createNameTag:function(key,name,sprite,scale,offsetX,offsetY,isFollowTargetScale){
        offsetX=offsetX || 0;
        offsetY=offsetY || 0;
        isFollowTargetScale=isFollowTargetScale===false?false:true;
        if(this[key]){
            try {
                this[key].removeFromParent();
                this[key] = null;
            }catch(err){}
        }

        this[key]=createLoserNameTag(name);
        this[key].scale=this[key].initScale=scale || 0.8;
        this[key].y=-this[key].height;
        this.addChild(this[key],5);
        this[key].schedule(function(){
            try{
                if(sprite){
                    var spritePos=sprite.getParent().convertToWorldSpace(sprite.getPosition());
                    this[key].attr({
                        x:spritePos.x+(0.5-sprite.anchorX)*sprite.width+offsetX*(isFollowTargetScale?sprite.getScaleX():1),
                        y:spritePos.y+(1-sprite.anchorY)*sprite.height+offsetY*(isFollowTargetScale?sprite.getScaleY():1),
                        visible:sprite.isVisible()
                    });

                    if(isFollowTargetScale){
                        this[key].scaleX=sprite.getScaleX()*this[key].initScale;
                        this[key].scaleY=sprite.getScaleY()*this[key].initScale;
                    }
                }
            }catch(err){
                this[key].unscheduleAllCallbacks();
            }
        }.bind(this),0.01);
    },
    //设置被整人名字标签
    setLoserNameTag:function(sprite,scale,offsetX,offsetY,isFollowTargetScale){
        this.createNameTag("_loserNameTag",null,sprite,scale,offsetX,offsetY,isFollowTargetScale);
    },
    removeLoserNameTag:function(){
        if(this._loserNameTag){
            try {
                this._loserNameTag.removeFromParent();
                this._loserNameTag = null;
            }catch(err){}
        }
    },
    //设置史小坑名字标签
    setMyNameTag:function(sprite,scale,offsetX,offsetY,isFollowTargetScale){
        this.createNameTag("_myNameTag",getMyName(),sprite,scale,offsetX,offsetY,isFollowTargetScale);
    },
    removeMyNameTag:function(){
        if(this._myNameTag){
            try {
                this._myNameTag.removeFromParent();
                this._myNameTag = null;
            }catch(err){}
        }
    }
});

var GameMenuLayer=cc.Layer.extend({
    size:null,
    goldBtn:null,
    tipsBtn:null,
    kengBB:null,
    ctor:function(){
        this._super();
        this.size=cc.director.getWinSize();
        this.initSurface();
        return true;
    },
    initSurface:function(){
        var leftSpacing=95;
        var spacing=180;

        //金币按钮
        var goldBtn=this.createBtnItem(getGoldNum(),"game_btn_gold",isHidePurchase==1?"game_hat":"game_btn_add");
        goldBtn.attr({
            x:leftSpacing+spacing*0,
            y:this.size.height-50
        });
        this.addChild(goldBtn);
        goldBtn.callback=function(){
            if(isHidePurchase==1)return;
            _pauseGame();
            var storeLayer=new StoreLayer();
            storeLayer.addToCurScene();
        }.bind(this);
        this.goldBtn=goldBtn;

        //提示按钮
        var tipsBtn=this.createBtnItem("提示","game_btn_hint","game_hat");
        tipsBtn.attr({
            x:leftSpacing+spacing*1,
            y:this.size.height-50
        });
        this.addChild(tipsBtn);
        tipsBtn.callback=function(){
            this.pauseGame();
            var tipsLayer=new GameTipsLayer();
            tipsLayer.addToCurScene();
        }.bind(this);
        this.tipsBtn=tipsBtn;

        //跳过按钮
        var passGold=100;
        if(isMobile()){
            var onlinePassGold=getOnlineData("passGold");
            if(onlinePassGold && onlinePassGold!=""){
                passGold=parseInt(onlinePassGold);
            }
        }

        var passBtn=this.createBtnItem(passGold+"金币","game_btn_skip","game_hat");
        passBtn.attr({
            x:leftSpacing+spacing*2,
            y:this.size.height-50
        });
        this.addChild(passBtn);
        passBtn.callback=function(){
            if(consumeGold(passGold,false,function(){_resumeGame();},isMobile("Android")?true:false)){
                this.getParent().gameWin("",1);
                if(isMobile()){
                    //统计跳过
                    CommonPlatform.getInstance().umengEvent(addZero(_preSelectLevel)+"04","")
                }
            }else{
                if(isALLGameWeb==1 || isHidePurchase==1)return;
                _pauseGame();
            }
        }.bind(this);
        this.passBtn = passBtn;
        //暂停按钮
        var pauseBtn=createButton({img:getResImg("game_btn_pause")});
        pauseBtn.attr({
            x:this.size.width-50,
            y:this.size.height-50
        });
        this.addChild(pauseBtn);
        pauseBtn.callback=function(){
            this.pauseGame();
            var pauseLayer=new PauseGameLayer();
            pauseLayer.addToCurScene();
        }.bind(this);
        this.pauseBtn=pauseBtn;

        // 刘海屏适配
        var topHeight2=0;
        if(isMobile() && CommonPlatform.getInstance().isNotch()){
            // var topHeight1 = CommonPlatform.getInstance().getTopHeight();
            topHeight2 = 40;
            trace("刘海屏长度："+topHeight2);
            pauseBtn.y-=topHeight2;
        }

        //适配小屏幕顶部状态栏按钮位置
        var btnArr=[goldBtn,tipsBtn,passBtn];
        var w=(cc.director.getWinSize().width-pauseBtn.width)/btnArr.length;
        for(var i=0;i<btnArr.length;i++){
            var btn=btnArr[i];
            if(btn.width+25<=w)break;
            if(btn.width+25>w)
                btn.scale=w/(btn.width+25);
            btn.x=(i+0.5)*w;
            btn.y-=topHeight2;
        }

        //攻略按钮
        if(isHidePurchase!=1) {
            if (isMobile("iOS") && isReview != 1) {

                var strategyBtn = createButton({img: getResImg("game_btn_strategy"), soundOff: false});
                strategyBtn.attr({
                    x: 65,
                    y: 170
                });
                this.addChild(strategyBtn, 10);
                strategyBtn.callback = function () {
                    CommonPlatform.getInstance().openStrategy();
                };
                //}else if(isMobile("Android")){
            } else {
                var strategyBtn = createButton({img: getResImg("game_btn_strategy"), soundOff: false});
                strategyBtn.attr({
                    x: 65,
                    y: 170
                });
                this.addChild(strategyBtn, 10);
                strategyBtn.callback = function () {
                    if (getIsBuyStrategy() == 1) {
                        if (isMobile()) {
                            CommonPlatform.getInstance().openFile(getClassName(_preSelectLevel));
                        }
                    } else {
                        _pauseGame();
                        new StrategyLayer().addToCurScene();
                    }
                };
            }
        }

        if(isBrowser() && isTestMode==1){
            //广告占位
            var adBanner=createScale9Sprite(getResImg("game_gold_frame"));
            adBanner.attr({
                x:this.size.width/2,
                y:0,
                anchorY:0,
                width:this.size.width,
                height:120
            });
            this.addChild(adBanner);

            var adLabel=new cc.LabelTTF("横幅广告专用位","",40);
            adLabel.attr({
                x:adBanner.width/2,
                y:adBanner.height/2,
                color:cc.color(0,0,0)
            });
            adBanner.addChild(adLabel);
        }

        //坑BB
        //this.kengBB=createLevelSprite("k_dw_bb_stand1.png");
        //this.kengBB.attr({
        //    x:winCenter().x+230,
        //    y:120,
        //    anchorY:0
        //});
        //this.addChild(this.kengBB);
        //setAnimation(this.kengBB,0.3,[getResImg("k_dw_bb_stand1.png"),getResImg("k_dw_bb_stand2.png")]);

    },
    kengBBCry:function(callback){ //坑BB哭泣
        //this.kengBB.stopAllActions();
        //setAnimation(this.kengBB,0.2,[getResImg("k_dw_bb_cry2.png"),getResImg("k_dw_bb_cry1.png")]);
        //playEffect(res_sound.cry_mp3);
        //this.runAction(cc.sequence(
        //    cc.delayTime(2),
        //    cc.callFunc(function(){
        //        if(callback)callback();
        //    },this)
        //));
    },
    kengBBAsh:function(callback){ //坑BB被炸
        //this.kengBB.stopAllActions();
        //setAnimation(this.kengBB,0.2,[
        //    getResImg("k_sssz_bb_ash_1.png"),
        //    getResImg("k_sssz_bb_ash_2.png"),
        //    getResImg("k_sssz_bb_ash_3.png"),
        //    getResImg("k_sssz_bb_ash_4.png")
        //]);
        //
        //this.runAction(cc.sequence(
        //    cc.delayTime(2),
        //    cc.callFunc(function(){
        //        if(callback)callback();
        //    },this)
        //));
    },
    kengBBSurprised:function(callback){ //坑BB惊讶
        //this.kengBB.stopAllActions();
        //setAnimation(this.kengBB,0.2,[
        //    getResImg("k_sssz_bb_surprised_1.png"),
        //    getResImg("k_sssz_bb_surprised_2.png")
        //],false,function(){
        //    setSpriteTxture(this, getResImg("k_sssz_bb_surprised_2.png"));
        //    this.anchorY=0;
        //});
        //
        //this.runAction(cc.sequence(
        //    cc.delayTime(2),
        //    cc.callFunc(function(){
        //        if(callback)callback();
        //    },this)
        //));
    },
    kengBBLaugh:function(callback){ //坑BB笑
        //this.kengBB.stopAllActions();
        //setAnimation(this.kengBB,0.2,[getResImg("k_dw_bb_laugh1.png"),getResImg("k_dw_bb_laugh2.png")]);
        //playEffect(res_sound.laugh_mp3);
        //this.runAction(cc.sequence(
        //    cc.delayTime(3),
        //    cc.callFunc(function(){
        //        if(callback)callback();
        //    },this)
        //));
    },
    createBtnItem:function(txt,leftIconName,rightIconName){
        var btn=createScale9Button({img:getResImg("game_gold_frame")});
        btn.width=btn.width+35;

        var leftIcon=createSprite(getResImg(leftIconName));
        leftIcon.attr({
            x:20,
            y:btn.height/2
        });
        btn.addChild(leftIcon);

        if(rightIconName) {
            var rightIcon = createSprite(getResImg(rightIconName));
            rightIcon.attr(
                {x: btn.width - 10,y: btn.height - 4}
            );

            btn.addChild(rightIcon);
        }

        btn.txtLabel=new cc.LabelTTF(""+txt,"",22);
        btn.txtLabel.attr({
            x:btn.width/2+23,
            y:btn.height/2,
            color:cc.color(118,93,91)
        });
        btn.addChild(btn.txtLabel);

        return btn;
    },
    pauseGame:function(){
        _pauseGame();
    },
    resumeGame:function(){
        _resumeGame();
    }
});

var GamePropBox=cc.Layer.extend({
    size:null,
    boxMaxCount:3,
    propBoxList:null,
    ctor:function(){
        this._super();
        this.size=cc.director.getWinSize();
        this.initSurface();
    },
    initSurface:function(){

        var bg=createSprite(getResImg("game_inventory_frame_1.png"));
        bg.attr({
            anchorY:0,
            x:this.size.width/2,
            y:100
        });
        this.addChild(bg);

        this.propBoxList=[];
        var space=115;
        for(var i=0;i<this.boxMaxCount;i++){
            //格子
            var propBox=createSprite(getResImg("game_inventory_frame_2.png"));
            propBox.attr({
                x:bg.width/2-space*(this.boxMaxCount/2-0.5)+i*space,
                y:bg.height/2
            });
            bg.addChild(propBox);

            //问号
            var question=createSprite(getResImg("game_inventory_frame_question.png"));
            question.setPosition(propBox.x,propBox.y);
            bg.addChild(question);

            //道具节点
            var propBoxNode=new cc.Node();
            propBoxNode.setPosition(propBox.x,propBox.y);
            bg.addChild(propBoxNode,1);

            this.propBoxList[i]={
                box:propBoxNode,
                question:question,
                prop:null
            };
        }
    },
    addProp:function(propImg,propTag,pos){
        if(!this.visible)return;

        var _this=this;

        this.removePropByTag(propTag);

        playEffect(res_sound.click_mp3);

        var prop=createSprite(propImg);
        prop.propTag=propTag;


        for(var i= 0,len=this.propBoxList.length;i<len;i++){
            var propBoxList=this.propBoxList[i];
            if(!propBoxList.prop){
                prop.index=i;
                prop.setPosition(propBoxList.box.convertToNodeSpace(pos));
                propBoxList.box.addChild(prop);
                propBoxList.prop=prop;
                break;
            }
        }

        var scale=1;
        if(prop.width > prop.height){
            scale=80/prop.width;
        }else{
            scale=80/prop.height;
        }
        prop._innerScale=scale;


        prop.runAction(cc.sequence(
            cc.spawn(
                cc.moveTo(0.1,cc.p(0,0)),
                cc.scaleTo(0.1,scale)
            ),
            cc.callFunc(function(){
                _this.resumePropPos();
                cc.eventManager.addListener({
                    event:cc.EventListener.TOUCH_ONE_BY_ONE,
                    swallowTouches:false,
                    onTouchBegan:function(touch,event){
                        if(!_this.visible)return false;

                        var target=event.getCurrentTarget();
                        var locationInNode = target.convertToNodeSpace(touch.getLocation());
                        var s = target.getContentSize();
                        var rect = cc.rect(0, 0, s.width, s.height);
                        if (cc.rectContainsPoint(rect, locationInNode)) {
                            target.scale=scale+0.2;
                            _this.setPropZOrder(target.index);

                            var curScene=cc.director.getRunningScene();
                            if(curScene.propBeganCallBack){
                                curScene.propBeganCallBack(target.propTag,touch.getLocation(),target);
                            }
                            return true;
                        }
                        return false;
                    },
                    onTouchMoved:function(touch,event){
                        var target=event.getCurrentTarget();
                        target.x+=touch.getDelta().x;
                        target.y+=touch.getDelta().y;

                        var curScene=cc.director.getRunningScene();
                        if(curScene.propMoveCallBack){
                            curScene.propMoveCallBack(target.propTag,touch.getLocation(),target);
                        }
                    },
                    onTouchEnded:function(touch,event){
                        var target=event.getCurrentTarget();
                        var curScene=cc.director.getRunningScene();
                        if(curScene.propCallBack){
                            if(curScene.propCallBack(target.propTag,touch.getLocation(),target)){
                                _this.removePropByTag(target.propTag);
                            }else{
                                target.scale=scale;
                                _this.resumePropPos();
                            }
                        }else{
                            _this.resumePropPos();
                        }
                    }
                },prop);
            })
        ));

    },
    setPropZOrder:function(index){
        for(var i= 0,len=this.propBoxList.length;i<len;i++){
            var propBoxList=this.propBoxList[i];
            if(index==i){
                propBoxList.box.setLocalZOrder(2);
            }else{
                propBoxList.box.setLocalZOrder(1);
            }
        }
    },
    resumePropPos:function(){
        for(var i= 0,len=this.propBoxList.length;i<len;i++){
            var propBoxList=this.propBoxList[i];
            if(propBoxList.prop){
                propBoxList.question.visible=false;
                propBoxList.prop.setPosition(0,0);
                propBoxList.prop.scale=propBoxList.prop._innerScale;
            }else{
                propBoxList.question.visible=true;
            }
        }
    },
    removePropByTag:function(propTag){
        for(var i= 0,len=this.propBoxList.length;i<len;i++){
            var propBoxList=this.propBoxList[i];
            if(propBoxList.prop && propBoxList.prop.propTag==propTag){
                propBoxList.prop.removeFromParent();
                propBoxList.prop=null;
                break;
            }
        }
        this.resumePropPos();
    }
});