/**
 * Created by weicheng on 15/10/6.
 *
 * 游戏主场景
 */

var MainSceneLayer=cc.Layer.extend({
    size:null,
    ctor:function(){
        this._super();
        this.size=cc.director.getWinSize();

        imgSearchPath="res_MainScene";

        var myName=getMyName();

        setIsReview();

        if(isMobile()){
            //游戏结束广告频率在线参数
            var onlineAdHz=getOnlineData("ad_insert_gameOver_hz");
            if(onlineAdHz && onlineAdHz!="" && !isNaN(onlineAdHz)){
                adHz=onlineAdHz;
            }

            //关卡选择广告频率在线参数
            var onlineAdSelectHz=getOnlineData("ad_insert_select_hz");
            if(onlineAdSelectHz && onlineAdSelectHz!="" && !isNaN(onlineAdSelectHz)){
                adSelectHz=onlineAdSelectHz;
            }

            var onlineAdPauseHz=getOnlineData("ad_insert_pause_hz");
            if(onlineAdPauseHz && onlineAdPauseHz!=""){
                adPauseHz=onlineAdPauseHz;
            }

            if(isMobile("Android")){
                //是否屏蔽广点通广告
                var onlineIsShieldGdt=getOnlineData("isShieldGdt");
                if(onlineIsShieldGdt && onlineIsShieldGdt!=""){
                    isShieldGdt=onlineIsShieldGdt;
                }

                //关卡结束弹出礼包窗口频率
                var onlineShowPackageHz=getOnlineData("show_package_hz");
                if(onlineShowPackageHz && onlineShowPackageHz!="" && !isNaN(onlineShowPackageHz)){
                    showPackageHz=onlineShowPackageHz;
                }

                //关卡失败弹出商品购买窗口频率
                var onlineShowPurchaseHz=getOnlineData("show_purchase_hz");
                if(onlineShowPurchaseHz && onlineShowPurchaseHz!="" && !isNaN(onlineShowPurchaseHz)){
                    showPurchaseHz=onlineShowPurchaseHz;
                }
            }
        }

        if(curMusicIndex!=1){
            curMusicIndex=1;
            stopMusic();
            playMusic(res_sound.music_MainScene_mp3,true);
        }

        //设置游戏总时长
        setGameTime();

        //背景
        var bgColor=new cc.LayerColor(cc.color(219,205,187));
        this.addChild(bgColor,-1);

        var bg=createSprite(getResImg("k_sy_bg.png","res_MainScene"));
        bg.attr({
            anchorY:0,
            x:winCenter().x,
            y:0
        });
        this.addChild(bg);

        if(isBaoXiao) {
            bg.visible = false;

            var bg = createSprite(getResImg("KL8_BG", "res_common"));
            bg.attr({
                anchorY: 0,
                x: winCenter().x,
                y: 0
            });
            this.addChild(bg);

            //相框
            var bg2 = createSprite(getResImg("KL8_Front", "res_common"));
            bg2.attr({
                anchorY: 0,
                x: winCenter().x,
                y: 0
            });
            this.addChild(bg2);

            //史小坑
            var sxk = createSprite(getResImg("KL8_sxk", "res_common"));
            sxk.attr({
                x: winCenter().x,
                y: winCenter().y
            });
            this.addChild(sxk);
            //渐入渐出动画效果
            sxk.runAction(cc.sequence(cc.fadeOut(0.8), cc.fadeIn(0.8)).repeatForever());
        }

        //底部线条
        var buttonLine=createSprite(getResImg("home_bg_2.png","res_MainScene"));
        buttonLine.attr({
            anchorY:0,
            x:winCenter().x,
            y:0
        });
        this.addChild(buttonLine);

        //标题
        var title=createSprite(getResImg("k_sy_title.png","res_MainScene"));
        title.attr({
            x:winCenter().x,
            y:this.size.height-235
        });
        this.addChild(title);

        //史小坑
        var man=createLevelSprite("k_sy_people1.png",0.1,[
            "k_sy_people1.png",
            "k_sy_people2.png",
            "k_sy_people3.png",
            "k_sy_people4.png",
            "k_sy_people5.png",
            "k_sy_people6.png",
            "k_sy_people7.png",
            "k_sy_people8.png",
            "k_sy_people9.png",
            "k_sy_people10.png"
        ]);
        man.attr({x:winCenter().x+15,y:winCenter().y+-280.2});
        this.addChild(man);

        //左小丑
        var hezi=createLevelSprite("k_sy_hezi1.png",0.15,["k_sy_hezi1","k_sy_hezi2","k_sy_hezi1","k_sy_hezi2","k_sy_hezi3","k_sy_hezi4","k_sy_hezi3","k_sy_hezi4","k_sy_hezi3","k_sy_hezi4"]);
        hezi.attr({x:winCenter().x+-152.5,y:winCenter().y+-351.9,scaleX:-1});
        this.addChild(hezi);

        //右小丑
        var hezi2=createLevelSprite("k_sy_hezi4.png",0.15,["k_sy_hezi4","k_sy_hezi3","k_sy_hezi4","k_sy_hezi3","k_sy_hezi4","k_sy_hezi3","k_sy_hezi2","k_sy_hezi1","k_sy_hezi2","k_sy_hezi1"]);
        hezi2.attr({x:winCenter().x+159.0,y:winCenter().y+-358.5});
        this.addChild(hezi2);

        //hahaha
        var ha=createLevelSprite("k_sy_ha.png",0.2,["k_sy_ha2.png","k_sy_ha.png"]);
        ha.attr({x:winCenter().x+-3.9,y:winCenter().y+-200});
        this.addChild(ha);


        if(isBaoXiao){
            //玩家名字
            if (getMyName() != "") {
                var nameBox = createSprite(getResImg("k_sy_name.png", "res_MainScene"));
                nameBox.attr({
                    x: winCenter().x,
                    y: winCenter().y - 230
                });
                this.addChild(nameBox);
                addTouchCallBack(nameBox, function () {
                    var reNameLayer = new ReNameLayer();
                    cc.director.getRunningScene().addChild(reNameLayer, 99);
                });
                nameBox.beganCallback = function (touch) {
                    var rect = cc.rect(nameBox.x - 143, nameBox.y + 15, 290, 60);
                    if (cc.rectContainsPoint(rect, touch.getLocation())) {
                        return true;
                    }
                    return false;
                };

                var name = new cc.LabelTTF(myName, "", 30);
                name.attr({
                    x: nameBox.width / 2,
                    y: nameBox.height / 2 + 43,
                    color: cc.color(116, 86, 52)
                });
                nameBox.addChild(name);
                nameBox.schedule(function () {
                    myName = getMyName();
                    if (myName != name.string) {
                        name.string = myName;
                    }
                }, 0.05);


                //点击改名
                var tips = createLevelSprite("k_sy_change.png");
                tips.attr({x: 265.9, y: 172});
                nameBox.addChild(tips);
                tips.runAction(cc.sequence(
                    cc.delayTime(1),
                    cc.fadeTo(0.5, 30),
                    cc.delayTime(0.2),
                    cc.fadeTo(0.5, 255)
                ).repeatForever());

            } else {
                //play提示
                var play = createSprite(getResImg("home_play", "res_MainScene"));
                play.attr({
                    x: winCenter().x,
                    y: winCenter().y - 230
                });
                this.addChild(play);
            }

            //开始按钮
            var starBtn = createButton({img: getResImg("home_btn_04", "res_MainScene")});
            starBtn.attr({
                x: winCenter().x,
                y: winCenter().y - 340
            });
            this.addChild(starBtn);
            starBtn.callback = function () {
                if (getIsResetName() != 0) {
                    cc.director.runScene(new LevelSelectScene());
                    // cc.director.runScene(new AllLevelPassLayer());
                } else {
                    var reNameLayer = new ReNameLayer();
                    cc.director.getRunningScene().addChild(reNameLayer, 99);
                }
            }
            starBtn.runAction(cc.sequence(cc.scaleTo(0.4, 1.1), cc.scaleTo(0.4, 1)).repeatForever());
        }else {
            //玩家名字
            if(getMyName()!=""){
                var nameBox=createSprite(getResImg("k_sy_name.png","res_MainScene"));
                nameBox.attr({
                    x:winCenter().x,
                    y:winCenter().y+100
                });
                this.addChild(nameBox);
                addTouchCallBack(nameBox,function(){
                    var reNameLayer=new ReNameLayer();
                    cc.director.getRunningScene().addChild(reNameLayer,99);
                });
                nameBox.beganCallback=function(touch){
                    var rect=cc.rect(nameBox.x-143,nameBox.y+15,290,60);
                    if(cc.rectContainsPoint(rect,touch.getLocation())){
                        return true;
                    }
                    return false;
                };

                var name=new cc.LabelTTF(myName,"",30);
                name.attr({
                    x:nameBox.width/2,
                    y:nameBox.height/2+43,
                    color:cc.color(116,86,52)
                });
                nameBox.addChild(name);
                nameBox.schedule(function(){
                    myName=getMyName();
                    if(myName!=name.string) {
                        name.string = myName;
                    }
                },0.05);

                var tips=createLevelSprite("k_sy_change.png");
                tips.attr({x:265.9,y:172});
                nameBox.addChild(tips);
                tips.runAction(cc.sequence(
                    cc.delayTime(1),
                    cc.fadeTo(0.5,30),
                    cc.delayTime(0.2),
                    cc.fadeTo(0.5,255)
                ).repeatForever());

            }else{
                //play提示
                var play=createSprite(getResImg("home_play","res_MainScene"));
                play.attr({
                    x:winCenter().x,
                    y:winCenter().y+100
                });
                this.addChild(play);
            }

            //开始按钮
            var starBtn=createButton({img:getResImg("home_btn_04","res_MainScene")});
            starBtn.attr({
                x:winCenter().x,
                y:winCenter().y+10
            });
            this.addChild(starBtn);
            starBtn.callback=function(){
                if(getIsResetName()!=0){
                    cc.director.runScene(new LevelSelectScene());
                    // cc.director.runScene(new AllLevelPassLayer());
                }else{
                    var reNameLayer=new ReNameLayer();
                    cc.director.getRunningScene().addChild(reNameLayer,99);
                }
            }
            starBtn.runAction(cc.sequence(cc.scaleTo(0.4,1.1),cc.scaleTo(0.4,1)).repeatForever());
        }

        //点子征集按钮
        //if(getOnlineData("isShowIdeaBtn")=="true"){
        if(isOpen("gameIdea")){
            var ideaCollectionBtn=createButton({img:getResImg("home_btn_02","res_MainScene")});
            ideaCollectionBtn.attr({
                x:winCenter().x,
                y:60
            });
            this.addChild(ideaCollectionBtn);
            ideaCollectionBtn.callback=function(){
                new IdeaCollectionLayer().addToCurScene();
            };
        }

        if(isBaoXiao){
            buttonLine.visible = false;
            title.visible = false;
            man.visible = false;
            hezi.visible = false;
            hezi2.visible = false;
            ha.visible = false;
        }

        //投诉按钮
        //if(!isHideOutChain() && isReview!=1 && !isHideShare()){
        //    var complaintBtn=createButton({img:getResImg("home_btn_01","res_MainScene")});
        //    complaintBtn.attr({
        //        x:winCenter().x-255,
        //        y:60
        //    });
        //    this.addChild(complaintBtn);
        //    complaintBtn.callback=function(){
        //        trace("投诉");
        //        if(isMobile()){
        //            CommonPlatform.getInstance().feedback();
        //        }
        //    };
        //}

        if(isWeb==0){
            //设置按钮
            var settingBtn=createButton({img:getResImg("home_btn_03","res_MainScene")});
            settingBtn.attr({
                x:cc.director.getWinSize().width-settingBtn.width/2-20,
                y:60
            });
            this.addChild(settingBtn);
            settingBtn.callback=function(){
                new SettingLayer().addToCurScene();
            };
        }

        //新手礼包按钮
        if(isWeb==0 && getIsBuyNovicePackage()==0 && isALLGameWeb!=1 && isHidePurchase!=1){
            var NovicePackageBtn=createButton({img:getResImg("gift_btn_new","res_Panel")});
            NovicePackageBtn.attr({
                x:this.size.width-80,
                y:winCenter().y+255
            });
            this.addChild(NovicePackageBtn);
            NovicePackageBtn.callback=function(){
                if(getIsBuyNovicePackage()==0) {
                    new NovicePackageLayer().addToCurScene();
                }else{
                    this.visible=false;
                }
            };

            var ray = createSprite(getResImg("gift_ray2.png", "res_Panel"));
            ray.attr({
                x: NovicePackageBtn.width / 2,
                y: NovicePackageBtn.height / 2
            });
            NovicePackageBtn.addChild(ray, -1);
            ray.runAction(cc.rotateBy(3.5, 360).repeatForever());
            ray.runAction(cc.sequence(
                cc.scaleTo(0.7, 1.2),
                cc.scaleTo(0.7, 1)
            ).repeatForever());
        }

        //更多游戏按钮
        //if(getOnlineData("isShowLink")=="true" || getChannel()=="play"){
        if(isOpen("gameMore") || getChannel()=="play"){
            var moreBtn=createButton({img:getResImg("home_btn_more","res_Panel")});
            moreBtn.attr({
                x:100,
                y:winCenter().y+255
            });
            this.addChild(moreBtn);
            moreBtn.callback=function(){
                trace("更多游戏");
                CommonPlatform.getInstance().moreGame();
            };
        }

        //小游戏按钮
        var overLevelLittleGame=getOnlineData("overLevelLittleGame") || 3;
        if (isOpen("littleGame") && getLevelPassNum()>=overLevelLittleGame) {
            //小游戏按钮
            var littleGameBtn = createButton({img: getResImg("littlegame", "res_common")});
            littleGameBtn.attr({
                x: this.size.width-80,
                y: cc.director.getWinSize().height - littleGameBtn.height - 400
            });
            littleGameBtn.scale = 1.5;
            this.addChild(littleGameBtn);
            littleGameBtn.callback = function () {
                trace("小游戏按钮");
                CommonPlatform.getInstance().openLittleGame();
            };
        }

        //公告按钮
        try {
            //if (getOnlineData("isShowNoticeBtn") == "true") {
            if (isOpen("announcement")) {
                var noticeBtn = createButton({img:getResImg("home_btn_gg.png","res_MainScene")});
                noticeBtn.attr({
                    x: noticeBtn.width/2+20,
                    y: 60
                });
                this.addChild(noticeBtn);
                noticeBtn.callback = function () {
                    // new CommunityLayer().addToCurScene();

                    isShowRedPoint=false;
                    if(redPoint){
                        redPoint.visible = false;
                    }
                    if(isMobile("Android")){
                        CommonPlatform.getInstance().openNotice();
                    }
                }

                if (isShowRedPoint) {
                    var redPoint=createSprite(getResImg("redPoint.png","res_MainScene"));
                    redPoint.attr({
                        x: noticeBtn.width-10,
                        y: noticeBtn.height-10
                    });
                    noticeBtn.addChild(redPoint);
                }


            }
        }catch(e){}


        //返回按键监听
        cc.eventManager.addListener({
            event: cc.EventListener.KEYBOARD,
            onKeyReleased: function(keyCode, event) {
                if (keyCode == 6) {
                    trace("调用退出");
                    CommonPlatform.getInstance().exit();
                }
            }
        }, this);


        return true;
    },
    onEnter:function(){
        this._super();
        //首次打开加100金币
        if(isWeb==0 && !getIsFirstOpen()){
            addGoldNum(200,true);
            setIsFirstOpen();
        }
        if(isMobile()){
            CommonPlatform.getInstance().removeBanner();
        }
        closeNativeAd();
        showAd("gameMain");
    }
});

var MainScene=cc.Scene.extend({
    ctor:function(){
        this._super();
        cc.director.getRunningScene().cleanup();
        removePlistCache();
        var layer=new MainSceneLayer();
        this.addChild(layer);
    }
});