/**
 * Created by weicheng on 15/10/6.
 *
 * 游戏预加载场景
 */

var ReadyLayer=cc.Layer.extend({
    loserNames:[],
    ctor:function(level){
        this._super();
        var size=cc.director.getWinSize();
        var _this=this;

        //设置游戏总时长
        setGameTime();

        setIsReview();

        if(SensitiveConfig.length<=0){
            initSensitiveConfig();
        }

        if(isWeb!=1){
            if(curMusicIndex==0){
                curMusicIndex=1;
                stopMusic();
                playMusic(res_sound.music_MainScene_mp3,true);
            }
        }

        setSelectLevel(level);

        //初始化关卡文案
        initLevelWordConfig(getClassName(level));

        //添加关卡资源
        addLevelSpriteFrames(getClassName(level));

        var bg=createSprite(getResImg("com_bg_01"));
        bg.attr({
            anchorY:1,
            x:size.width/2,
            y:size.height
        });
        this.addChild(bg);

        //返回按钮
        if(isWeb==1 && isBrowser() && isWebTest!=1){}
        else{
            var returnBtn=createButton({img:getResImg("com_btn_back")});
            returnBtn.attr({
                x:80,
                y:size.height-110
            });
            this.addChild(returnBtn,10);
            returnBtn.callback=function(){
                removeLevelScenePlist(function(){
                    try{
                        cc.director.runScene(new LevelSelectScene());
                    }catch(err){
                        _resumeGame();
                        cc.director.runScene(new LevelSelectScene());
                    }
                });
            }
        }

        //外框
        var frame=createSprite(getResImg("proload_frame"));
        frame.attr({
            x:size.width/2,
            y:size.height/2+90
        });
        this.addChild(frame);

        //标题
        var title=new cc.LabelTTF(level+"、"+levelConfig[level-1]["title"],"",24);
        title.attr({
            x:frame.width/2,
            y:frame.height-63
        });
        frame.addChild(title);

        //关卡图
        var icon=createSprite(getResImg("icon_"+levelConfig[level-1]["className"],"res_levelIcon"));
        icon.attr({
            x:frame.width/2,
            y:frame.height/2+67
        });
        frame.addChild(icon);

        //关卡描述
        var desc=new cc.LabelTTF(levelConfig[level-1]["desc"].replace(/{n}/g,"\n"),"",26,cc.size(380,120),cc.TEXT_ALIGNMENT_CENTER);
        desc.attr({
            anchorY:1,
            x:frame.width/2,
            y:257,
            color:cc.color(75,50,16)
        });
        frame.addChild(desc);

        //输入框
        var box=createLevelSprite("proload_name_box_01.png");
        box.attr({
            x:frame.width/2,
            y:118
        });
        frame.addChild(box);

        this.nameLabel=new cc.LabelTTF("","",40);
        this.nameLabel.attr({
            x:box.x,
            y:box.y
        });
        frame.addChild(this.nameLabel);

        var textFiled=new cc.EditBox(cc.size(378,70),createScale9Sprite(getResImg("proload_name_box_01.png")));
        textFiled.attr({
            x:box.width/2,
            y:box.height/2,
            opacity:0
        });
        textFiled.setCascadeOpacityEnabled(true);
        textFiled.setMaxLength(8);
        textFiled.setDelegate(this);
        textFiled.setFontSize(36);
        textFiled.setPlaceholderFontSize(36);
        //if(isMobile("iOS")){
        //    textFiled.setPlaceHolder("请输入小伙伴名字");
        //}
        box.addChild(textFiled,-1);
        this.textFiled=textFiled;

        textFiled.string=_curLoserName;
        if(_curLoserName!=""){
            this.nameLabel.string=_curLoserName;
        }

        //历史名字列表
        this.loserNames=getHistoryLoserName();
        for(var i=0;i<3;i++){
            var nameBtn=createScale9Button({img:getResImg("proload_name_box_02.png")});
            nameBtn.nameTag=this.loserNames[i] || "";
            nameBtn.attr({
                x:frame.width/2-125+i*120,
                y:62
            });
            frame.addChild(nameBtn);
            nameBtn.callback=function(){
                textFiled.string=this.nameTag;
                _this.nameLabel.string=this.nameTag;
            };

            var nameLabel=new cc.LabelTTF(this.loserNames[i],"",22,cc.size(nameBtn.width-10,28),cc.TEXT_ALIGNMENT_CENTER);
            nameLabel.attr({
                x:nameBtn.width/2,
                y:nameBtn.height/2,
                color:cc.color(0,0,0)
            });
            nameBtn.addChild(nameLabel);

            if(isBrowser()){
                if(i==0 && this.nameLabel.string==""){
                    textFiled.string=this.loserNames[0];
                    this.nameLabel.string=this.loserNames[0];
                }
            }
        }

        if(this.nameLabel.string==""){
            this.nameLabel.string="请输入小伙伴名字";
        }

        if(_curLoserName!=""){
            textFiled.string=_curLoserName;
            this.nameLabel.string=_curLoserName;
        }


        //开始按钮
        var startBtn=createButton({img:getResImg("proload_btn_play")});
        startBtn.attr({
            x:size.width/2,
            y:size.height/2-360
        });
        this.addChild(startBtn);

        var startGame = function(){
            var Txt=textFiled.string.replace(/ /g,"");
            if(Txt.length>0){
                if(!checkStrSpecialChar(Txt) && !cheackSensitiveWord(Txt)){
                    _curLoserName=Txt;
                    setHistoryLoserName(Txt);

                    removeMainScenePlist(function(){
                        try{
                            cc.director.runScene(eval("new "+getClassName(level)+"()"));
                        }catch(err){
                            trace("场景有错误（自动跳到测试页面）："+err);
                            cc.director.runScene(new HelloWorldScene());
                        }
                    });
                }
            }else{
                showToast("你想整谁？输名字！",cc.color(255,0,0));
            }
        };

        startBtn.callback = startGame;


        //自动开始游戏，发布时请去掉 start＝＝＝＝＝＝＝＝＝＝＝＝＝＝＝＝＝＝＝＝＝＝
        //this.runAction(cc.sequence(cc.delayTime(0.5), cc.callFunc(function(){
        //    startGame();
        //})));
        //自动开始游戏 end -＝＝＝＝＝＝＝＝＝＝＝＝＝＝＝＝＝＝＝＝＝＝

        if(isBrowser()){
            share("坑8求助："+levelConfig[_preSelectLevel-1]["helpWord"], "http://h5.kdyx.cn/"+gameKey,1002);
        }

        if(isBrowser() && isTestMode==1){
            var levelNameLabel=new cc.LabelTTF("关卡类名：\n"+getClassName(level),"",24,null,cc.TEXT_ALIGNMENT_CENTER);
            levelNameLabel.attr({
                anchorY:1,
                x:size.width/2,
                y:size.height-30,
                //color:cc.color(0,0,0),
                lineWidth:3,
                strokeStyle:cc.color(0,0,0)
            });
            this.addChild(levelNameLabel);
        }

    },
    editBoxEditingDidBegin: function (editBox) {
        if(isMobile())this.nameLabel.visible=false;
    },
    editBoxTextChanged: function (editBox, text) {
        this.nameLabel.string=text;
    },
    editBoxReturn: function (editBox) {
        editBox.string=editBox.string.replace(/ /g,"");
        editBox.string=editBox.string.substr(0,8);
        if(editBox.string!=""){
            this.nameLabel.string=editBox.string;
        }else{
            this.nameLabel.string="请输入小伙伴名字";
        }
        if(isMobile())this.nameLabel.visible=true;
    }
});

var ReadyScene=cc.Scene.extend({
    callback:null,
    ctor:function(level,callback){
        this._super();
        cc.director.getRunningScene().cleanup();
        removePlistCache();
        if(level)_preSelectLevel=level;
        this.addChild(new ReadyLayer(_preSelectLevel));
        if(callback)this.callback=callback;
    },onEnter:function(){
        this._super();
        if(isMobile("iOS")){
            CommonPlatform.getInstance().showBanner();
        }
        if(this.callback)this.callback();
    },
    onExit:function(){
        this._super();
        if(isMobile("iOS")){
            CommonPlatform.getInstance().removeBanner();
        }
    }
});