/**
 * Created by weicheng on 15/10/6.
 *
 * 网页版游戏场景类
 */
isWeb=1;    //当前为网页版,1:单关版，2:三关版
isWebTest=0;//关闭网页测试

if(isWeb==2){
    gameMaxLevel=4;
}

var GameSceneBase=cc.Scene.extend({
    level:1, //当前关卡序号
    _className:"GameSceneBase",
    _propBox:null,      //道具栏
    _menuLayer:null,    //菜单栏
    _bgFile:null,
    state:0, //场景状态、0：游戏中，1：胜利，2：失败
    ctor:function(){
        this._super();
        //音效清除
        effectArray = [];

        var _this=this;

        this.level=_preSelectLevel || 1;
        this._className=getClassName(this.level);
        this.size=cc.director.getWinSize();
        this.initSurface();

        stopAllEffect();
        stopMusic();

        this.state=0;

        curMusicIndex=2;
        try{
            var musicPath=eval("res_"+getClassName(this.level)+"_sound");
            if(musicPath){
                var music=musicPath["bg_mp3"];
                if(music)playMusic(music,true);
            }
        }catch(err){
            trace("背景音乐找不到："+err);
        }

        //设置游戏总时长
        setGameTime();
        cc.eventManager.addCustomListener(cc.game.EVENT_HIDE, function(){
            _this.pauseTheGame();
        });
        cc.eventManager.addCustomListener(cc.game.EVENT_SHOW, function(){
            _this.resumeTheGame();
        });


        return true;
    },
    onEnter:function(){
        this._super();
        //设备背景图片
//        addBackground(this._bgFile, this);
        addBackground(null, this);
    },
    pauseTheGame:function(){
        trace("暂停游戏处理");
    },
    resumeTheGame:function(){
        trace("恢复游戏处理");
    },
    gameOver:function(faileKey,lossType){
        faileKey=faileKey || "lossWord1";

        //var swallowLayer=new SwallowViewBase();
        //swallowLayer.blackBg.opacity=0;
        //this.addChild(swallowLayer,99);

        //if(lossType==1){
        //    //炸死
        //    this._menuLayer.kengBBAsh(function(){
        //        this.gameOverCallBack(faileKey);
        //    }.bind(this));
        //}else if(lossType==2){
        //    //吓死（吐奶嘴）
        //    this._menuLayer.kengBBSurprised(function(){
        //        this.gameOverCallBack(faileKey);
        //    }.bind(this));
        //}else{
        //    //哭死
        //    this._menuLayer.kengBBCry(function(){
        //        this.gameOverCallBack(faileKey);
        //    }.bind(this));
        //}

        this.gameOverCallBack(faileKey);
    },
    gameWin:function(winWordKey,winType){
        //var swallowLayer=new SwallowViewBase();
        //swallowLayer.blackBg.opacity=0;
        //this.addChild(swallowLayer,99);
        //this._menuLayer.kengBBLaugh(function(){
        //    this.gameWinCallBack(winWordKey,winType);
        //}.bind(this));


        this.gameWinCallBack(winWordKey,winType);
    },
    gameOverCallBack:function(faileKey){ //faileKey:文案键名（对应失败文案）
        _pauseGame();
        this.unAllSchedule();

        this.rotation=0;
        this.state=2;

        //设置游戏总时长
        setGameTime();

        //添加死亡次数
        addLossCount();

        playEffect(res_sound.faile_mp3);

        var layer=new PanelViewBase();
        this.addChild(layer,99);

        var frame=createSprite(getResImg("failure_bg","res_GameOver"));
        layer.nodeUI_.addChild(frame);

        //文案背景
        var wordBg=createSprite(getResImg("failure_dialog","res_GameOver"));
        wordBg.attr({
            x:frame.width/2+100,
            y:frame.height/2+85
        });
        frame.addChild(wordBg);

        //失败文案
        var faileWordLabel=new cc.LabelTTF(getWordByKey(faileKey),"",24,cc.size(275,80),cc.TEXT_ALIGNMENT_CENTER);
        faileWordLabel.attr({
            x:wordBg.width/2+20,
            y:wordBg.height/2,
            color:cc.color(125,105,101)
        });
        wordBg.addChild(faileWordLabel);

        //史小坑
        var animNumFrames=[0,1,0,1,0,1,2,3,4,5,6,5,6,5,6,5,4,3,2,1];
        var animFrames=[];
        var repeatAnimNum=0;
        for(var i=0;i<animNumFrames.length;i++){
            var repeat=false;
            for(var j=0;j<i;j++){
                if(animNumFrames[i]==animNumFrames[j]){
                    repeat=true;
                    repeatAnimNum=j;
                    break;
                }
            }
            animFrames[i]=repeat?animFrames[repeatAnimNum]:getResImg("failure_man_"+animNumFrames[i]+".png","res_GameOver");
        }
        var man=createSprite(getResImg("failure_man_1.png","res_GameOver"));
        man.attr({
            x:frame.width/2-190,
            y:frame.height/2
        });
        frame.addChild(man);
        setAnimation(man,0.2,animFrames);

        if(isWeb==2){
            //返回菜单按钮
            var exitBtn=createButton({img:getResImg("failure_btn_menu","res_GameOver")});
            exitBtn.attr({
                x:frame.width/2-35,
                y:frame.height/2-70
            });
            frame.addChild(exitBtn);
            exitBtn.callback=function(){
                stopAllEffect();
                removeLevelScenePlist(function(){
                    cc.director.runScene(new LevelSelectScene());
                });
            }.bind(this);
        }else{
            //更多关卡按钮
            var moreBtn=createButton({img:getResImg("web_game_more","res_webCommon")});
            moreBtn.attr({
                x:frame.width/2-35,
                y:frame.height/2-70
            });
            frame.addChild(moreBtn);
            moreBtn.callback=function(){
                trace("更多关卡");
                new DownloadTipsLayer(function(){}).addToCurScene();
            }.bind(this);
        }

        //重来按钮
        var againBtn=createButton({img:getResImg("pause_btn_restart","res_GameOver")});
        againBtn.attr({
            x:frame.width/2+95,
            y:frame.height/2-70
        });
        frame.addChild(againBtn);
        againBtn.callback=function(){
            _resumeGame();
            cc.director.runScene(eval("new "+getClassName(this.level)+"()"));
        }.bind(this);

        //求助按钮
        var helpBtn=createButton({img:getResImg("failure_btn_help","res_GameOver")});
        helpBtn.attr({
            x:frame.width/2+225,
            y:frame.height/2-70
        });
        frame.addChild(helpBtn);
        helpBtn.callback=function(){
            trace("求助");
            __shareTips.show();
        }.bind(this);

        share("坑8求助："+levelConfig[_preSelectLevel-1]["helpWord"], "http://h5.kdyx.cn/"+gameKey,1002);

    },
    gameWinCallBack:function(winWordKey,winType){
        _pauseGame();
        this.unAllSchedule();

        //设置游戏总时长
        setGameTime();

        this.rotation=0;
        this.state=1;

        playEffect(res_sound.win_mp3);

        winWordKey=winWordKey || "winWord";

        if(getLevelStatusByLevel(this.level)!=1){
            //修改关卡通关状态
            setLevelStatusByLevel(this.level,1);
        }

        var layer=new PanelViewBase();
        this.addChild(layer,99);

        var frame=createSprite(getResImg("failure_bg","res_GameOver"));
        layer.nodeUI_.addChild(frame);

        //文案背景
        var wordBg=createSprite(getResImg("failure_dialog","res_GameOver"));
        wordBg.attr({
            x:frame.width/2+100,
            y:frame.height/2+85
        });
        frame.addChild(wordBg);

        //通关文案
        var winWordLabel=new cc.LabelTTF(getWordByKey(winWordKey),"",24,cc.size(275,80),cc.TEXT_ALIGNMENT_CENTER);
        winWordLabel.attr({
            x:wordBg.width/2+20,
            y:wordBg.height/2,
            color:cc.color(125,105,101)
        });
        wordBg.addChild(winWordLabel);

        //史小坑
        var animFrames=[2,3,4,5,6,5,4,3,2,1];
        for(var i=0;i<animFrames.length;i++){
            animFrames[i]=getResImg("win_man_"+animFrames[i]+".png","res_GameOver");
        }
        var animateAction=getAnimation(0.08,animFrames);
        var man=createSprite(getResImg("win_man_1.png","res_GameOver"));
        man.attr({
            x:frame.width/2-190,
            y:frame.height/2
        });
        frame.addChild(man);
        man.runAction(cc.sequence(animateAction, cc.delayTime(0.5)).repeatForever());

        //重来按钮
        var againBtn=createButton({img:getResImg("pause_btn_restart","res_GameOver")});
        againBtn.attr({
            x:frame.width/2-35,
            y:frame.height/2-70
        });
        frame.addChild(againBtn);
        againBtn.callback=function(){
            try{
                cc.director.runScene(eval("new "+getClassName(this.level)+"()"));
            }catch(err){
                _resumeGame();
                cc.director.runScene(eval("new "+getClassName(this.level)+"()"));
                trace(err);
            }
        }.bind(this);

        //下一关按钮
        var nextBtn=createButton({img:getResImg("win_btn_next","res_GameOver")});
        nextBtn.attr({
            x:frame.width/2+95,
            y:frame.height/2-70
        });
        frame.addChild(nextBtn);
        nextBtn.callback=function(){
            if(isWeb==2 && this.level<gameMaxLevel-1){
                _resumeGame();
                cc.director.runScene(new ReadyScene(this.level+1));
            }else{
                trace("下载完整版");
                new DownloadTipsLayer(function(){}).addToCurScene();
            }
        }.bind(this);

        //炫耀按钮
        var shareBtn=createButton({img:getResImg("win_btn_show","res_GameOver")});
        shareBtn.attr({
            x:frame.width/2+225,
            y:frame.height/2-70
        });
        frame.addChild(shareBtn);
        shareBtn.callback=function(){
            trace("炫耀");
            __shareTips.show();
        }.bind(this);

        share("坑爹游戏8：："+levelConfig[_preSelectLevel-1]["winShareWord"], "http://h5.kdyx.cn/"+gameKey,1003);
    },
    unAllSchedule:function(){
        for(var i=0;i<this.getChildren().length;i++){
            this.getChildren()[i].unscheduleAllCallbacks();
        }
    },
    throwSkill:function(){
        trace("抛手机技能");
    },
    shakeSkill:function(){
        trace("摇一摇技能");
    },
    filpSkill:function(){
        trace("翻转手机技能");
    },
    hideMenuGoldBtn:function(){ //隐藏金币按钮
        this._menuLayer.goldBtn.visible=false;
    },
    showMenuGoldBtn:function(){ //隐藏金币按钮
        this._menuLayer.goldBtn.visible=true;
    },
    hideMenuTipsBtn:function(){ //隐藏提示按钮
        this._menuLayer.tipsBtn.visible=false;
    },
    showMenuTipsBtn:function(){ //显示提示按钮
        this._menuLayer.tipsBtn.visible=true;
    },
    hidePropBox:function(){ //隐藏道具栏
        //this._propBox.visible=false;
    },
    showPropBox:function(){ //显示道具栏
        //this._propBox.visible=true;
    },
    initSurface:function(){
        //this._propBox=new GamePropBox();
        //this.addChild(this._propBox,97);

        this._menuLayer=new GameMenuLayer();
        this.addChild(this._menuLayer,98);
    },
    //道具栏道具拖动松开时触发的回调,返回参数：propTag（道具tag），propEndPos，（松开时的位置）prop（道具）
    propCallBack:function(propTag,propEndPos,prop){
        console.log("道具Tag："+propTag+",道具当前位置：[x:"+propEndPos.x+",y:"+propEndPos.y+"]");
        if(this.layer && this.layer.propCallBack){
            return this.layer.propCallBack(propTag,propEndPos,prop) || false;
        }
        return false;
    },
    //道具栏道具点击时触发的回调,返回参数：propTag（道具tag），propMovePos，（移动中的位置）prop（道具）
    propBeganCallBack:function(propTag,propMovePos,prop){
        if(this.layer && this.layer.propBeganCallBack){
            this.layer.propBeganCallBack(propTag,propMovePos,prop);
        }
    },
    //道具栏道具拖动时触发的回调,返回参数：propTag（道具tag），propMovePos，（移动中的位置）prop（道具）
    propMoveCallBack:function(propTag,propMovePos,prop){
        if(this.layer && this.layer.propMoveCallBack){
            this.layer.propMoveCallBack(propTag,propMovePos,prop);
        }
    },
    //添加道具到道具栏，需传入参数：propImg（道具图片），tag（道具tag），pos（道具当前的位置）
    addPropToBox:function(propImg,tag,pos){
        pos=pos || winCenter();
        this._propBox.addProp(propImg,tag,pos);
    },
    createNameTag:function(key,name,sprite,scale,offsetX,offsetY,isFollowTargetScale){
        offsetX=offsetX || 0;
        offsetY=offsetY || 0;
        isFollowTargetScale=isFollowTargetScale===false?false:true;
        if(this[key]){
            try {
                this[key].removeFromParent();
                this[key] = null;
            }catch(err){}
        }

        this[key]=createLoserNameTag(name);
        this[key].scale=this[key].initScale=scale || 0.8;
        this[key].y=-this[key].height;
        this.addChild(this[key],5);
        this[key].schedule(function(){
            try{
                if(sprite){
                    var spritePos=sprite.getParent().convertToWorldSpace(sprite.getPosition());
                    this[key].attr({
                        x:spritePos.x+(0.5-sprite.anchorX)*sprite.width+offsetX*(isFollowTargetScale?sprite.getScaleX():1),
                        y:spritePos.y+(1-sprite.anchorY)*sprite.height+offsetY*(isFollowTargetScale?sprite.getScaleY():1),
                        visible:sprite.isVisible()
                    });

                    if(isFollowTargetScale){
                        this[key].scaleX=sprite.getScaleX()*this[key].initScale;
                        this[key].scaleY=sprite.getScaleY()*this[key].initScale;
                    }
                }
            }catch(err){
                this[key].unscheduleAllCallbacks();
            }
        }.bind(this),0.01);
    },
    //设置被整人名字标签
    setLoserNameTag:function(sprite,scale,offsetX,offsetY,isFollowTargetScale){
        this.createNameTag("_loserNameTag",null,sprite,scale,offsetX,offsetY,isFollowTargetScale);
    },
    removeLoserNameTag:function(){
        if(this._loserNameTag){
            try {
                this._loserNameTag.removeFromParent();
                this._loserNameTag = null;
            }catch(err){}
        }
    },
    //设置史小坑名字标签
    setMyNameTag:function(sprite,scale,offsetX,offsetY,isFollowTargetScale){
        this.createNameTag("_myNameTag",getMyName(),sprite,scale,offsetX,offsetY,isFollowTargetScale);
    },
    removeMyNameTag:function(){
        if(this._myNameTag){
            try {
                this._myNameTag.removeFromParent();
                this._myNameTag = null;
            }catch(err){}
        }
    }
});

var GameMenuLayer=cc.Layer.extend({
    size:null,
    goldBtn:null,
    tipsBtn:null,
    kengBB:null,
    ctor:function(){
        this._super();
        this.size=cc.director.getWinSize();
        this.initSurface();
        return true;
    },
    initSurface:function(){
        var leftSpacing=95;
        var spacing=180;

        //当前等级
        var levelBtn=this.createBtnItem("第"+_preSelectLevel+"关","web_game_btn_level","game_hat");
        levelBtn.attr({
            x:leftSpacing+spacing*0,
            y:this.size.height-50
        });
        this.addChild(levelBtn);
        levelBtn.callback=function(){}.bind(this);
        levelBtn.setTouchEnabled(false);
        this.goldBtn=levelBtn;

        //提示按钮
        var tipsBtn=this.createBtnItem("提示","game_btn_hint","game_hat");
        tipsBtn.attr({
            x:leftSpacing+spacing*1,
            y:this.size.height-50
        });
        this.addChild(tipsBtn);
        tipsBtn.callback=function(){
            this.pauseGame();
            var tipsLayer=new GameTipsLayer();
            tipsLayer.addToCurScene();
        }.bind(this);
        this.tipsBtn=tipsBtn;

        //game_hat
        var passBtn=this.createBtnItem("完整版","web_game_btn_completion","game_hat");
        passBtn.attr({
            x:leftSpacing+spacing*2,
            y:this.size.height-50
        });
        this.addChild(passBtn);
        passBtn.callback=function(){
            this.pauseGame();
            new DownloadTipsLayer().addToCurScene();
        }.bind(this);

        //暂停按钮
        var pauseBtn=createButton({img:getResImg("game_btn_pause")});
        pauseBtn.attr({
            x:this.size.width-50,
            y:this.size.height-50
        });
        this.addChild(pauseBtn);
        pauseBtn.callback=function(){
            this.pauseGame();
            var pauseLayer=new PauseGameLayer();
            pauseLayer.addToCurScene();
        }.bind(this);


        //技能按钮
        this.skillBtn=createButton({img:getLevelImg("web_game_btn_skill")});
        this.skillBtn.attr({
            x:65,
            y:150
        });
        this.addChild(this.skillBtn,10);
        this.skillBtn.callback=function(){
            this.showSkillBtn();
        }.bind(this);

        //创建按钮列表
        this.createSkillBtn();
    },
    createBtnItem:function(txt,leftIconName,rightIconName){
        var btn=createScale9Button({img:getResImg("game_gold_frame")});
        btn.width=btn.width+35;

        var leftIcon=createSprite(getResImg(leftIconName));
        leftIcon.attr({
            x:20,
            y:btn.height/2
        });
        btn.addChild(leftIcon);

        if(rightIconName) {
            var rightIcon = createSprite(getResImg(rightIconName));
            rightIcon.attr(
                {x: btn.width - 10,y: btn.height - 4}
            );

            btn.addChild(rightIcon);
        }

        btn.txtLabel=new cc.LabelTTF(""+txt,"",22);
        btn.txtLabel.attr({
            x:btn.width/2+23,
            y:btn.height/2,
            color:cc.color(118,93,91)
        });
        btn.addChild(btn.txtLabel);

        return btn;
    },
    createSkillBtn:function(){
        this.skillArr=[];

        var node=new cc.Node();
        node.attr({
            x:this.skillBtn.x,
            y:this.skillBtn.y
        })
        this.addChild(node,9);

        var rotation=0;

        //翻转
        var flipBtn=createButton({img:getLevelImg("web_game_btn_skill_01")});
        flipBtn.attr({
            opacity:0
        });
        node.addChild(flipBtn);
        flipBtn.callback=function(){
            var curScene=cc.director.getRunningScene();
            if(rotation==0){
                rotation=180;
            }else{
                rotation=0;
            }
            curScene.rotation=rotation;
            this.getParent().filpSkill();
        }.bind(this);
        this.skillArr[0]=flipBtn;

        //摇
        var shakeBtn=createButton({img:getLevelImg("web_game_btn_skill_02")});
        shakeBtn.attr({
            opacity:0
        });
        node.addChild(shakeBtn);
        shakeBtn.callback=function(){
            var curScene=cc.director.getRunningScene();
            curScene.runAction(cc.sequence(
                cc.rotateTo(0.05,rotation-2),
                cc.rotateTo(0.05,rotation+0),
                cc.rotateTo(0.05,rotation+2),
                cc.rotateTo(0.05,rotation+0)
            ));
            this.getParent().shakeSkill();
        }.bind(this);
        this.skillArr[1]=shakeBtn;

        //抛
        var throwBtn=createButton({img:getLevelImg("web_game_btn_skill_03")});
        throwBtn.attr({
            opacity:0
        });
        node.addChild(throwBtn);
        throwBtn.callback=function(){
            var curScene=cc.director.getRunningScene();
            curScene.runAction(cc.sequence(
                cc.scaleTo(0.05,1.02),
                cc.scaleTo(0.05,1)
            ));
            this.getParent().throwSkill();
        }.bind(this);
        this.skillArr[2]=throwBtn;
    },
    showSkillBtn:function(){
        for(var i=0;i<this.skillArr.length;i++){
            var skill=this.skillArr[i];
            skill.stopAllActions();
            if(!this.skillOff){
                var velocity=cc.pMult(cc.pForAngle(i*0.9-0.2),130);
                skill.runAction(cc.spawn(
                    cc.moveTo(0.3,velocity),
                    cc.rotateTo(0.3,720),
                    cc.fadeIn(0.3)
                ));
                skill.setTouchEnabled(true);
            }else{
                skill.runAction(cc.sequence(
                    cc.spawn(
                        cc.moveTo(0.3,cc.p(0,0)),
                        cc.rotateTo(0.3,-720),
                        cc.fadeOut(0.3)
                    )
                ));
                skill.setTouchEnabled(false);
            }
        }

        this.skillOff=!this.skillOff;
    },
    pauseGame:function(){
        _pauseGame();
    },
    resumeGame:function(){
        _resumeGame();
    }
});

var GamePropBox=cc.Layer.extend({
    size:null,
    boxMaxCount:3,
    propBoxList:null,
    ctor:function(){
        this._super();
        this.size=cc.director.getWinSize();
        this.initSurface();
    },
    initSurface:function(){

        var bg=createSprite(getResImg("game_inventory_frame_1.png"));
        bg.attr({
            anchorY:0,
            x:this.size.width/2,
            y:100
        });
        this.addChild(bg);

        this.propBoxList=[];
        var space=115;
        for(var i=0;i<this.boxMaxCount;i++){
            //格子
            var propBox=createSprite(getResImg("game_inventory_frame_2.png"));
            propBox.attr({
                x:bg.width/2-space*(this.boxMaxCount/2-0.5)+i*space,
                y:bg.height/2
            });
            bg.addChild(propBox);

            //问号
            var question=createSprite(getResImg("game_inventory_frame_question.png"));
            question.setPosition(propBox.x,propBox.y);
            bg.addChild(question);

            //道具节点
            var propBoxNode=new cc.Node();
            propBoxNode.setPosition(propBox.x,propBox.y);
            bg.addChild(propBoxNode,1);

            this.propBoxList[i]={
                box:propBoxNode,
                question:question,
                prop:null
            };
        }
    },
    addProp:function(propImg,propTag,pos){
        if(!this.visible)return;

        var _this=this;

        this.removePropByTag(propTag);

        playEffect(res_sound.click_mp3);

        var prop=createSprite(propImg);
        prop.propTag=propTag;


        for(var i= 0,len=this.propBoxList.length;i<len;i++){
            var propBoxList=this.propBoxList[i];
            if(!propBoxList.prop){
                prop.index=i;
                prop.setPosition(propBoxList.box.convertToNodeSpace(pos));
                propBoxList.box.addChild(prop);
                propBoxList.prop=prop;
                break;
            }
        }

        var scale=1;
        if(prop.width > prop.height){
            scale=80/prop.width;
        }else{
            scale=80/prop.height;
        }
        prop._innerScale=scale;


        prop.runAction(cc.sequence(
            cc.spawn(
                cc.moveTo(0.1,cc.p(0,0)),
                cc.scaleTo(0.1,scale)
            ),
            cc.callFunc(function(){
                _this.resumePropPos();
                cc.eventManager.addListener({
                    event:cc.EventListener.TOUCH_ONE_BY_ONE,
                    swallowTouches:false,
                    onTouchBegan:function(touch,event){
                        if(!_this.visible)return false;

                        var target=event.getCurrentTarget();
                        var locationInNode = target.convertToNodeSpace(touch.getLocation());
                        var s = target.getContentSize();
                        var rect = cc.rect(0, 0, s.width, s.height);
                        if (cc.rectContainsPoint(rect, locationInNode)) {
                            target.scale=scale+0.2;
                            _this.setPropZOrder(target.index);

                            var curScene=cc.director.getRunningScene();
                            if(curScene.propBeganCallBack){
                                curScene.propBeganCallBack(target.propTag,touch.getLocation(),target);
                            }
                            return true;
                        }
                        return false;
                    },
                    onTouchMoved:function(touch,event){
                        var target=event.getCurrentTarget();
                        target.x+=touch.getDelta().x;
                        target.y+=touch.getDelta().y;

                        var curScene=cc.director.getRunningScene();
                        if(curScene.propMoveCallBack){
                            curScene.propMoveCallBack(target.propTag,touch.getLocation(),target);
                        }
                    },
                    onTouchEnded:function(touch,event){
                        var target=event.getCurrentTarget();
                        var curScene=cc.director.getRunningScene();
                        if(curScene.propCallBack){
                            if(curScene.propCallBack(target.propTag,touch.getLocation(),target)){
                                _this.removePropByTag(target.propTag);
                            }else{
                                target.scale=scale;
                                _this.resumePropPos();
                            }
                        }else{
                            _this.resumePropPos();
                        }
                    }
                },prop);
            })
        ));

    },
    setPropZOrder:function(index){
        for(var i= 0,len=this.propBoxList.length;i<len;i++){
            var propBoxList=this.propBoxList[i];
            if(index==i){
                propBoxList.box.setLocalZOrder(2);
            }else{
                propBoxList.box.setLocalZOrder(1);
            }
        }
    },
    resumePropPos:function(){
        for(var i= 0,len=this.propBoxList.length;i<len;i++){
            var propBoxList=this.propBoxList[i];
            if(propBoxList.prop){
                propBoxList.question.visible=false;
                propBoxList.prop.setPosition(0,0);
                propBoxList.prop.scale=propBoxList.prop._innerScale;
            }else{
                propBoxList.question.visible=true;
            }
        }
    },
    removePropByTag:function(propTag){
        for(var i= 0,len=this.propBoxList.length;i<len;i++){
            var propBoxList=this.propBoxList[i];
            if(propBoxList.prop && propBoxList.prop.propTag==propTag){
                propBoxList.prop.removeFromParent();
                propBoxList.prop=null;
                break;
            }
        }
        this.resumePropPos();
    }
});