/**
 * Created by weicheng on 15/10/6.
 *
 * 工具
 */

/*CSV工具*/
function CSVAnalyser(str, row, key) {
    var abc = getStrByRowAndKeyFromCSV(str, ",", row, key);
    return abc;
}
function getStrByRowAndKeyFromCSV(strData, strDelimiter, row, key) {
    strDelimiter = (strDelimiter || ",");
    var objPattern = new RegExp(
        (
            "(\\" + strDelimiter + "|\\r?\\n|\\r|^)" +

            "(?:\"([^\"]*(?:\"\"[^\"]*)*)\"|" +

            "([^\"\\" + strDelimiter + "\\r\\n]*))"
        ),
        "gi"
    );
    var arrData = [
        []
    ];
    var arrMatches = null;
    while (arrMatches = objPattern.exec(strData)) {
        var strMatchedDelimiter = arrMatches[1];
        if (
            strMatchedDelimiter.length &&
            (strMatchedDelimiter != strDelimiter)
        ) {
            arrData.push([]);
        }
        if (arrMatches[2]) {
            var strMatchedValue = arrMatches[2].replace(
                new RegExp("\"\"", "g"),
                "\""
            );
        } else {
            var strMatchedValue = arrMatches[3];
        }
        arrData[arrData.length - 1].push(strMatchedValue);
    }
    for (var i = 0; i < arrData[1].length; i++) {
        if (arrData[1][i] == key) {
            return arrData[row + 1][i]
        }
    }
    return "";
}
//CSV转Array
function CSVToArray(strData, strDelimiter) {
    strDelimiter = (strDelimiter || ",");
    var objPattern = new RegExp(
        (
            "(\\" + strDelimiter + "|\\r?\\n|\\r|^)" +
            "(?:\"([^\"]*(?:\"\"[^\"]*)*)\"|" +
            "([^\"\\" + strDelimiter + "\\r\\n]*))"
        ),
        "gi"
    );
    var arrData = [
        []
    ];
    var arrMatches = null;
    while (arrMatches = objPattern.exec(strData)) {
        var strMatchedDelimiter = arrMatches[1];
        if (
            strMatchedDelimiter.length &&
            (strMatchedDelimiter != strDelimiter)
        ) {
            arrData.push([]);
        }
        if (arrMatches[2]) {
            var strMatchedValue = arrMatches[2].replace(
                new RegExp("\"\"", "g"),
                "\""
            );
        } else {
            var strMatchedValue = arrMatches[3];
        }
        arrData[arrData.length - 1].push(strMatchedValue);
    }
    return arrData;
}

// 暂停当前场景所有子节点
function pauseAllNode() {
    var curScene = cc.director.getRunningScene();
    pauseNodeAllChildren(curScene);
}

// 恢复当前场景所有子节点
function resumeAllNode() {
    var curScene = cc.director.getRunningScene();
    resumeNodeAllChildren(curScene);
}


//遍历节点暂停所有子节点
function pauseNodeAllChildren(node) {
    if (node.getChildren().length > 0) {
        for (var i = 0; i < node.getChildren().length; i++) {
            node.getChildren()[i].pause();
            pauseNodeAllChildren(node.getChildren()[i]);
        }
    }
}
//遍历节点恢复所有子节点
function resumeNodeAllChildren(node) {
    if (node.getChildren().length > 0) {
        for (var i = 0; i < node.getChildren().length; i++) {
            node.getChildren()[i].resume();
            resumeNodeAllChildren(node.getChildren()[i]);
        }
    }
}

//暂停游戏
function _pauseGame() {
    pauseAllEffect();
    pauseMusic();
    pauseAllNode();
    var Scene = cc.director.getRunningScene();
    if (Scene.pauseTheGame)Scene.pauseTheGame();
}

//恢复游戏
function _resumeGame() {
    resumeAllEffect();
    resumeMusic();
    resumeAllNode();
    var Scene = cc.director.getRunningScene();
    if (Scene.pauseTheGame)Scene.resumeTheGame();
}

var effectArray = [];

// 播放音效
function playEffect(fileName, loop) {
    try {
        if (fileName) {
            if (effectArray.indexOf(fileName) == -1) {
                effectArray.push(fileName);
                var soundId = cc.audioEngine.playEffect(fileName, loop);
                cc.director.getRunningScene().runAction(cc.callFunc(function () {
                    effectArray = [];
                }));
                return soundId;
            }
        } else {
            trace("~~传入音效路径为空！");
        }
    } catch (err) {
        trace("找不到音效：" + err);
    }
}

//播放关卡目录音效（输入文件名即可）
function playLevelEffect(fileName, loop) {
    try {
        var audioPath, audioFile;
        try {
            audioPath = eval("res_" + getClassName(_preSelectLevel) + "_sound");
        } catch (err) {
            audioPath = null;
        }
        if (!fileName.split(".")[1])fileName = fileName + ".mp3";
        fileName = fileName.replace(/\./g, "_");
        if (audioPath) {
            audioFile = audioPath[fileName];
        }
        if (!audioFile) {
            audioFile = res_sound[fileName];
        }
        if (isTestMode == 1) {
            trace("fileName:", audioFile);
        }
        return playEffect(audioFile, loop);
    } catch (err) {
        trace(err);
    }
}

// 停止音效
function stopEffect(soundId) {
    try {
        cc.audioEngine.stopEffect(soundId);
    } catch (err) {
        trace("停止音效失败：" + err);
    }
}

// 暂停音效
function pauseEffect(soundId) {
    try {
        cc.audioEngine.pauseEffect(soundId);
    } catch (err) {
        trace("暂停音效失败：" + err);
    }
}

// 恢复音效
function resumeEffect(soundId) {
    try {
        cc.audioEngine.resumeEffect(soundId);
    } catch (err) {
        trace("恢复音效失败：" + err);
    }
}

// 停止所有音效
function stopAllEffect() {
    try {
        cc.audioEngine.stopAllEffects();
    } catch (err) {
        trace("所有音效停止失败：" + err);
    }
}

// 暂停所有音效
function pauseAllEffect() {
    try {
        cc.audioEngine.pauseAllEffects();
    } catch (err) {
        trace("音效暂停失败：" + err);
    }

}

// 回复所有音效
function resumeAllEffect() {
    try {
        cc.audioEngine.resumeAllEffects();
    } catch (err) {
        trace("音效恢复错误：" + err);
    }
}

// 播放背影音乐
function playMusic(fileName, loop) {
    try {
        //切换音乐时，将停止上一次的背景音效
        stopMusic();
        trace(cc.audioEngine.playMusic(fileName, loop));
    } catch (err) {
        trace("找不到音乐：" + err);
    }
}

// 停止背景音乐
function stopMusic(release) {
    try {
        cc.audioEngine.stopMusic(release);
    } catch (err) {
        trace("停止背景音乐失败：" + err);
    }
}

// 暂停背景音乐
function pauseMusic() {
    try {
        cc.audioEngine.pauseMusic();
    } catch (err) {
        trace("背景音乐暂停失败：" + err);
    }
}

// 回复背景音乐
function resumeMusic() {
    try {
        cc.audioEngine.resumeMusic();
    } catch (err) {
        trace("音乐恢复错误：" + err);
    }
}

//屏幕的中心
function winCenter() {
    var winSize = cc.director.getWinSize();
    return cc.p(winSize.width / 2, winSize.height / 2);
}

/**创建按钮
 json={
     img:"res/photo.png",       //图片路径
     clickImg:"res/photo2.png", //点击后切换图片路径(可不填)
     callback:function(){},     //点击回调（可在创建按钮后再定义按钮的回调【例：btn.callback=function(){}】）
     swallow:true,              //是否吞噬下级事件
     clickScale:0.9             //点击缩放比例
     mode:1                     //按钮模式：默认不填（点击后在按钮范围内松开后发回调），1（点击后拖动一段距离松开按钮不触发回调）
     sound:"res/sound/click.png" //点击按钮音效（默认不填为：通用点击音效）
     soundOff:true              //音效开关（默认开启）
     txt:"显示的文本"             //创建label在精灵中心
     txtSize:18                 //文本大小（默认大小18）
     txtColor:cc.color(255,0,0) //字体颜色
     touchContentNode           //点击区域节点，如果点击位置不在区域内就为无效点击
  }

 sprite.setTouchEnabled(false); //设置关闭按钮触摸
 sprite.setString("文本");      //修改按钮精灵label文本（没有创建label的时候，会创建一个label）
 sprite.getString();            //获取按钮精灵label文本字符串
 sprite.getBtnLabel();         //获取按钮精灵label
 sprite.removeBtnLabel();       //删除当前按钮精灵label
 */
function createButton(json) {
    //优化
    if (typeof(json) == "string") {
        json = {img: json};
    }
    if (!json)return null;
    if (!json.img)return null;
    if (json.img.indexOf("/") == -1 && json.img.indexOf("#") == -1)json.img = getResImg(json.img);
    if (json.clickImg) {
        if (json.clickImg.indexOf("/") == -1 && json.clickImg.indexOf("#") == -1)json.clickImg = getResImg(json.clickImg);
    }

    var _spriteBtn = cc.Sprite.extend({
        _img: json.img,
        clickImg: json.clickImg,
        callback: json.callback,
        clickScale: json.clickScale,
        sound: json.sound,
        soundOff: json.soundOff,
        mode: json.mode,
        curPos_: null,
        distance_: null,
        __scale: 1,
        touchEnabled_: true,
        _btnLabel: null,
        txtSize: json.txtSize || 18,
        txtColor: json.txtColor || cc.color(0, 0, 0),
        touchContentNode:null,
        delayTouchTime:0,   //点击一次后需要N秒才能继续点击
        onExit: function () {
            this._super();
            cc.eventManager.removeListeners(this);
        },
        onEnter: function () {
            this._super();
            this.__scale = this.getScale();
            cc.eventManager.addListener({
                event: cc.EventListener.TOUCH_ONE_BY_ONE,
                swallowTouches: json.swallow != false ? true : false,
                onTouchBegan: function (touch, event) {
                    var target = event.getCurrentTarget();
                    if (target.touchEnabled_ === false || !target.isVisible())return false;

                    //防止当前目标超出点击区域的位置被点击
                    try {
                        if (target.touchContentNode) {
                            var locationInParentNode = target.touchContentNode.convertToNodeSpace(touch.getLocation());
                            var parentS = target.touchContentNode.getContentSize();
                            var parentRect=cc.rect(0,0,parentS.width,parentS.height);
                            if(!cc.rectContainsPoint(parentRect,locationInParentNode)){
                                return false;
                            }
                        }
                    }catch(e){
                        cc.log(e)
                    }
                    var locationInNode = target.convertToNodeSpace(touch.getLocation());
                    var s = target.getContentSize();
                    var rect = cc.rect(0, 0, s.width * target.getScaleX(), s.height * target.getScaleY());
                    if (cc.rectContainsPoint(rect, locationInNode)) {
                        if (target.clickImg)target.changeTxture(target.clickImg);
                        target.scale = target.clickScale || target.__scale + 0.05;
                        target.curPos_ = touch.getLocation();
                        target.distance_ = 0;
                        return true;
                    }
                    return false;
                },
                onTouchMoved: function (touch, event) {
                    var target = event.getCurrentTarget();
                    var locationInNode = target.convertToNodeSpace(touch.getLocation());
                    var s = target.getContentSize();
                    var rect = cc.rect(0, 0, s.width * target.getScaleX(), s.height * target.getScaleY());
                    if (cc.rectContainsPoint(rect, locationInNode)) {
                        if (target.clickImg)target.changeTxture(target.clickImg);
                        target.scale = target.clickScale || target.__scale + 0.05;
                    } else {
                        if (target.clickImg)target.changeTxture(target._img);
                        target.scale = target.__scale;
                    }
                    target.distance_ += cc.pDistance(target.curPos_, touch.getLocation());
                },
                onTouchEnded: function (touch, event) {
                    var target = event.getCurrentTarget();
                    var locationInNode = target.convertToNodeSpace(touch.getLocation());
                    var s = target.getContentSize();
                    var rect = cc.rect(0, 0, s.width * target.getScaleX(), s.height * target.getScaleY());
                    if (target.clickImg)target.changeTxture(target._img);
                    target.scale = target.__scale;
                    if (cc.rectContainsPoint(rect, locationInNode)) {
                        if (target.mode == 1 && target.distance_ > 40) {
                        }
                        else {
                            try {
                                if (target.delayTouchTime > 0) {
                                    target.setTouchEnabled(false);
                                    target.scheduleOnce(function () {
                                        if(target)
                                            target.setTouchEnabled(true);
                                    }, target.delayTouchTime);
                                }
                            }catch(e){
                                cc.log(e);
                            }

                            if (target.soundOff !== false) {
                                playEffect(target.sound || res_sound.click_mp3);
                            }
                            if (target.callback)target.callback();
                        }
                    }
                }
            }, this);
        },
        setDelayTime:function(time){
            this.delayTouchTime=time || 0;
        },
        setTouchEnabled: function (bool) {
            this.touchEnabled_ = bool == false ? false : true;
        },
        changeTxture: function (txture) {
            setSpriteTxture(this, txture);
        },
        setString: function (txt) {
            if (this._btnLabel) {
                this._btnLabel.string = txt;
            } else {
                this._btnLabel = new cc.LabelTTF(txt, "", this.txtSize);
                this._btnLabel.attr({
                    x: this.width / 2,
                    y: this.height / 2,
                    color: this.txtColor
                });
                this.addChild(this._btnLabel);
            }
        },
        getString: function () {
            return this.getBtnLabel() ? this.getBtnLabel().string : "";
        },
        getBtnLabel: function () {
            return this._btnLabel;
        },
        removeBtnLabel: function () {
            try {
                if (this._btnLabel) {
                    this._btnLabel.removeFromParent();
                    this._btnLabel = null;
                }
            } catch (err) {
                this._btnLabel = null;
            }
        }
    });

    var spriteBtn = new _spriteBtn(json.img);
    if (json.txt && json.txt != "")spriteBtn.setString(json.txt);

    return spriteBtn;
}


function createScale9Button(json) {
    if (!json)return null;
    if (!json.img)return null;
    if (json.img.indexOf("/") == -1 && json.img.indexOf("#") == -1)json.img = getResImg(json.img);
    json.img = json.img.replace(/#/g, "");
    if (json.clickImg) {
        if (json.clickImg.indexOf("/") == -1 && json.clickImg.indexOf("#") == -1)json.clickImg = getResImg(json.clickImg);
        json.clickImg = json.clickImg.replace(/#/g, "");
    }

    var scale9SpriteBtn = cc.Scale9Sprite.extend({
        _img: json.img,
        clickImg: json.clickImg,
        callback: json.callback,
        clickScale: json.clickScale,
        sound: json.sound,
        soundOff: json.soundOff,
        mode: json.mode,
        curPos_: null,
        distance_: null,
        __scale: 1,
        touchEnabled_: true,
        touchContentNode:null,
        onExit: function () {
            this._super();
            cc.eventManager.removeListeners(this);
        },
        onEnter: function () {
            this._super();
            this.__scale = this.getScale();
            cc.eventManager.addListener({
                event: cc.EventListener.TOUCH_ONE_BY_ONE,
                swallowTouches: json.swallow != false ? true : false,
                onTouchBegan: function (touch, event) {
                    var target = event.getCurrentTarget();
                    if (target.touchEnabled_ === false || !target.isVisible())return false;

                    //防止当前目标超出点击区域的位置被点击
                    try {
                        if (target.touchContentNode) {
                            var locationInParentNode = target.touchContentNode.convertToNodeSpace(touch.getLocation());
                            var parentS = target.touchContentNode.getContentSize();
                            var parentRect=cc.rect(0,0,parentS.width,parentS.height);
                            if(!cc.rectContainsPoint(parentRect,locationInParentNode)){
                                return false;
                            }
                        }
                    }catch(e){
                        cc.log(e)
                    }
                    var locationInNode = target.convertToNodeSpace(touch.getLocation());
                    var s = target.getContentSize();
                    var rect = cc.rect(0, 0, s.width * target.getScaleX(), s.height * target.getScaleY());
                    if (cc.rectContainsPoint(rect, locationInNode)) {
                        if (target.clickImg)target.changeTxture(target.clickImg);
                        target.scale = target.clickScale || target.__scale + 0.05;
                        target.curPos_ = touch.getLocation();
                        target.distance_ = 0;
                        return true;
                    }
                    return false;
                },
                onTouchMoved: function (touch, event) {
                    var target = event.getCurrentTarget();
                    var locationInNode = target.convertToNodeSpace(touch.getLocation());
                    var s = target.getContentSize();
                    var rect = cc.rect(0, 0, s.width * target.getScaleX(), s.height * target.getScaleY());
                    if (cc.rectContainsPoint(rect, locationInNode)) {
                        if (target.clickImg)target.changeTxture(target.clickImg);
                        target.scale = target.clickScale || target.__scale + 0.05;
                    } else {
                        if (target.clickImg)target.changeTxture(target._img);
                        target.scale = target.__scale;
                    }
                    target.distance_ += cc.pDistance(target.curPos_, touch.getLocation());
                },
                onTouchEnded: function (touch, event) {
                    var target = event.getCurrentTarget();
                    var locationInNode = target.convertToNodeSpace(touch.getLocation());
                    var s = target.getContentSize();
                    var rect = cc.rect(0, 0, s.width * target.getScaleX(), s.height * target.getScaleY());
                    if (target.clickImg)target.changeTxture(target._img);
                    target.scale = target.__scale;
                    if (cc.rectContainsPoint(rect, locationInNode)) {
                        if (target.mode == 1 && target.distance_ > 40) {
                        }
                        else {
                            if (target.soundOff !== false) {
                                playEffect(target.sound || res_sound.click_mp3);
                            }
                            if (target.callback)target.callback();
                        }
                    }
                }
            }, this);
        },
        setTouchEnabled: function (bool) {
            this.touchEnabled_ = bool == false ? false : true;
        },
        changeTxture: function (txture) {
            setScale9SpriteTexture(this, txture);
        }
    });

    return (new scale9SpriteBtn(json.img));
}

/**添加点击回调
 *
 * @param sprite 精灵
 * @param callback 回调
 * @param swallow   是否吞噬事件
 * @returns {*}
 */
function addTouchCallBack(sprite, callback, swallow, moveCallback) {
    removeListener(sprite);

    if (callback)sprite.callback = callback;
    if (moveCallback)sprite.moveCallback = moveCallback;
    sprite.touchEnabled_ = true;
    sprite.setTouchEnabled = function (bool) {
        this.touchEnabled_ = bool == false ? false : true;
    }.bind(sprite);

    cc.eventManager.addListener({
        event: cc.EventListener.TOUCH_ONE_BY_ONE,
        swallowTouches: swallow != false ? true : false,
        onTouchBegan: function (touch, event) {
            var target = event.getCurrentTarget();
            if (target.touchEnabled_ === false || !target.isVisible())return false;

            //防止当前目标超出点击区域的位置被点击
            try {
                if (target.touchContentNode) {
                    var locationInParentNode = target.touchContentNode.convertToNodeSpace(touch.getLocation());
                    var parentS = target.touchContentNode.getContentSize();
                    var parentRect=cc.rect(0,0,parentS.width,parentS.height);
                    if(!cc.rectContainsPoint(parentRect,locationInParentNode)){
                        return false;
                    }
                }
            }catch(e){
                cc.log(e)
            }

            var locationInNode = target.convertToNodeSpace(touch.getLocation());
            var s = target.getContentSize();
            var rect = cc.rect(0, 0, s.width * target.getScaleX(), s.height * target.getScaleY());
            if (cc.rectContainsPoint(rect, locationInNode)) {
                if (target.beganCallback) {
                    var callback = target.beganCallback(touch, event);
                    return typeof(callback) == "boolean" ? callback : true;
                }
                return true;
            }
            return false;
        },
        onTouchMoved: function (touch, event) {
            var target = event.getCurrentTarget();
            if (target.moveCallback)target.moveCallback(touch, event);
        },
        onTouchEnded: function (touch, event) {
            var target = event.getCurrentTarget();
            var locationInNode = target.convertToNodeSpace(touch.getLocation());
            var s = target.getContentSize();
            var rect = cc.rect(0, 0, s.width * target.getScaleX(), s.height * target.getScaleY());
            if (cc.rectContainsPoint(rect, locationInNode)) {
                if (target.callback)target.callback(touch, event);
            }
        }
    }, sprite);
}

//删除事件
function removeListener(sprite) {
    cc.eventManager.removeListeners(sprite);
}

/**创建计算坐标精灵（可拖动）
 * img      图片
 * tag      输出log后对应的tag
 * swallow  是否吞噬下面事件
 * */
function createPosSprite(img, tag, swallow) {
    var sprite;
    if (isTestMode == 1) {
        sprite = createLevelSprite(img);
        sprite.__tag = tag || "无标记";
        sprite.attr({
            x: winCenter().x,
            y: winCenter().y
        });

        function posLog(Event, target) {
            try {
                var pos = target.getParent().convertToWorldSpace(target.getPosition());
                var nodePos = target.getPosition();
                trace("~~~", Event, "~~~~");
                trace("目标tag:(" + target.__tag + ")，坐标:[" +
                    "\n\tpos【x:" + pos.x.toFixed(1) + ",y:" + pos.y.toFixed(1) +
                    "】，\n\twinPos【x:winCenter().x+" + (pos.x - winCenter().x).toFixed(1) + ",y:winCenter().y+" + (pos.y - winCenter().y).toFixed(1) +
                    "】，\n\tnodePos【x:" + nodePos.x.toFixed(1) + ",y:" + nodePos.y.toFixed(1) +
                    "】，\n\tnodeWinPos【x:" + (nodePos.x - target.getParent().width / 2).toFixed(1) + ",y:" + (nodePos.y - target.getParent().height / 2).toFixed(1) +
                    "】\n]");
                trace("~~~~~~~");
            } catch (err) {
            }
        }

        cc.eventManager.addListener({
            event: cc.EventListener.TOUCH_ONE_BY_ONE,
            swallowTouches: swallow != false ? true : false,
            onTouchBegan: function (touch, event) {
                var target = event.getCurrentTarget();
                if (target.touchEnabled_ === false || !target.isVisible())return false;

                posLog("began", target);

                var locationInNode = target.convertToNodeSpace(touch.getLocation());
                var s = target.getContentSize();
                var rect = cc.rect(0, 0, s.width, s.height);
                if (cc.rectContainsPoint(rect, locationInNode)) {
                    return true;
                }
                return false;
            },
            onTouchMoved: function (touch, event) {
                var target = event.getCurrentTarget();
                var delta = touch.getDelta();
                target.setPosition(cc.pAdd(target.getPosition(), delta));

                posLog("moved", target);
            },
            onTouchEnded: function (touch, event) {
                var target = event.getCurrentTarget();

                posLog("ended", target);
            }
        }, sprite);
    } else {
        sprite = createLevelSprite(arguments[0], arguments[1], arguments[2], arguments[3], arguments[4]);
    }

    return sprite;
}


/**
 * 获取动画(每帧用时，图片数组)
 *
 * 优化处理：
 * 1、可直接穿图片名字，不需要转全路径。
 * 2、重复图片帧资源优化。
 * by yutian.liu
 */
function getAnimation(time, arr) {
    if (arr) {
        try {
            //字符串动画处理
            for (var i = 0; i < arr.length; i++) {
                if (arr[i].indexOf("#") == -1 && arr[i].indexOf("/") == -1) {
                    arr[i] = getResImg(arr[i]);
                }
            }

            var animation;
            var oneImg = arr[0] ? arr[0].replace(/#/g, "") : arr[0];
            if (cc.spriteFrameCache.getSpriteFrame(oneImg)) {
                var animFrames = [];
                for (var i = 0; i < arr.length; i++) {
                    //此处做重复资源优化
                    var repeat = false;
                    for (var of = 0; of < animFrames.length; of++) {
                        if (arr[of] == arr[i]) {
                            repeat = true;
                            break;
                        }
                    }
                    //重复资源，则使用旧帧数据，否则使用新的帧数据
                    var frame = repeat ? animFrames[of] : cc.spriteFrameCache.getSpriteFrame(arr[i].replace(/#/g, ""));
                    //var frame = cc.spriteFrameCache.getSpriteFrame(arr[i].replace(/#/g,""));
                    animFrames.push(frame);
                }
                animation = new cc.Animation(animFrames, time);
            } else {
                animation = new cc.Animation();
                for (var i = 0; i < arr.length; i++) {
                    animation.addSpriteFrameWithFile(arr[i]);
                }
                animation.setDelayPerUnit(time);
            }

            var animate = cc.animate(animation);
            return animate;
        } catch (err) {
            trace("获取动画动作错误，动画动作换成延时动作:", err);
            return cc.delayTime(time);
        }
    } else {
        trace("~没有传入动画数组，改为返回延时动作！");
        return cc.delayTime(time);
    }
}

//添加动画（精灵，每帧用时，图片数组，是否循环（默认循环），函数）
function setAnimation(sprite, time, arr, loop, fn) {
    if(!sprite)return;

    try {
        if (sprite.animationAction) {
            sprite.stopAction(sprite.animationAction);
            sprite.animationAction = null;
        }
    } catch (err) {
        //trace("停止动画错误：",err);
    }
    var animate = getAnimation(time, arr);
    if (!animate) {
        trace("获取动画动作出错，不执行动作的运行");
        return;
    }

    loop = (loop === false ? false : true);

    if (loop === true) {
        sprite.animationAction = cc.sequence(
            animate,
            cc.callFunc(fn, sprite)
        ).repeatForever();
    } else {
        sprite.animationAction = cc.sequence(
            animate,
            cc.callFunc(fn, sprite)
        );
    }
    sprite.runAction(sprite.animationAction);
}
//添加动画（精灵，每帧用时，图片数组，是否循环（默认循环），函数）
function setAnimationForLocal(sprite, time, arr, loop, fn) {
    setAnimation(sprite, time, arr, loop, fn)
}

//创建文本
function createLabel(txt, size, color, box, hAlignment, vAlignment) {
    var label = new cc.LabelTTF(txt || "", "Arial", size || 33, box, hAlignment, vAlignment);
    label.color = color || cc.color(62, 65, 67);

    return label;
}

//创建精灵
function createSprite(img, rect) {
    var sprite = new cc.Sprite(img, rect);
    sprite._img = img;

    return sprite;
}

//创建9图精灵
function createScale9Sprite(img) {
    img = img.replace(/#/g, "");
    var sprite = new cc.Scale9Sprite(img);
    sprite._img = img;
    return sprite;
}

//创建关卡精灵
/**
 * @yutian.liu
 * @param imgName 传入创建的图片名字
 * @param time 传入间隔时间，要使用动画，此值不能为空
 * @param arr 如果此值不为空，则会创建动画
 * @param loop 是否循环
 * @param fun 是否需要播放回调
 * @returns {*}
 */
function createLevelSprite(imgName, time, arr, loop, fun) {
    var sprite = createSprite(getResImg(imgName));
    if (arr != null) {
        setAnimation(sprite, time, arr, loop, fun);
    }
    return sprite;
}

//检测碰撞
function isHitTest(obj1,obj2){
    try{
        if(cc.rectIntersectsRect(obj1.getBoundingBox(),obj2.getBoundingBox())){
            return true;
        }
    }catch(e){
        cc.log(e);
    }
    return false;
}

/**
 * 创建矩形精灵
 * @param width 宽
 * @param height 高
 * @param color 颜色
 * @param opacity 透明度（0～255）
 */
function createRectSprite(width,height,color,opacity){
    var sprite=createSprite();
    sprite.setTextureRect(cc.rect(0,0,width || 100,height || 100));
    sprite.color=color || cc.color(255,0,0);
    if(isTestMode){
        sprite.opacity=opacity || 100;
    }else{
        sprite.opacity=0;
    }

    return sprite;

}


/**
 * <p>获取对应关卡的资源</p>
 在resource里面命名
 关卡资源命名
 var res_HelloWorldScene={
        abc_png:"res/HelloWorldScene/abc.png"
    }

 调用方法
 getResImg("abc","res_HelloWorldScene")
 或
 getResImg("abc.png","res_HelloWorldScene")
 */
function getResImg(imageName, searchPath) {
    if (!imageName)return null;
    var imagePath = null;
    imageName = imageName.replace(/#/g, "");
    var imgStr, Suffix;
    if (imageName.indexOf("/") != -1) {
        var imgStrArr = imageName.split("/");
        imgStr = imgStrArr[imgStrArr.length - 1];
    } else {
        imgStr = imageName;
    }
    if (imgStr.indexOf(".") != -1) {
        var imgStrSplit = imgStr.split(".");
        Suffix = imgStrSplit[1];
        if (Suffix == "")imgStr = imgStrSplit[0] + ".png";
    } else {
        imgStr = imgStr + ".png"
    }

    imgStr = imgStr.toString();
    if ((!Suffix || Suffix == "png") && cc.spriteFrameCache.getSpriteFrame(imgStr)) {
        imagePath = "#" + imgStr;
    } else {
        var resClassList = [
            "res_" + getClassName(_preSelectLevel),
            "res_levelCommon",
            "res_common",
            "res_Panel",
            "res_webCommon",
            "res_Register",
            "res_effects",
            "res"
        ];

        if(imgSearchPath && imgSearchPath!="" && typeof(imgSearchPath)==="string")
            resClassList.unshift(imgSearchPath);

        imageName = imgStr.replace(/\./g, "_");
        if (searchPath) {
            try {
                imagePath = eval(searchPath) ? eval(searchPath)[imageName] : null;
            } catch (err) {
                imagePath = null;
            }
        }
        if (!imagePath) {
            //if(searchPath)trace("寻找路径：",searchPath,"，找不到资源");
            for (var i = 0; i < resClassList.length; i++) {
                try {
                    imagePath = eval(resClassList[i]) ? eval(resClassList[i])[imageName] : null;
                } catch (err) {
                    imagePath = null;
                }

                if (imagePath)break;
            }
        }
    }
    if (!imagePath)trace("查找图片【", imageName.replace(/_png/, ".png"), "】路径：", imagePath);
    return imagePath;
}

function getLevelImg(imageName, searchPath) {
    return getResImg(imageName, searchPath);
}

function getResPath(imageName, searchPath) {
    return getResImg(imageName, searchPath);
}

/**
 * <p>
 *     给指定Scene或Layer添加背景
 * </p>
 * @function
 * @param {String} bgFilePath:背景图片路径
 * @param {cc.Scene/cc.Layer} target:指定的Scene或Layer
 */
function addBackground(bgFilePath, target) {
    if (!bgFilePath) bgFilePath = getResImg("bg1.png");

    var bg = createSprite(bgFilePath);

    bg.setAnchorPoint(cc.p(0.5, 0));
    bg.y = 0;
    bg.x = cc.winSize.width / 2;

    target.addChild(bg, -100);
}


/**
 * <p>指定一个对象，让它可以抖动<p/>
 * <p>这是第二种震动效果，以放大缩小来实现的。<p/>
 * @function
 * @param {cc.Node} target:要抖动的对象，可以是场景，也可以是层，还可以是别的对象
 * @param {Number} times:要抖动的次数，如果值为-1，则表示永久抖动
 * @param {number} duration: 每一次抖动的时间间隔
 * @param {function} callback:抖动结束后要执行的回调函数
 *
 */
function shock(target, duration, times, callback) {

    if (!duration || duration == 0) duration = 0.01;
    if (!times || times == 0) times = 15;

    var actions = [
        cc.scaleTo(duration, 1.02),
        cc.scaleTo(duration, 1)
    ];
    if (!callback) actions.push(cc.callFunc(callback));

    var seq = cc.sequence(actions);

    if (times == -1) {
        seq.repeatForever();
    } else {
        seq.repeat(times);
    }

    target.runAction(seq);

}


/**
 * 判断当前设备
 * @param {String} os:判断的设备
 */
function isMobile(os) {
    var bool = false;
    if (os) {
        if (cc.sys.os == os && cc.sys.platform != 100 && cc.sys.platform != 101) {
            bool = true;
        } else {
            bool = false;
        }
    } else {
        if (cc.sys.isMobile && cc.sys.platform != 100 && cc.sys.platform != 101) {
            bool = true;
        }
    }
    return bool;
}

//判断当前是否为浏览器
function isBrowser(os) {
    var bool = false;

    if (os) {
        if (cc.sys.os == os && ( cc.sys.platform == 100 || cc.sys.platform == 101)) {
            bool = true;
        }
    } else if (cc.sys.platform == 100 || cc.sys.platform == 101) {
        bool = true;
    }
    return bool;
}

//设置声音开关
function setSoundOpenOrNot(isOpenSound) {
    if (isOpenSound) {
        cc.audioEngine.setEffectsVolume(1);
        cc.audioEngine.setMusicVolume(1);
        setMusicOffStatus(true);
    } else {
        cc.audioEngine.setEffectsVolume(0);
        cc.audioEngine.setMusicVolume(0);
        setMusicOffStatus(false);
    }
}

//消耗金币
function consumeGold(num, isShow, closeTipsCallback,isShowSkip) {
    var curGoldNum = getGoldNum();
    num = parseInt(num);
    if (num <= curGoldNum) {
        addGoldNum(-num, isShow);
        return true;
    } else {
        //new StoreLayer().addToCurScene();
        if (isALLGameWeb != 1 && isHidePurchase != 1) {
            if(isShowSkip){
                new SkipLevelLayer(closeTipsCallback).addToCurScene();
            }else {
                new GoldTipsLayer(closeTipsCallback).addToCurScene();
            }
        }
    }
    return false;
}

//刷新关卡金币数量
function refreshGoldStatus() {
    var curScene = cc.director.getRunningScene();
    if (curScene._menuLayer && curScene._menuLayer.goldBtn) {
        curScene._menuLayer.goldBtn.txtLabel.setString("" + getGoldNum());
    }
}

//金币添加效果
function showGoldChange(gold, delay) {
    var curScene = cc.director.getRunningScene();
    var winSize = cc.director.getWinSize();
    delay = delay || 0.0001;
    gold = parseInt(gold);
    var goldStr = gold > 0 ? "+" + gold : gold;
    var word = new cc.LabelTTF(goldStr, "", 70);
    word.x = winSize.width + 100;
    word.y = -100;
    word.color = cc.color(220, 220, 0);
    word.scale = 1.5;
    curScene.addChild(word, 100);

    word.runAction(cc.sequence(
        cc.delayTime(delay),
        cc.spawn(
            cc.moveTo(0.7, cc.p(100, winSize.height - 50)),
            cc.scaleTo(0.7, 1)
        ),
        cc.delayTime(0.2),
        cc.fadeOut(0.6),
        cc.removeSelf()
    ));

    refreshGoldStatus();
}

//设置精灵纹理
function setSpriteTxture(sprite, txture) {
    if (!txture)return;
    try {
        //获取精灵当前锚点
        var spriteAnchor = sprite.getAnchorPoint();

        //优化，可不传全路径
        txture = txture.indexOf("/") == -1 ? getResImg(txture) : txture;
        if (cc.spriteFrameCache.getSpriteFrame(txture.replace(/#/g, ""))) {
            sprite.setSpriteFrame(txture.replace(/#/g, ""));
        } else {
            sprite.initWithFile(txture);
        }
        sprite._img = txture;
        sprite.setAnchorPoint(spriteAnchor);
    } catch (err) {
        trace("报错的更换纹理：" + txture);
        trace(err);
    }
}

//设置9图精灵纹理
function setScale9SpriteTexture(sprite, txture) {
    if (!txture)return;
    if (cc.spriteFrameCache.getSpriteFrame(txture.replace(/#/g, ""))) {
        sprite.initWithSpriteFrameName(txture.replace(/#/g, ""));
    } else {
        sprite.initWithFile(txture);
    }
}

/**
 * 关卡通用：拍死动画
 * @param sprite
 * @param callback
 */
function shotDead(sprite, callback) {
    sprite.shotFlyImg = sprite.shotFlyImg || getResImg("k_rbgn_deadman_01");
    sprite.shotDeadImg = sprite.shotDeadImg || getResImg("k_com_deadman", "res_levelCommon");

    sprite.setLocalZOrder(99);
    sprite.stopAllActions();
    setSpriteTxture(sprite, sprite.shotFlyImg);
    sprite.attr({
        scale: 0.5,
        anchorX: 0.5,
        anchorY: 0.5
    });

    playEffect(res_sound.theFace_mp3);
    sprite.runAction(cc.sequence(
        cc.spawn(
            cc.moveBy(0.3, cc.p(50, 20)),
            cc.scaleTo(0.3, 1.4)
        ),
        cc.callFunc(function () {
            setSpriteTxture(sprite, sprite.shotDeadImg);
            sprite.scale = 1;
            sprite.setLocalZOrder(sprite.getLocalZOrder() + 5);

            playEffect(res_sound.fly_peng_mp3);

            //手
            var hand = createLevelSprite("k_com_bighand2.png");
            hand.attr({
                x: sprite.x + 70,
                y: sprite.y
            });
            sprite.getParent().addChild(hand, sprite.getLocalZOrder() - 1);

            sprite.runAction(cc.sequence(
                cc.callFunc(function () {
                    shock(cc.director.getRunningScene());
                }),
                cc.delayTime(0.5),
                cc.callFunc(function () {
                    hand.removeFromParent();
                }),
                cc.moveBy(2, cc.p(0, -350)),
                cc.callFunc(function () {
                    if (callback)callback();
                })
            ));
        })
    ));
}

/**
 * 相对于屏幕中心点的偏移量转成坐标点
 * @param x
 * @param y
 * @returns {cc.Point|*}
 */
function limitToPosition(x, y) {
    return cc.p(winCenter().x + x, winCenter().y + y);
}

/**
 * 疯狂打人动画
 * @param target 被打者
 * @param fighter 打人者
 * @param callback
 */
function fightFightFight(target, fighter, callback) {
    if (fighter && fighter != null) {//如果指定了打人者
        fighter.runAction(cc.sequence(
            cc.moveTo(0.3, target.getPosition()),
            cc.callFunc(function () {
                fighter.setVisible(false);
                fighting();
            })
        ));
    } else {
        fighting();
    }

    function fighting() {
        shock(cc.director.getRunningScene(), 0.02, 20);
        playEffect(res_sound.fightFightFight_mp3);
        delayTimeDoSomething(0.3, function () {
            playEffect(res_sound.fightFightFight_mp3);
        });
        setAnimation(target, 0.08, ["k_dxz_fight1.png", "k_dxz_fight2.png"], true);
        if (callback) {
            target.runAction(cc.sequence(cc.delayTime(2.0), cc.callFunc(callback)));
        }
    }
}


/**
 * 左右摇摆的动画
 * @param target 摇摆的对你
 * @param duration 时间间隔
 * @param deltaAngle 幅度
 * @param times 重复次数
 * @param callback 回调
 */
function rotate(target, duration, deltaAngle, times) {
    var seq = cc.sequence(
        cc.rotateBy(duration, deltaAngle),
        cc.rotateBy(duration, -deltaAngle)
    );

    if (times < 0) {
        seq = seq.repeatForever();
    } else {
        seq = seq.repeat(times);
    }

    target.runAction(seq);
}

/**
 * 延迟干某件事
 */
function delayTimeDoSomething(delay, callback) {
    cc.director.getRunningScene().getChildren()[0].runAction(cc.sequence(
        cc.delayTime(delay),
        cc.callFunc(function () {
            if (callback)callback();
        })
    ));
}

/**关卡通用：爆炸动画
 *
 * @param parentNode  当前关卡层
 * @param pos         爆炸位置
 * @param callback    爆炸后回调
 * @param scale       爆炸缩放比例
 */
function explosion(parentNode, pos, callback, scale) {
    var scene=cc.director.getRunningScene();
    var bombSprit = createSprite(getLevelImg("bloom_01.png"));
    bombSprit.setPosition(pos);
    bombSprit.scale=scale || 1;
    // parentNode.addChild(bombSprit,20);
    scene.addChild(bombSprit,20);

    var imgList = ["bloom_01.png", "bloom_02.png", "bloom_03.png"];
    setAnimation(
        bombSprit,
        0.07,
        [
            imgList[2], imgList[1], imgList[0],
            imgList[2], imgList[1], imgList[0],
            imgList[2], imgList[1], imgList[0]
        ],
        false,
        function () {
            bombSprit.removeFromParent();
            if (callback)callback();
        }
    );

    var layer = new cc.LayerColor(cc.color(255, 255, 255, 150));
    // parentNode.addChild(layer, 99);
    scene.addChild(layer,20);
    layer.runAction(cc.sequence(
        cc.blink(0.6,5),
        cc.removeSelf()
    ));

    playEffect(res_sound.boom_mp3);

    shock(cc.director.getRunningScene());//爆炸的同时，让屏幕抖动
}

//显示提示文字
function showToast(txt, color) {
    if (txt) {
        var curScene = cc.director.getRunningScene();
        var winSize = cc.director.getWinSize();

        color = color || cc.color(255, 255, 255);

        var toast = new cc.LabelTTF(txt, "", 40, cc.size(winSize.width - 40, 120), cc.TEXT_ALIGNMENT_CENTER);
        toast.attr({
            x: winSize.width / 2,
            y: winSize.height / 2,
            color: color
        });
        curScene.addChild(toast, 99999);

        toast.runAction(cc.sequence(
            cc.spawn(
                cc.moveBy(1, cc.p(0, 100)),
                cc.fadeOut(1)
            ),
            cc.removeSelf()
        ));
    }
}

/**
 * 使一个精灵生动起来，实际是放大与缩小处理。
 */
function vivid(spr, scale) {
    try {
        if (!scale) scale = 0.02;
        spr.runAction(cc.sequence(cc.scaleTo(1, spr.scale + 0.02, spr.scale + 0.02), cc.scaleTo(1, spr.scale, spr.scale)).repeatForever());
    } catch (err) {
        trace(err)
    }
}

//创建看视频按钮
function createVideoBtn(styleNum) {
    styleNum = styleNum || 0;
    var btn, icon;
    var tipsWord = "看片得金币";
    switch (styleNum) {
        case 0:
            btn = createButton({img: getResImg("shop_free_frame", "res_storeLayer")});
            icon = createSprite(getResImg("shop_free_02", "res_storeLayer"));
            icon.attr({
                anchorY: 0,
                x: btn.width / 2,
                y: 12
            });
            btn.addChild(icon);
            break;
        case 1:
//            tipsWord="免费金币"
            btn = createButton({img: getResImg("com_btn_frame_2", "res_video")});
            icon = createSprite(getResImg("com_tv", "res_video"));
            icon.attr({
                x: 40,
                y: btn.height / 2,
                scale: 0.9
            });
            btn.addChild(icon);
            break;
        default:
            break;
    }

    var nameLabel = new cc.LabelTTF(tipsWord, "", styleNum == 1 ? 24 : 20);
    nameLabel.attr({
        x: styleNum == 1 ? btn.width / 2 + 30 : btn.width / 2,
        y: styleNum == 1 ? btn.height / 2 - 2 : 28,
        color: cc.color(93, 71, 67)
    });
    btn.addChild(nameLabel);
    btn.label = nameLabel;

    btn.callback = function () {
        var times = getVideoDownTime();
        if (videoDownTime.surplusTime <= 0) {
            if (isMobile("iOS")) {
                CommonPlatform.getInstance().showVideoAd();
            }
            //初始化倒计时
            initVideoOpenDownTime();
        } else {
            if (isMobile("iOS")) {
                CommonPlatform.getInstance().showToast(times + "秒后才能点击哦～");
            }
        }
    }
    btn.downTimeFunc = function () {
        var times = getVideoDownTime();
        if (times <= 0) {
            btn.label.string = tipsWord;
        } else {
            btn.label.string = addZero(Math.floor(times / 60)) + ":" + addZero(times % 60);
        }
    }
    btn.downTimeFunc();
    btn.schedule(btn.downTimeFunc, 1);
    return btn;
}

function addZero(num) {
    var sNum = num < 10 ? "0" + num : num;
    return sNum;
}


/**
 * 输出，忽略注释时把tarce函数中内容注释即可
 */
function trace() {
    try {
        if (arguments.length <= 1) {
            cc.log(arguments[0]);
        } else {
            var str = "";
            for (var i = 0; i < arguments.length; i++) {
                str += arguments[i];
            }
            cc.log(str);
        }
    } catch (err) {
        cc.log(err);
    }
}

/**检测字符串是否包含特殊字符*/
function checkStrSpecialChar(txt) {
    var pattern = new RegExp("[`~!@#$^&*()=|{}':;',\\[\\].<>/?~！@#￥……&*（）——|{}【】‘；：”“'。，、？]");
    if (pattern.test(txt)) {
        showToast("名字中不能包含\n特殊字符", cc.color(255, 0, 0));
        return true;
    }
    return false;
}

/**检测字符串是否包含敏感词*/
function cheackSensitiveWord(txt) {
    var isContain = false;

    for (var i = 0; i < SensitiveConfig.length; i++) {
        var index = txt.indexOf(SensitiveConfig[i]);
        if (index != -1) {
            isContain = true;
            break;
        }
    }

    if (isContain) {
        showToast("名字中不能包含敏感词", cc.color(255, 0, 0));
    }

    return isContain;
}

//被整人创建名字标签
function createLoserNameTag(name) {
    var nameTag = createLevelSprite("k_dxj_kuang.png");
    nameTag.anchorY = 0;
    nameTag.setCascadeOpacityEnabled(true);

    var nameTagLabel = new cc.LabelTTF(name && name != null && name != "" ? name : _curLoserName, "", 18);
    nameTagLabel.attr({
        x: nameTag.width / 2,
        y: nameTag.height / 2 + 7,
        color: cc.color(52, 8, 7)
    });
    nameTag.addChild(nameTagLabel);

    var labelSize = nameTag.width / nameTagLabel.width * 16;
    labelSize = labelSize > 40 ? 40 : labelSize;
    nameTagLabel.fontSize = labelSize;

    return nameTag;
}

/**
 * 创建指定精灵的名字标签
 * @param target 当前层，一般用this 或 _this
 * @param sprite 指定的精灵
 * @param xLimit 从精灵x轴的锚点x坐标到标签向右的偏移量
 * @param yOffset 从精灵上边距到标签向上的偏移量
 * @param name 名字，为空或不填则默认为Loser的名字
 * @param scale 缩放比例，默认为1
 */
function createNameTagAndUpdate(target, sprite, xOffset, yOffset, name, scale) {
    if (!yOffset) yOffset = 0;
    if (!xOffset) xOffset = 0;
    if (!scale) scale = 0.8;
    var tag = createLoserNameTag(name);
    tag.setLocalZOrder(100);
    tag.setScale(scale);
    tag.setScale(sprite.getScale());
    tag.attr({
        x: sprite.getPosition().x + xOffset * sprite.getScale(),
        y: sprite.getPosition().y + (sprite.height * (1 - sprite.getAnchorPoint().y) + yOffset) * sprite.getScale()
    });
    target.addChild(tag);
    target.schedule(onNameTagPositionUpdate, 0.01);
    function onNameTagPositionUpdate() {
        if (sprite && sprite != null) {
            tag.setPosition({
                x: sprite.getPosition().x + xOffset * sprite.getScale(),
                y: sprite.getPosition().y + (sprite.height * (1 - sprite.getAnchorPoint().y) + yOffset ) * sprite.getScale()
            });
            tag.setScale(sprite.getScale() * scale);
            tag.setVisible(sprite.isVisible());
        }
    }
}

/**
 * 创建对话框, 并添加至指定层
 * @param target
 * @param string
 * @param postion
 * @param isLeft
 * @returns {*}
 */
function createChart(target, string, postion, isLeft, fontSize) {
    if (!fontSize) fontSize = 20;
    var chart = createLevelSprite("k_jbthy_box_woman.png");
    chart.setPosition(postion);
    chart.setLocalZOrder(400);
    chart.runAction(cc.sequence(cc.rotateBy(0.2, 4), cc.rotateBy(0.2, -4)).repeatForever());
    target.addChild(chart);
    if (!isLeft) chart.runAction(cc.flipX(true));
    var label = new cc.LabelTTF(string, "", fontSize);
    label.attr({
        x: chart.width / 2,
        y: chart.height / 2,
        color: cc.color(52, 8, 7)
    });
    label.setFontFillColor(cc.color(0, 0, 0));
    chart.addChild(label);

    return chart;
}

/**灵魂飞出
 * @param target    父节点(默认当前场景)
 * @param x         x坐标（默认屏幕中间）
 * @param y         y坐标（默认屏幕中间）
 * @param moveByX   移动X距离（默认100）
 * @param moveByY   移动Y距离（默认150）
 * @param callback  移动完回调
 * @param moveTime  移动时间（默认2秒）
 * @returns {*}
 */
function soulFluttering(target, x, y, moveByX, moveByY, callback, moveTime) {
    if (!target)target = cc.director.getRunningScene();
    var soul = createLevelSprite("k_zxx_guihun.png");
    soul.attr({
        x: x || winCenter().x,
        y: y || winCenter().y
    });
    target.addChild(soul, 10);

    soul.runAction(cc.sequence(
        cc.spawn(
            cc.moveBy(moveTime || 2, cc.p(moveByX || 100, moveByY || 150)),
            cc.fadeOut(moveTime || 2)
        ),
        cc.callFunc(function () {
            if (callback)callback();
        }, target),
        cc.removeSelf()
    ));

    return soul;
}

//调用当前场景失败界面
function showGameOver(faileKey, lossType) {
    var curScene = cc.director.getRunningScene();
    if (curScene.gameOver)curScene.gameOver(faileKey, lossType);
}

//调用当前场景胜利界面
function showGameWin(winWordKey, winType) {
    var curScene = cc.director.getRunningScene();
    if (curScene.gameWin)curScene.gameWin(winWordKey, winType);
}

//延时调用方法
function setDelay(sprite, time, func) {
    sprite.runAction(cc.sequence(cc.delayTime(time), cc.callFunc(func)));
}

//显示礼包 type:1(胜利)、2(失败)
function showPackage(type) {
    if (isHidePurchase == 1)return;
    if (isMobile("Android") && isWeb == 0 && isALLGameWeb != 1) {
        var overCount = _winCount + _faileCount;
        if (type == 2 && showPurchaseHz > 0 && _faileCount > 0 && (_faileCount % showPurchaseHz == 0)) {
            new PurchaseLayer().addToCurScene();
        } else if (showPackageHz > 0 && overCount > 0 && (overCount % showPackageHz == 0)) {
            if (getIsBuyMasterPackage() == 0) {
                new MasterPackageLayer().addToCurScene();
            } else {
                new NovicePackageLayer().addToCurScene();
            }
        }
    }
}

//创建屏蔽触摸层,可以传入时间
function createUnTouchLayer(time) {
    if (time && typeof(time).toLowerCase() != "number")
        time = null;

    var scene = cc.director.getRunningScene();
    var size = cc.director.getWinSize();
    var bg = new cc.LayerColor(cc.color(0, 0, 0, 1), size.width, size.height);
    scene.addChild(bg, 1000);

    bg.runAction(cc.sequence(
        cc.delayTime(time || 0.5),
        cc.removeSelf()
    ));

    var listener1 = cc.EventListener.create({
        event: cc.EventListener.TOUCH_ONE_BY_ONE,
        swallowTouches: true,
        onTouchBegan: function (touch, event) {
            var target = event.getCurrentTarget();

            var locationInNode = target.convertToNodeSpace(touch.getLocation());
            var s = target.getContentSize();
            var rect = cc.rect(0, 0, s.width, s.height);

            if (cc.rectContainsPoint(rect, locationInNode)) {
                return true;
            }
            return false;
        },
        onTouchMoved: function (touch, event) {

        },
        onTouchEnded: function (touch, event) {
        }
    });
    cc.eventManager.addListener(listener1, bg);
}


/**
 * 计算点与点之间的角度
 * @param p1 中心点
 * @param p2
 * @returns {number}
 */
function getPointRotate(p1,p2){
    var p=cc.pSub(p2,p1);
    var angle=Math.atan2(p.x, p.y);
    var radius=angle*180/Math.PI;
    if(p.x<=0){
        radius+=360;
    }
    return radius;
}

/**
 * 根据角度获取偏移坐标
 * @param rotate    角度
 * @param distance  偏移的距离
 */
function getOffsetOfRotate(rotate,distance){
    return cc.p(Math.cos(rotate)*distance,Math.sin(rotate)*distance);
}

/**
 * 创建进度条
 * @param imgName       图片资源名字
 * @param percent       显示百分比
 * @param progressType  进度条类型（0：扇形，1：条形）
 * @param midPoint      设置锚点
 * @param barChangeRate 设置变化
 * @returns {*}
 */
function createProgressBar(imgName,percent,progressType,midPoint,barChangeRate){
    if(!imgName)return null;
    var progressBar=new cc.ProgressTimer(createLevelSprite(imgName));
    progressBar.type=progressType!=0?cc.ProgressTimer.TYPE_BAR:cc.ProgressTimer.TYPE_RADIAL;
    progressBar.midPoint=midPoint || cc.p(0,0);
    progressBar.barChangeRate=barChangeRate || cc.p(0,1);

    //设置进度
    progressBar.setPercentage(percent || 100);

    return progressBar;
}

/**
 * 检查计费点是否显示
 * 用于游戏失败时判断是否显示计费点按钮
 * @param code
 */
function checkCodeIsShow(code){

    var param={
        isShow:false,
        name:"",
        code:""+code
    }

    switch(code){
        case "1001":
            param.isShow=true;
            param.name="2元金币";
            break;
        case "1002":
            param.isShow=true;
            param.name="4元金币";
            break;
        case "1003":
            param.isShow=true;
            param.name="6元金币";
            break;
        case "1004":
            param.isShow=true;
            param.name="7元金币";
            break;
        case "1005":
            param.isShow=true;
            param.name="10元金币";
            break;
        case "1006":
            if(getIsBuyNovicePackage()==0){
                param.isShow=true;
                param.name="新手礼包";
            }
            break;
        case "1007":
            if(getIsBuyMasterPackage()==0){
                param.isShow=true;
                param.name="高手礼包";
            }
            break;
        case "1008":
            if(getIsBuyStrategy()==0){
                param.isShow=true;
                param.name="全套攻略";
            }
            break;
        case "1009":
            param.isShow=true;
            param.name="过关神器";
            break;
        case "1010":
            param.isShow=true;
            param.name="补充金币";
            break;
    }

    return param;
}

function addSwallowTouch(node){
    var listener1 = cc.EventListener.create({
        event: cc.EventListener.TOUCH_ONE_BY_ONE,
        swallowTouches: true,
        onTouchBegan: function (touch, event) {
            var target = event.getCurrentTarget();

            var locationInNode = target.convertToNodeSpace(touch.getLocation());
            var s = target.getContentSize();
            var rect = cc.rect(0, 0, s.width, s.height);

            if (cc.rectContainsPoint(rect, locationInNode)) {
                // cc.log("sprite began... x = " + locationInNode.x + ", y = " + locationInNode.y);
                return true;
            }
            return false;
        },
        onTouchMoved: function (touch, event) {

        },
        onTouchEnded: function (touch, event) {
        }
    });
    cc.eventManager.addListener(listener1, node);
}

function isOpen(key){
    if(!isMobile())return true;

    return CommonPlatform.getInstance().isOpen(key);
}

function showAd(key,fn){

    if(!isMobile()){
        typeof fn=="function"&&fn(["red_dot","史上最坑爹的游戏X","史上最坑爹的游戏X游戏简介"]);
        return;
    }

    cc.log("~~~showAd["+key+"]:需要通关"+getOnlineData("overLevelAd")+"关后显示广告,当前通关数量："+getLevelPassNum()+","+getLevelPassNum()>=getOnlineData("overLevelAd"));

    // if(curLevelObj.curlevel >= getOnlineData("overLevelAd")){
    if(getLevelPassNum()>=(parseInt(getOnlineData("overLevelAd")) || 3)){
        adCallback=fn;
        cc.log("开始展示广告关卡："+ getOnlineData("overLevelAd"));
        CommonPlatform.getInstance().showAd(key,typeof fn=="function");
    }

}

function clickNativeAd(){
    if(!isMobile())return;
    CommonPlatform.getInstance().clickNativeAd()
}

function closeNativeAd(){
    if(!isMobile())return;
    CommonPlatform.getInstance().closeNativeAd();
}

var levelLoseParam={    //单关失败次数
    level:-1,
    count:0
};

function markLevelLoseCount(level){
    if(level<=3 || !isOpen("overPackage"))return;

    if(levelLoseParam.level!=level){
        levelLoseParam.count=0;
        levelLoseParam.level=level;
    }

    levelLoseParam.count++;

    if(levelLoseParam.level<=0)return;

    if(levelLoseParam.count%10==0 && getIsBuyMasterPackage()==0){
        new MasterPackageLayer().addToCurScene();
    }else if(levelLoseParam.count%5==0 && getIsBuyNovicePackage()==0){
        new NovicePackageLayer().addToCurScene();
    }else if(levelLoseParam.count%5==0 && getIsBuyMasterPackage()==0){
        new MasterPackageLayer().addToCurScene();
    }
}

//显示原生广告
function showNativeAdPanel(_frame,data){
    cc.log("-----------------进入展示原生广告方法");
    var ad_bg = createLevelSprite("k6_adBoard");
    _frame.addChild(ad_bg);
    ad_bg.attr({
        x: _frame.width / 2,
        y: -55,
        anchorY: 0
    });
    addTouchCallBack(ad_bg,function(){
        clickNativeAd();
    });

    if(data[0]){
        try{
            cc.loader.loadImg(data[0],function(err,texture){
                if(err)return;
                var icon = createSprite(texture);
                ad_bg.addChild(icon);
                icon.attr({
                    scale: 0.5,
                    x: 63,
                    y: 50
                });
            })
        }catch(e){
            cc.log(e);
        }
    }

    var title = createLabel(data[1], 20, cc.color(62, 65, 67));
    ad_bg.addChild(title);
    title.attr({
        anchorX: 0,
        x: 140,
        y: 62
    });
    var desc = createLabel(data[2], 20, cc.color(62, 65, 67));
    ad_bg.addChild(desc);
    desc.attr({
        anchorX: 0,
        x: 140,
        y: 30
    });
}